#include "stdafx.h"
#include "index.h"
#include "DebugOut.h"

//RXgN^
BufferingStream::BufferingStream(const char* FileName, unsigned int FileSize){
	m_FileName = FileName;
	m_Buffer.reserve(FileSize);
}
//fXgN^
BufferingStream::~BufferingStream(){
	FILE* stream = fopen(m_FileName.c_str(), "w");
	if(stream){
		fprintf(stream, "/-----o͌-----/\n");
		fprintf(stream, "%s", m_Buffer.c_str());
		fclose(stream);
	}
}

//o
void BufferingStream::Out(const Expression& t) const{
	for(unsigned int i=0;i<t.size();i++){
		if(t.at(i).Type==TK_CONST){
			Out("(%d)", t.at(i).Value);
		}
		else{
			Out("(%s)", t.at(i).Text.c_str());
		}
	}
}
//ɏ]o
void __cdecl BufferingStream::Out(LPCSTR fmt, ...) const{
	char buf[65535];
	const int n = wvsprintf(buf, fmt, reinterpret_cast<va_list>(&fmt+1)) - 1;
	if(buf[n]=='\n'){
		buf[n+1] = '\0';
	}
	m_Buffer += buf;
}

	
	
//RXgN^
DialogStream::DialogStream(CDbg* Obj){
	m_Obj = Obj;
}
//o
void DialogStream::Out(const Expression& t) const{
	for(unsigned int i=0;i<t.size();i++){
		if(t.at(i).Type==TK_CONST){
			Out("(%d)", t.at(i).Value);
		}
		else{
			Out("(%s)", t.at(i).Text.c_str());
		}
	}
}
//ɏ]o
void __cdecl DialogStream::Out(LPCSTR fmt, ... ) const{
	char buf[65535];
	const int n = wvsprintf(buf, fmt, reinterpret_cast<va_list>(&fmt+1)) - 1;
	if(buf[n]=='\n'){
		buf[n+1] = '\0';
	}
	m_Obj->Out("%s", buf);
}

	
	
//`^XN̓eo
void PrintDrawTask(const DrawTask& _DrawTask, const ITextStream* Output, const char* Header = ""){
	//֐pNX
	class InnerFunction{
	public:
		static const char* ConvertTextTokenSectionToString(const TextTokenSection& t){
			static string Temp;
			Temp = "";
			for(unsigned int i=0;i<t.size();i++){
				for(unsigned int j=0;j<t.at(i).size();j++){
					Temp += t.at(i).at(j).Text.c_str();
				}
				Temp += "\\n";
			}
			return(Temp.c_str());
		}
	};
	Output->Out("%s<`^XN>\n", Header);
	switch(_DrawTask.Type){
		case(TYPE_NONE):
			Output->Out("%s\tType = TYPE_NONE;\n", Header);
			break;
		case(TYPE_TEXT):
			Output->Out("%s\tType = TYPE_TEXT;\n", Header);
			if(_DrawTask.IsShow){
				Output->Out("%s\tIsShow = True;\n", Header);
			}
			else{
				Output->Out("%s\tIsShow = False;\n", Header);
			}
			Output->Out("%s\t(X, Y, Z, A) = (%d, %d, %d, %d);\n", Header, _DrawTask.x, _DrawTask.y, _DrawTask.z, _DrawTask.a);
			Output->Out("%s\tZZ = %d;\n", Header, _DrawTask.zz);
			Output->Out("%s\tBltType = %d;\n", Header, _DrawTask.BltType);
			Output->Out("%s\tText = %s;\n", Header, InnerFunction::ConvertTextTokenSectionToString(_DrawTask.Text));
			Output->Out("%s\tDegree = %f;\n", Header, _DrawTask.Degree);
			break;
		case(TYPE_GRAPHIC):
			Output->Out("%s\tType = TYPE_GRAPHIC;\n", Header);
			if(_DrawTask.IsShow){
				Output->Out("%s\tIsShow = True;\n", Header);
			}
			else{
				Output->Out("%s\tIsShow = False;\n", Header);
			}
			Output->Out("%s\t(X, Y, Z, A) = (%d, %d, %d, %d);\n", Header, _DrawTask.x, _DrawTask.y, _DrawTask.z, _DrawTask.a);
			Output->Out("%s\tZZ = %d;\n", Header, _DrawTask.zz);
			Output->Out("%s\tBltType = %d;\n", Header, _DrawTask.BltType);
			Output->Out("%s\tFileName = %s;\n", Header, _DrawTask.FileName.c_str());
			Output->Out("%s\tSrcRect = (%d, %d, %d, %d);\n", Header, _DrawTask.SrcRect.left, _DrawTask.SrcRect.top, _DrawTask.SrcRect.right, _DrawTask.SrcRect.bottom);
			Output->Out("%s\tScalingX = %f;\n", Header, _DrawTask.ScalingX);
			Output->Out("%s\tScalingY = %f;\n", Header, _DrawTask.ScalingY);
			Output->Out("%s\tDegree = %f;\n", Header, _DrawTask.Degree);
			break;
		case(TYPE_RECT):
			Output->Out("%s\tType = TYPE_RECT;\n", Header);
			if(_DrawTask.IsShow){
				Output->Out("%s\tIsShow = True;\n", Header);
			}
			else{
				Output->Out("%s\tIsShow = False;\n", Header);
			}
			Output->Out("%s\tZ = %d;\n", Header, _DrawTask.z);
			Output->Out("%s\tA = %d;\n", Header, _DrawTask.a);
			Output->Out("%s\tZZ = %d;\n", Header, _DrawTask.zz);
			Output->Out("%s\tBltType = %d;\n", Header, _DrawTask.BltType);
			Output->Out("%s\tRectPos = (%d, %d, %d, %d);\n", Header, _DrawTask.RectPos.left, _DrawTask.RectPos.top, _DrawTask.RectPos.right, _DrawTask.RectPos.bottom);
			Output->Out("%s\tDegree = %f;\n", Header, _DrawTask.Degree);
			break;
		default:
			WARNING
	};
}

//XvCg̓eo
void PrintSprite(const Sprite& _Sprite, const ITextStream* Output, const char* Header = ""){
	string HeaderForPrintDrawTask = Header;
	HeaderForPrintDrawTask += "\t\t";

	Output->Out("%s<XvCg>\n", Header);
	Output->Out("%s\t<`^XNi\j>\n", Header);
	PrintDrawTask(_Sprite.SpriteTask[GetTMAccessor()->GetDrawTaskIterator()], Output, HeaderForPrintDrawTask.c_str());
	Output->Out("%s\t<`^XNij>\n", Header);
	PrintDrawTask(_Sprite.SpriteTask[1-GetTMAccessor()->GetDrawTaskIterator()], Output, HeaderForPrintDrawTask.c_str());
}

//{^̓eo
void PrintButton(const Button& _Button, const ITextStream* Output, const char* Header = ""){
	string HeaderForPrintSprite = Header;
	HeaderForPrintSprite += "\t\t";

	Output->Out("%s<{^>\n", Header);
	if(_Button.IsEnable){
		Output->Out("%s\tIsEnable = True;\n", Header);
	}
	else{
		Output->Out("%s\tIsEnable = False;\n", Header);
	}
	Output->Out("%s\tClickRect = (%d, %d, %d, %d);\n", Header, _Button.ClickRect.left, _Button.ClickRect.top, _Button.ClickRect.right, _Button.ClickRect.bottom);
	for(unsigned int i=0;i<2;i++){
		for(unsigned int j=0;j<4;j++){
			Output->Out("%s\tSrcRect[%d][%d] = (%d, %d, %d, %d);\n", Header, i, j, _Button.SrcRect[i][j].left, _Button.SrcRect[i][j].top, _Button.SrcRect[i][j].right, _Button.SrcRect[i][j].bottom);
		}
	}
	Output->Out("%s\tDestLabel = %s;\n", Header, _Button.DestLabel.c_str());
	Output->Out("%s\tOnClickSE = %s;\n", Header, _Button.OnClickSE.c_str());
	Output->Out("%s\tOnCursorSE = %s;\n", Header, _Button.OnCursorSE.c_str());
	Output->Out("%s\t<XvCg>\n", Header);
	PrintSprite(_Button.ButtonTask, Output, HeaderForPrintSprite.c_str());
}

//ϐXgo
void PrintVarList(NovelPlayer* Outer, CDbg* DebugDialog){
	static map<string, int> LocalSnap;
	static map<string, int> GlobalSnap;
	static DialogStream VarList(DebugDialog);

	if(LocalSnap!=(*(GETLOCAL()->GetObj())) || GlobalSnap!=(*(GETGLOBAL()->GetObj()))){
		DebugDialog->Clear();
		VarList.Out("<ϐ>");
		GETLOCAL()->Print(&VarList);
		VarList.Out("<Oϐ>");
		GETGLOBAL()->Print(&VarList);
		LocalSnap = (*(GETLOCAL()->GetObj()));
		GlobalSnap = (*(GETGLOBAL()->GetObj()));
	}
}

//߃Xgo
void PrintCmdList(NovelPlayer* Outer){
	static int IteratorSnap = -1;
	static BufferingStream CmdList("CmdList.log", 1024*100);

	if(GETCOMMAND()->GetIterator()!=IteratorSnap){
		if(GETCOMMAND()->GetIterator()>-1){
			CmdList.Out("%4dF", GETCOMMAND()->GetIterator());
			GETCOMMAND()->GetObj()->at(GETCOMMAND()->GetIterator())->Print(&CmdList);
		}
		IteratorSnap = GETCOMMAND()->GetIterator();
	}
}

//`^XNXgo
void PrintDrawTaskList(NovelPlayer* Outer){
	static vector<DrawTask> DrawTaskListSnap;
	static BufferingStream DrawTaskList("DrawTaskList.log", 1024*100);

	if(DrawTaskListSnap!=GETTASK()->GetTaskList()){
		DrawTaskList.Out("<`^XNXg>\n");
		DrawTaskList.Out("\tEffectType = %d;\n", GETTASK()->GetEffectType());
		DrawTaskList.Out("\tUpdateType = %d;\n", GETTASK()->GetUpdateType());
		for(vector<DrawTask>::iterator it=GETTASK()->GetTaskList().begin();it!=GETTASK()->GetTaskList().end();it++){
			PrintDrawTask((*it), &DrawTaskList, "\t");
		}
		DrawTaskListSnap = GETTASK()->GetTaskList();
	}
}

//ʍXVp^[o
void PrintUpdatePattern(){
	static UpdateParam UpdateParamSnap;
	static BufferingStream UpdatePattern("UpdatePattern.log", 1024*100);

	bool IsDifference = false;
	ITMAccessor* TMA = GetTMAccessor();
	if(TMA->GetUpdateParam().Type!=UpdateParamSnap.Type){
		IsDifference = true;
	}
	if(TMA->GetUpdateParam().Time!=UpdateParamSnap.Time){
		IsDifference = true;
	}
	if(TMA->GetUpdateParam().Color!=UpdateParamSnap.Color){
		IsDifference = true;
	}
	for(unsigned int i=0;i<10;i++){
		if(TMA->GetUpdateParam().nArg[i]!=UpdateParamSnap.nArg[i]){
			IsDifference = true;
		}
		if(TMA->GetUpdateParam().strArg[i]!=UpdateParamSnap.strArg[i]){
			IsDifference = true;
		}
	}
	if(IsDifference){
		UpdatePattern.Out("<ʍXVp^[̃p[^>\n");
		UpdatePattern.Out("\tType = %d;\n", TMA->GetUpdateParam().Type);
		UpdatePattern.Out("\tTime = %d;\n", TMA->GetUpdateParam().Time);
		UpdatePattern.Out("\tColor = (%3d, %3d, %3d);\n", GetRValue(TMA->GetUpdateParam().Color), GetGValue(TMA->GetUpdateParam().Color), GetBValue(TMA->GetUpdateParam().Color));
		for(unsigned int i=0;i<10;i++){
			UpdatePattern.Out("\tnArg[%d] = %d;\n", i, TMA->GetUpdateParam().nArg[i]);
		}
		for(unsigned int i=0;i<10;i++){
			UpdatePattern.Out("\tstrArg[%d] = %s;\n", i, TMA->GetUpdateParam().strArg[i].c_str());
		}
		UpdateParamSnap = TMA->GetUpdateParam();
	}
}

//ʌʃp^[o
void PrintEffectPattern(){
	static EffectParam EffectParamSnap;
	static BufferingStream EffectPattern("EffectPattern.log", 1024*100);

	bool IsDifference = false;
	ITMAccessor* TMA = GetTMAccessor();
	if(TMA->GetEffectParam().Type!=EffectParamSnap.Type){
		IsDifference = true;
	}
	if(TMA->GetEffectParam().Time!=EffectParamSnap.Time){
		IsDifference = true;
	}
	if(TMA->GetEffectParam().Color!=EffectParamSnap.Color){
		IsDifference = true;
	}
	for(unsigned int i=0;i<10;i++){
		if(TMA->GetEffectParam().nArg[i]!=EffectParamSnap.nArg[i]){
			IsDifference = true;
		}
		if(TMA->GetEffectParam().strArg[i]!=EffectParamSnap.strArg[i]){
			IsDifference = true;
		}
	}
	if(IsDifference){
		EffectPattern.Out("<ʌʃp^[̃p[^>\n");
		EffectPattern.Out("\tType = %d;\n", TMA->GetEffectParam().Type);
		EffectPattern.Out("\tTime = %d;\n", TMA->GetEffectParam().Time);
		EffectPattern.Out("\tColor = (%3d, %3d, %3d);\n", GetRValue(TMA->GetEffectParam().Color), GetGValue(TMA->GetEffectParam().Color), GetBValue(TMA->GetEffectParam().Color));
		for(unsigned int i=0;i<10;i++){
			EffectPattern.Out("\tnArg[%d] = %d;\n", i, TMA->GetEffectParam().nArg[i]);
		}
		for(unsigned int i=0;i<10;i++){
			EffectPattern.Out("\tstrArg[%d] = %s;\n", i, TMA->GetEffectParam().strArg[i].c_str());
		}
		EffectParamSnap = TMA->GetEffectParam();
	}
}

//ʍXVpꎞϐo
void PrintUpdateTempVar(){
	//֐pNX
	class InnerFunction{
	public:
		static char* DoubleToStr(double Double){
			static char Str[1024];
			sprintf(Str, "%f", Double);
			return(Str);
		}
	};

	static int UpdateI[4];
	static BYTE UpdateBy[4];
	static mystr UpdateS[4];
	static DWORD UpdateDw[4];
	static double UpdateD[4];
	static COLORREF UpdateC[4];
	static BufferingStream UpdateTempVar("UpdateTempVar.log", 1024*100);

	bool IsDifference = false;
	ITMAccessor* TMA = GetTMAccessor();
	for(unsigned int i=0;i<4;i++){
		if(TMA->GetUpdateI(i)!=UpdateI[i]){
			IsDifference = true;
		}
		if(TMA->GetUpdateBy(i)!=UpdateBy[i]){
			IsDifference = true;
		}
		if(TMA->GetUpdateS(i)!=UpdateS[i]){
			IsDifference = true;
		}
		if(TMA->GetUpdateDw(i)!=UpdateDw[i]){
			IsDifference = true;
		}
		if(TMA->GetUpdateD(i)!=UpdateD[i]){
			IsDifference = true;
		}
		if(TMA->GetUpdateC(i)!=UpdateC[i]){
			IsDifference = true;
		}
	}
	if(IsDifference){
		UpdateTempVar.Out("<ʍXVpꎞϐ>\n");
		for(unsigned int i=0;i<4;i++){
			UpdateI[i] = TMA->GetUpdateI(i);
			UpdateTempVar.Out("\tUpdateI[%d] = %d;\n", i, TMA->GetUpdateI(i));
		}
		for(unsigned int i=0;i<4;i++){
			UpdateBy[i] = TMA->GetUpdateBy(i);
			UpdateTempVar.Out("\tUpdateBy[%d] = %d;\n", i, static_cast<int>(TMA->GetUpdateBy(i)));
		}
		for(unsigned int i=0;i<4;i++){
			UpdateS[i] = TMA->GetUpdateS(i);
			UpdateTempVar.Out("\tUpdateS[%d] = %s;\n", i, TMA->GetUpdateS(i).c_str());
		}
		for(unsigned int i=0;i<4;i++){
			UpdateDw[i] = TMA->GetUpdateDw(i);
			UpdateTempVar.Out("\tUpdateDw[%d] = %d;\n", i, TMA->GetUpdateDw(i));
		}
		for(unsigned int i=0;i<4;i++){
			UpdateD[i] = TMA->GetUpdateD(i);
			UpdateTempVar.Out("\tUpdateD[%d] = %s;\n", i, InnerFunction::DoubleToStr(TMA->GetUpdateD(i)));
		}
		for(unsigned int i=0;i<4;i++){
			UpdateC[i] = TMA->GetUpdateC(i);
			UpdateTempVar.Out("\tUpdateC[%d] = (%3d, %3d, %3d);\n", i, GetRValue(TMA->GetUpdateC(i)), GetGValue(TMA->GetUpdateC(i)), GetBValue(TMA->GetUpdateC(i)));
		}
	}
}

//ʌʗpꎞϐo
void PrintEffectTempVar(){
	//֐pNX
	class InnerFunction{
	public:
		static char* DoubleToStr(double Double){
			static char Str[1024];
			sprintf(Str, "%f", Double);
			return(Str);
		}
	};

	static int EffectI[4];
	static BYTE EffectBy[4];
	static mystr EffectS[4];
	static DWORD EffectDw[4];
	static double EffectD[4];
	static COLORREF EffectC[4];
	static BufferingStream EffectTempVar("EffectTempVar.log", 1024*100);

	bool IsDifference = false;
	ITMAccessor* TMA = GetTMAccessor();
	for(unsigned int i=0;i<4;i++){
		if(TMA->GetEffectI(i)!=EffectI[i]){
			IsDifference = true;
		}
		if(TMA->GetEffectBy(i)!=EffectBy[i]){
			IsDifference = true;
		}
		if(TMA->GetEffectS(i)!=EffectS[i]){
			IsDifference = true;
		}
		if(TMA->GetEffectDw(i)!=EffectDw[i]){
			IsDifference = true;
		}
		if(TMA->GetEffectD(i)!=EffectD[i]){
			IsDifference = true;
		}
		if(TMA->GetEffectC(i)!=EffectC[i]){
			IsDifference = true;
		}
	}
	if(IsDifference){
		EffectTempVar.Out("<ʌʗpꎞϐ>\n");
		for(unsigned int i=0;i<4;i++){
			EffectI[i] = TMA->GetEffectI(i);
			EffectTempVar.Out("\tEffectI[%d] = %d;\n", i, TMA->GetEffectI(i));
		}
		for(unsigned int i=0;i<4;i++){
			EffectBy[i] = TMA->GetEffectBy(i);
			EffectTempVar.Out("\tEffectBy[%d] = %d;\n", i, static_cast<int>(TMA->GetEffectBy(i)));
		}
		for(unsigned int i=0;i<4;i++){
			EffectS[i] = TMA->GetEffectS(i);
			EffectTempVar.Out("\tEffectS[%d] = %s;\n", i, TMA->GetEffectS(i).c_str());
		}
		for(unsigned int i=0;i<4;i++){
			EffectDw[i] = TMA->GetEffectDw(i);
			EffectTempVar.Out("\tEffectDw[%d] = %d;\n", i, TMA->GetEffectDw(i));
		}
		for(unsigned int i=0;i<4;i++){
			EffectD[i] = TMA->GetEffectD(i);
			EffectTempVar.Out("\tEffectD[%d] = %s;\n", i, InnerFunction::DoubleToStr(TMA->GetEffectD(i)));
		}
		for(unsigned int i=0;i<4;i++){
			EffectC[i] = TMA->GetEffectC(i);
			EffectTempVar.Out("\tEffectC[%d] = (%3d, %3d, %3d);\n", i, GetRValue(TMA->GetEffectC(i)), GetGValue(TMA->GetEffectC(i)), GetBValue(TMA->GetEffectC(i)));
		}
	}
}

//fobOp
void DebugOut(NovelPlayer* Player, CDbg* DebugDialog){
	SetTMAccessor(Player);

	PrintCmdList(Player);
	PrintEffectPattern();
	PrintEffectTempVar();
	PrintUpdatePattern();
	PrintUpdateTempVar();
	PrintDrawTaskList(Player);
	PrintVarList(Player, DebugDialog);
}