#include "stdafx.h"
#include "index.h"
#include "ScriptPlayer.h"

static BaseIOStream s_Stream;

//ftHgRXgN^
ScriptPlayerApp::ScriptPlayerApp(){
	LoadPlugin();
}
//fXgN^
ScriptPlayerApp::~ScriptPlayerApp(){
	SaveSettingsToFile(m_ScriptPlayer.getObj(), &s_Stream);
	FreeCommand(m_ScriptPlayer.getObj());
	FreePlugin();
}

//͊֘A
CFixMouse* ScriptPlayerApp::GetMouse(){
	return(&m_Mouse);
}
//OtBbN֘A
CFastDraw* ScriptPlayerApp::GetDraw(){
	return(m_PlaneFactory.GetDraw());
}

//I
void ScriptPlayerApp::Close(){
	GetMyApp()->Close();
}
//ImF
LRESULT ScriptPlayerApp::OnPreClose(){
	if(MessageBox(GetMyApp()->GetHWnd(), "I܂H", "mF", MB_YESNO)==IDYES){
		return(0);
	}
	return(1);
}

//CXbh
void ScriptPlayerApp::MainThread(){
#ifdef _DEBUG
	//ϐĎp
	static CDbg VarChk;
#endif

	//fXNgbvR|WV𖳌
	HMODULE hLibrary = LoadLibrary("Dwmapi.dll");
	if(hLibrary){
		HRESULT (WINAPI *DWMDisableFunc)(UINT) = 
			reinterpret_cast<HRESULT (WINAPI *)(UINT)>(GetProcAddress(hLibrary, "DwmEnableComposition"));
		if(DWMDisableFunc){
			DWMDisableFunc(0);
		}
		FreeLibrary(hLibrary);
	}

	//mxGW𐶐
	m_ScriptPlayer.Add(new NovelPlayerfY(new FileTextStream, new InputManagerfY, new SoundManagerfY, new DrawManagerfY, IT_ALLOW_ALL));
	LoadSettingsFromFile(m_ScriptPlayer.getObj(), &s_Stream);

	//eLXgEChE\
	m_ScriptPlayer->GetDraw()->SetTextWindowShow(false);

	//
	if(!m_ScriptPlayer->LoadScript(FILE_SCRIPT, &s_Stream)){
		MessageBox(GetMyApp()->GetHWnd(), FILE_SCRIPT"̓ǂݍ݂Ɏs܂I", "G[I", MB_OK | MB_ICONWARNING);
		GetMyApp()->Close();
	}

	//CAvݒ
	SetMainApp(true);

	//C[v
	while(IsThreadValid()){

		//XNvgs
		m_ScriptPlayer->Run();

#ifdef _DEBUG
		//fobOp
		DebugOut(m_ScriptPlayer.getObj(), &VarChk);
#endif

		//XNvg~ɂ͋I
		if(m_ScriptPlayer->GetState()==ST_SUSPEND){
			MessageBox(GetMyApp()->GetHWnd(), "mxGW̓삪~܂I", "I", MB_OK | MB_ICONWARNING);
			GetMyApp()->Close();
		}

	}

}



//CEChENX
class CAppMainWindow : public CAppBase{
public:

	//ftHgRXgN^
	CAppMainWindow(){
		m_App = NULL;
	}

protected:

	//CXbh
	void MainThread(){
		m_App = new ScriptPlayerApp;
		m_App->Start();
		DELETE_SAFE(m_App);
	}

	//EChE̐
	LRESULT OnPreCreate(CWindowOption &opt){
		opt.caption	= APP_TITLE;
		opt.size_x	= SCREEN_WIDTH;
		opt.size_y	= SCREEN_HEIGHT;
		return(0);
	}

	//EChẺ̎
	LRESULT OnPreClose(){
		if(m_App){
			return(m_App->OnPreClose());
		}
		else{
			return(0);
		}
	}

	//AvP[VNX
	ScriptPlayerApp* m_App;
private:
	CAppMainWindow(const CAppMainWindow&);					//Rs[RXgN^i֎~j
	CAppMainWindow& operator =(const CAppMainWindow&);		//Zqi֎~j
};



//Gg[|Cg
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow){

	//XNvgt@C`FbN
	if(!FindScriptFile(&s_Stream, FILE_SCRIPT)){
		MessageBox(NULL, FILE_SCRIPT"̓ǂݍ݂Ɏs܂I", "G[I", MB_OK | MB_ICONWARNING);
		return(0);
	}

	CAppInitializer init(hInstance, hPrevInstance, lpCmdLine, nCmdShow);

	CSingleApp SApp;
	if(SApp.IsValid()){
		CThreadManager::CreateThread(new CAppMainWindow());
	}

	return(0);
}