//	yaneApp.h :
//		application thread class
//			programmed by yaneurao	'00/02/25

#ifndef __yaneAppBase_h__
#define __yaneAppBase_h__

#include "../Window/yaneWinHook.h"
#include "../Window/yaneWindow.h"
#include "../Thread/yaneThread.h"
#include "../Timer/yaneIntervalTimer.h"

namespace yaneuraoGameSDK3rd {
namespace AppFrame {

class IAppBase {
/**
	AvP[VNX̃C^[tF[X
*/
public:
	virtual bool	IsThreadValid()=0;
	virtual void	InvalidateThread()=0;
	//	CAppBasełCThread::InvalidateThread()̌Ăяoɉ

	virtual IWindow* GetMyWindow()=0;
	virtual HWND	GetHWnd() const=0;
	virtual LRESULT	Run()=0;
	virtual void	Close()=0;
	virtual IIntervalTimer* GetIntervalTimer()=0;

////////////////////////////////////////////////////////////////
//	mainƂsubƂTÔiZXȂ̂
//	̃\bh͔p~̕ŁDD

	///		gȁH
///	static	IAppBase* GetMainApp()	 { return m_lpMainApp; }
	/// CAvւ̃|C^Ԃ

///	static	HWND	GetMainWnd()	 { return GetMainApp()->GetHWnd(); }
	/// CAvۗ̕LEBhDnhԂ

	virtual bool	IsMainApp() const =0;
	virtual void	SetMainApp(bool b) =0;

	///	[J[Xbh̎擾
	virtual IThread* GetWorkerThread()=0;

////////////////////////////////////////////////////////////////

	virtual ~IAppBase(){}

protected:
	//	static IAppBase* m_lpMainApp;
	//	CEBhDȉIvOIƂ݂Ȃj
};

class CAppBase : public IWinHook,public IAppBase , public CThread {
/**
	AvP[VNX

	AvP[V́AhƗǂB

	Ȃ킿ACAppBase Ƃ Xbh + CWindow + bZ[W|v

	̃NX̃CX^X𕡐쐬邱ƂɂāA
	}`EBhDłB

	@EBhDƂ̏Lqɂ

	WM_CLOSEĂяoƁAOnPreCloseĂяo܂B
	ꂪ0Ԃ΁AWM_CLOSE͏܂B
	iEBhD͕܂j
	āÂƂɂ̃EBhD邩ǂ[U[
	₢킹悤ȏāA邱Ƃm肵A
	IAppBase::CloseĂяo܂B΁AEBhD͕܂B

*/
public:

	virtual LRESULT Run();
	/**
@	̊֐ĂяoƂɂđA
	[J[Xbh(virtual void MainThread()s)𐶐܂B
	̂҂Ă琧Ԃ܂B

	̊֐ĂяoCreateThreadŒڃXbhNĂ܂܂B
	̏ꍇ́A̐҂ɐԂ܂
	*/

	virtual HWND	GetHWnd() const { return m_oWindow.GetHWnd(); }
	///	EBhDnh擾

	virtual IWindow* GetMyWindow() { return &m_oWindow; }
	///	EBhDNX擾

	bool	IsMainApp() const { return m_bMainApp; }
	void	SetMainApp(bool b){ m_bMainApp = b; }
	/**
		CAppBaseCAvł邩ݒ肷
		defaultfalse
		trueɂĂ΁ÃAvIƂ
		̃Xbhׂinvalidatei悤WM_QUIT𔭍sj
	*/

	bool	IsMessage() const { return m_bMessage; }
	///	bZ[W[vXbh͐Ă邩

	///	Xbh̐`FbN overriden from CThread
	virtual bool	IsThreadValid();
	///	ˁ@̂ȂɃbZ[W[vƗǂ

	///	XbhInvalidateB
	virtual void	InvalidateThread();	//	overriden from CThread
	/**
		Xbĥ𖳌ɂBIdle[hœ삵ĂXbh́A
		WindowbZ[WȂA܂܂Ȃ̂ŁAꍇɂ́A
		IWM_CLOSE𑗂ĂKvB
		̊֐́ABƂ΁ACDebugWindoẃA
		ʏAIdle[hœ삵ĂB
	*/

	///	EBhDŏɑҋ@邩
	volatile bool*	GetWaitIfMinimized() {	return &m_bWaitIfMinimized; }
	/**
		IsThreadValidĂяoɁAEBhDŏĂ΂̂܂
		ҋ@邩HbooltO擾B
			gpၨ@ *GetWaitIfMinimized( ) = true;
	*/

	///	Idle[h(default:false)ɂ̂
	bool* GetIdle() { return &m_bIdle;}
	/**
		tÕ|C^Ԃ̂ŁAIdle[hɂɂ́A
		*GetIdle( ) = true;̂悤ɂB
		Idle[hɂƁAIsThreadValidWindowbZ[WƂɁA
		WindowbZ[W݂ȂƂ́ÃXbh͖܂܂ɂȂB
		ibotp[HȂj
		Idle[hɂȂĂXbhEɂ́A
		̃NXInvalidateThreadĂяoƁB
	*/

	///	OnPreCloseɋIWM_CLOSEs
	virtual void	Close();

	///	[J[Xbh̎擾
	virtual IThread* GetWorkerThread()
		{ return this; }
	/**
		̃t[[Nɂ́AbZ[W|v݂͑
		[J[Xbĥ݂ŁACAppBasêA
		CThread̔hNXȂ̂ŁÂ܂ܕԂĂΗǂB
	*/

	CAppBase();
	virtual ~CAppBase();

protected:
	//////////////////////////////////////////////////////////////////////////
	///	pƂƂ邩i΁j֐̈ꗗ

	///	ꂪsXbhȂ̂ŌpāApӂĂˁI
	///	EBhD쐬(OnCreate()̂)ɌĂяóB
	virtual void MainThread() {
		while (IsThreadValid())
			IThread::getThread()->sleep(20);
			//@Ă΃XbhC^vgɑ΂鉞
	}

	//	̑KXI[o[ChĂ˂
	virtual LRESULT OnInit()	{ return 0; }		///	
	virtual LRESULT OnPreCreate(CWindowOption& opt);///	EBhD쐬O
	virtual LRESULT OnCreate()	{ return 0; }		///	EBhD쐬
	virtual LRESULT OnDestroy() { return 0; }		///	IO

	virtual LRESULT OnPreClose() { return 0; }
	///	WM_CLOSEOɌĂяoA0ԂWM_CLOSE͎sȂ
	///	̏󋵉ɂăEBhDCLOSE邽߂ɂ́ACloseĂяo

	///	brief Window Message to override
	virtual void OnPaint()		{ }

	IIntervalTimer*	GetIntervalTimer();
	/**
		C^[o^C}̎擾
		IsThreadValidĂяoƂɁÃR[obN
	*/

	//////////////////////////////////////////////////////////////////////////
protected:
	CWindow m_oWindow;			//	ۗLĂwindow
	bool	m_bMessage;			//	bZ[W[vXbh͐Ă邩

	virtual void	ThreadProc();					//	override from CThread
	virtual LRESULT WndProc(HWND,UINT,WPARAM,LPARAM);	//	override in CWinHook
	void	InnerStopThread();

	volatile bool	m_bWaitIfMinimized;		//	EBhDŏɑҋ@邩

	bool	m_bClose;			//	OnPreCloseĂ΂WM_CLOSE邩H
	bool	m_bIdle;			//	Idle[h
	HACCEL	m_hAccel;			//	ANZ[^

	CIntervalTimer	m_vIntervalTimer;
	volatile bool m_bMainApp;		//	CAvȂ̂

private:
	static	DWORD WINAPI RunPrepare(LPVOID lpVoid); //	RuñWv
	LRESULT RunThread();						//	EBhD̍쐬WorkThread̍쐬MessageLoop
	LRESULT MessagePump(bool bPeek=true);			//	MessagePomp
	//	bPeek==trueȂPeekāAbZ[WȂ܂ŏ
	//	bPeek==falseȂ΁AbZ[WЂƂł܂ł̊֐甲Ȃ

	volatile LONG	m_nThreadStatus;				//	Xbh̃Xe[^X
};

} // end of namespace AppFrame
} // end of namespace yaneuraoGameSDK3rd

#endif
