//	yaneAppFrame.h :
//			programmed by yaneurao	'00/06/16

#ifndef __yaneAppFrame_h__
#define __yaneAppFrame_h__

#include "yaneAppBase.h"
#include "yaneAppManager.h"

namespace yaneuraoGameSDK3rd {
namespace AppFrame {

class IAppFrame {
public:
	virtual void	Start()=0;
	virtual void	MesSleep(int nTime)=0;
	virtual void	InvalidateThread()=0;
	virtual IAppBase* GetMyApp()const=0;
	virtual bool	IsThreadValid()const=0;
	virtual void	MainThread() = 0;
	virtual bool	IsMainApp() const =0;
	virtual void	SetMainApp(bool b) =0;

	//	RXgN^`fXgN^ŁACAppManagerɓo^Ă
	IAppFrame();
	virtual ~IAppFrame();
};

class CAppFrame : public IAppFrame {
/**
	AvP[V̒jƂȂNXłB

	AvP[VƂ́AAvP[VNX(class CAppBase̔hNX)
	̂ƂłBAvP[VNX́A̃EBhD
	̃Xbh[vAP̕`NXۗL܂B

	̃[J[XbĥȂĂяôCAppFrameƂ킯łB

	gF

	[U[́ACAppFramehAɃoƂĎ̎g
	R|[lgoƂĎ܂B

	virtual void MainThread() = 0;
	̊֐I[o[ChāAStarto֐ĂяoĂB
	΁AÅ֐s܂B

	̃NX̊NXłAclass IAppFrame ̃RXgN^
	CAppManagerɓo^Ă̂ŁAXbhȂ΂ǂł
	CAppManager::GetMyFrameŎ擾邱Ƃo܂B
	KvɉāA_ELXgĎgƗǂł傤B

*/
public:
	///	Xbh̐
	virtual bool IsThreadValid()const { return GetMyApp()->IsThreadValid(); }
	/**
		MainThread̂Ȃł́Å֐true̊ԁA܂葱悤ɂ܂B
		iAꂪtruełĂIɔĂ\܂j
	*/

	///	Xbh̖
	virtual void	InvalidateThread() { GetMyApp()->InvalidateThread(); }
	/**
		̊֐sƁAIsThreadValidfalseԂ悤ɂȂ܂B
		CAppManager::GetMyFrameƗ߂āAO炱̃t[Xbh
		~vôɎgƕ֗łB
	*/

	///	ĂяõAvNX̎擾
	virtual IAppBase* GetMyApp()const { return m_lpMyApp; }
	/**
		̊֐ĂяoƂŁȂAvP[VNX
		擾o܂BiقƂǎgKv͂Ȃ͂łj
	*/

	virtual void	Start();
	/**
		̃NXł̎sɍۂẮAMainThreadI[o[ChĂ
		̃\bhĂяoĂBΏsȂꂽ
		MainThreadĂяo܂B
	*/

	virtual void	MesSleep(int nTime);
	/**
		WindowsbZ[WȂƁA
		IntervalTimerł̃R[obNȂ̂ŁA
		WindowMessagesȂȂSleep֐łB
		nTime[ms]̊ԁASleep܂B
		܂AȂƂAnTime[ms]͌o߂܂ł́Å֐甲܂B
		class CVolumeFaderŃtF[hƂȂǂɌĂяo
		ʓIm܂B
	*/

	virtual void	SetMainApp(bool b) { GetMyApp()->SetMainApp(b); }
	virtual bool	IsMainApp() const { return GetMyApp()->IsMainApp(); }
	/**
		CAvł邩ݒ^擾
		idefault : falsej

		CAvɐݒ肵Ă΂CAppFramehNX
		IƂɁAIɑCAppBasehNX̃CX^X
		IB
	*/

private:
	IAppBase* m_lpMyApp;
};

} // end of namespace AppFrame
} // end of namespace yaneuraoGameSDK3rd

#endif
