//	yaneAppManager.h :
//		application management class
//			programmed by yaneurao	 '00/03/03
//			reprogrammed by yaneurao '02/03/16

#ifndef __yaneAppManager_h__
#define __yaneAppManager_h__

#include "../thread/yaneCriticalSection.h"

namespace yaneuraoGameSDK3rd {
namespace Window {
	class IWinHook;
	class IWindow;
}
}

namespace yaneuraoGameSDK3rd {
namespace AppFrame {

class IAppDraw;
class IAppBase;
class IAppFrame;

class CAppManager {
protected:
	struct CAppManageInfo {
		IAppBase*		m_lpAppBase;		//	ЂƂ̃AvNX
		IAppFrame*		m_lpAppFrame;		//	̃t[NX
		IAppDraw*		m_lpAppDraw;		//	ЂƂ̕`NX
		DWORD			m_dwThreadID;		//	CXbhThreadID
	};
	typedef smart_vector_ptr<CAppManageInfo> CAppManageList;
	CAppManageList m_alpInfo;

	//	IɃR[obNvĂ郊Xg(CDbgŎgp)
	//	ɓo^Ă΁AstaticCAppBasẽCX^X
	//	łĂ(~CAppBaseĂяoĂȂ{
	//	ÎƂɎQƐ͂)Ae
	typedef smart_vector_ptr<function_callback> CAppCallBackList;
	CAppCallBackList m_alpCallBack;

public:
	static	void	Add(IAppBase*p){  GetObj()->_Add(p); }
	static	void	Del(IAppBase*p){  GetObj()->_Del(p); }
	static	void	Add(IAppFrame*p){  GetObj()->_Add(p); }
	static	void	Del(IAppFrame*p){  GetObj()->_Del(p); }
	static	void	Add(IAppDraw*p){  GetObj()->_Add(p); }
	static	void	Del(IAppDraw*p){  GetObj()->_Del(p); }

	//	o^Ă̂擾ł
	static	IAppBase*	 GetMyApp() { return GetObj()->_GetMyApp(); }
	static	IAppFrame*	 GetMyFrame() { return GetObj()->_GetMyFrame(); }
	static	IAppDraw*	 GetMyDraw() { return GetObj()->_GetMyDraw(); }
	static	IWindow*	 GetMyWindow(); // IAppBaseoRŎ擾

	///	 ̑AvXbhۗ̕LĂEBhDɊ֘AtB
	///	iEBhDbZ[WR[obN悤ɂȂj
	static void	Hook(IWinHook*p){ GetObj()->_Hook(p); }
	static void	Unhook(IWinHook*p){ GetObj()->_Unhook(p); }

	///	̑AvXbhۗ̕LEBhDnhԂ
	static HWND	GetHWnd(){ return GetObj()->_GetHWnd(); }

	///	tXN[[hǂԂ
	static bool	IsFullScreen(){ return GetObj()->_IsFullScreen(); }

	static	int		GetAppInstanceNum(){ return GetObj()->_GetAppInstanceNum(); }
	static	void	StopAllThread() { GetObj()->_StopAllThread(); }
	
	static	void Inc(){	GetObj()->_Inc(); }
	//	QƃJEg̃CNg

	static	void Dec(){	GetObj()->_Dec(); }
	//	QƃJEg̃fNg

	static	int GetRef(){ return GetObj()->_GetRef(); }

	static CAppCallBackList* GetCallBackList() { return GetObj()->_GetCallBackList(); }
	static CCriticalSection* GetCriticalSection() { return GetObj()->_GetCriticalSection(); }

	//	publicɂƂȂsingletonCheckInstanceŐłȂ
	CAppManager():m_nRef(0) {}

protected:
	static singleton <CAppManager> m_obj;
	static CAppManager* GetObj() { return m_obj.get(); }

	///	singletonoRŃANZXsȂ߁Astaticȃo[WKv
	void	_Add(IAppBase*);
	void	_Del(IAppBase*);
	void	_Add(IAppFrame*);
	void	_Del(IAppFrame*);
	void	_Add(IAppDraw*);
	void	_Del(IAppDraw*);
	IAppBase*	 _GetMyApp();
	IAppFrame*	 _GetMyFrame();
	IAppDraw*	 _GetMyDraw();
	void	_Hook(IWinHook*p);
	void	_Unhook(IWinHook*p);
	HWND	_GetHWnd();
	bool	_IsFullScreen();
	int		_GetAppInstanceNum();
	void	_StopAllThread();
	void _Inc();
	void _Dec();
	int _GetRef();
	CAppCallBackList* _GetCallBackList() { return& m_alpCallBack; }
	CCriticalSection* _GetCriticalSection() { return& m_oCriticalSection; }

private:
	CCriticalSection m_oCriticalSection;
	int m_nRef;	//	QƃJEg
};

} // end of namespace AppFrame
} // end of namespace yaneuraoGameSDK3rd

#endif
