
#include "stdafx.h"
#include "yaneLoadCache.h"

//////////////////////////////////////////////////////////////////////////////
//	CIDObjectManager

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

void	CIDObjectManager::clear()
	{
		GetObject()->clear();
	}

LRESULT	CIDObjectManager::erase(int nID)
		///	w肵ID̂̂폜
		///	Rei݂A폜łƂ́A0Ԃ
	{
		return !GetObject()->erase(nID);
	}

void	CIDObjectManager::setObject(int nID,const smart_obj& object) {
		///	IDɑΉIuWFNgݒ肷

		//	ID݂̂̂Ȃ̂ȂΑ}
		CIDObject::iterator it;
		it = GetObject()->find(nID);
		if (it==GetObject()->end()){
			//	key݂͑Ȃ
			//	قȁA}[
			GetObject()->insert(pair<int,smart_obj>(nID,object));
		} else {
			//	ǉǉǉ`(ށ)o@Ă̓XCJ`(ށ)o
			it->second = object;
		}
	}

LRESULT CIDObjectManager::getObject(int nID,smart_obj& object) {
		///	w肵IDɑΉIuWFNg擾
		CIDObject::iterator it;
		it = GetObject()->find(nID);
		if (it==GetObject()->end()){
			//	key݂͑Ȃ
			return 1;
		}
		object = it->second;
		return 0;
	}

//////////////////////////////////////////////////////////////////////////////

CLoadCache::CLoadCache() :
	m_bCanReloadAgain(true),
	m_pLoadCacheListener(new CDefaultLoadCacheListener),
	m_pCacheStaleListener(new CDefaultCacheStaleListener),
	m_vCacheManager(new CCacheManager)
{}

CLoadCache::~CLoadCache(){
	ReleaseAll();
}

LRESULT		CLoadCache::Load(int nNo){

	//	XioRĔԍu()
	GetLoadCacheListener()->OnLoad(nNo);

	LRESULT lr = GetCacheManager()->ReferToObject(GetIDObjectAndNumber(nNo));
	//	QƂ܂I

	if (lr==0){
		//	ɓǂݍǂŁ[
		return 0;
	}

	smart_obj obj;
	if (GetIDObjectManager()->getObject(nNo,obj)!=0){
		//	ȃoii
		//	ꂨB^COoĂ炢DD
		return 1;
	}
	//	obj́Asmart_ptr<CLoadCacheInfo>̃nY
	//	smart_ptr<CLoadCacheInfo>* pInfo = obj.get();

	while(GetCacheStaleListener()->isFull()){

		CIDObjectAndNumber on;
		if (GetCacheManager()->releaseLast(on))
			break; // ׂIuWFNg瑶݂Ȃ

		smart_obj obj;
		if (on.pIDObject->getObject(on.nNum,obj)!=0){
			//	ꂨB^COoĂ炢DD
			return 1;
		}

//		pInfo = obj.get();
//		GetCacheStaleListener()->OnRelease((*pInfo)->pObj); // XǐĂяo
		GetCacheStaleListener()->OnRelease(obj); // XǐĂяo
		on.pIDObject->erase(on.nNum); // ̃IuWFNg폜
	}
	//	[XĂAǂݍ܂ȂƁA
	//	ǂݍ񂾂ƂɃLbVɓȂƉꂽ
	//	sȃT[tF[XoĂ܂B
	//	LbVɂsT[tF[Xɑ΂`FbN
	//	𗘗pvOɂĂ͂Ȃ

	lr = InnerLoad(obj);
	if (lr!=0) return lr;

	GetCacheStaleListener()->OnLoad(obj);
	//	Xiɓǂݍ񂾂Ƃʒm

	return 0;
}

LRESULT		CLoadCache::Release(int nNo){
	GetIDObjectManager()->erase(nNo);
	return GetCacheManager()->release(GetIDObjectAndNumber(nNo));
}

LRESULT		CLoadCache::ReleaseAll(){
	CIDObjectManager* p = GetIDObjectManager();
	p->clear();
//	return GetCacheManager()->releaseAll();

	//	CLoadCacheێĂIuWFNgwĂ}bvNAĂ

	CCacheManager::listchainmap::iterator it = GetCacheManager()->GetMap()->begin();
	while(it!=GetCacheManager()->GetMap()->end()){
		/*
			it	: CCacheManager::listchainmap::iterator
			*it : CCacheManager::listchainmap
				==	fast_list<CIDObjectAndNumber>::listchainmap
				==	map<CIDObjectAndNumber,listchain::iterator>
			(*it).second : fast_list<CIDObjectAndNumber>::listchain::iterator
			*((*it).second) : fast_list<CIDObjectAndNumber>::listchain
		*/
		if ((*((*it).second)).pIDObject == p) {

			GetCacheManager()->GetList()->erase((*it).second);
	//		it = GetCacheManager()->GetMap()->erase(it);
	//	AzReiɑvf̐擪witeratorԂ̂
	//	W̊gȂ̂ŁA̋@\gpĂ͂Ȃ

			GetCacheManager()->GetMap()->erase(it++);
			//	okBڂEffectiveSTL 9QƂ̂ƁB

		} else {
			it ++;
		}
	}

	return 0;
}

///	SetŐݒ肵At@CXg̗vfԂ܂B
int		CLoadCache::GetSize() const
{
	CLoadCache* pThis = const_cast<CLoadCache*> (this);
	return pThis->GetCacheManager()->GetMap()->size();
}

LRESULT	CLoadCache::GetObj(int nNo,smart_obj& obj){
	if (GetIDObjectManager()->getObject(nNo,obj)!=0){
		//	ȃoii
		//	ꂨB^COoĂ炢DD
		return 1;
	}
	return 0;
}

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd
