#include "stdafx.h"
#include "yaneShell.h"
#include "yaneFile.h"
#include "../AppFrame/yaneAppInitializer.h"

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

LRESULT	CShell::Execute(const string& strExeName,bool bWait){
	//@t@Cs
	CHAR buf[512];
	::lstrcpy(buf,strExeName.c_str());

	STARTUPINFO startupInfo = { 0 } ;
	PROCESS_INFORMATION ProcessInfo;
	
	if (!::CreateProcess(NULL,buf,NULL,NULL,FALSE,
		CREATE_NO_WINDOW,NULL,NULL,&startupInfo,&ProcessInfo))
		//	CREATE_NO_WINDOẂAMS-DOSȂIvV
		//	iWo͂ÊŁj
		return 1;	// unable open..

	if (bWait){
		::WaitForSingleObject(ProcessInfo.hProcess ,INFINITE);
	}

	return 0;
}

LRESULT	CShell::OpenFolder(const string& strPathName){
	//	tH_explorerŊJ

	CHAR buf[512];
	::lstrcpy(buf,"explorer ");
	::lstrcat(buf,strPathName.c_str());

	STARTUPINFO startupInfo = { 0 };
	PROCESS_INFORMATION ProcessInfo;

	if (!::CreateProcess(NULL,buf,NULL,NULL,FALSE,
		0,NULL,NULL,&startupInfo,&ProcessInfo))
		return 1;	// unable open..

	return 0;
}

LRESULT CShell::CopyAndSetWallPaper(const string& strFileName){
	CFile file;
	if (file.Read(strFileName)!=0) return 1;

	//	VXetH_ɃRs[
	string name;
	name =	CFile::GetWindowsDir() + file.GetPureFileName();
	if (file.WriteBack(name)!=0) return 1;
	return SetWallPaper(name);
}

LRESULT CShell::SetWallPaper(const string& strFileName){
	//	ǎݒ肷

	//	ANeBufXNgbv̂߂ɁAWXgύXȂ΂ȂȂ

//	HKEY_CURRENT_USER/Desktop/WindowMetrics/WallPaper
//										   /WallpaperStyle/0
//	̃ZNV݂̗̑Lׂ͒ȂĂ͂ȂȂ

	return ::SystemParametersInfo(
		SPI_SETDESKWALLPAPER,		//	ǎ̕ύX
		0,
		(void*)strFileName.c_str(),
		SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE
		//	ύX͒ʒmق낤..
	)?0:1;

}

string	CShell::getModuleName() const {
	CHAR szFileName[_MAX_PATH];
	::GetModuleFileName(CAppInitializer::GetInstance(),szFileName,_MAX_PATH);
	return string(szFileName);
}

string	CShell::getModuleMutexName() const {
	//	NExeAdNh~MutexƂ
	CHAR szFileName[_MAX_PATH];
	::GetModuleFileName(CAppInitializer::GetInstance(),szFileName,_MAX_PATH);
	//	Mutexɂ\͎gȂ̂+ɒu
	for(int i=0;i<_MAX_PATH;i++){
		if (szFileName[i]=='\\') szFileName[i] = '?';
		// ? Mutexɂ͎g邪t@Cɂ͏oȂ̂łnj
		else if (szFileName[i]=='\0') break;
	}
	return string(szFileName);
}

//////////////////////////////////////////////////////////////////////////////
//	CFolderDialog
//////////////////////////////////////////////////////////////////////////////

//#include <direct.h>
//#include <shellapi.h>

//	tH_I_CAŐN
LRESULT CFolderDialog::GetOpenFolderName(string& Buffer,
		const string& DefaultFolder,const string& Title)
{
	BROWSEINFO bi = { NULL };
//	bi.hwndOwner = NULL;

	//	R[obN֐w
	bi.lpfn	  = &CFolderDialog::SHBrowseProc;
	//	ftHgőIĂtH_w
	bi.lParam = (LPARAM)DefaultFolder.c_str();
	//	^Cg̎w
	bi.lpszTitle = Title.c_str();	//"tH_IĂ";

	//	tH__CAŐN
	ITEMIDLIST* pidl = ::SHBrowseForFolder( &bi );
	if( pidl )
	{
		//	IꂽtH_擾
		CHAR szSelectedFolder[MAX_PATH];
		::SHGetPathFromIDList( pidl, szSelectedFolder );
		_SHFree(pidl);
		if( (DWORD)lstrlen(szSelectedFolder) < MAX_PATH ){
			Buffer = szSelectedFolder;
		}else{
		//	Ȃ̕ԂƂ́A(L֥`)ް݁@..
			Buffer.erase();
			return 2; // G[R(`DL)m
		}
		//	tH_Iꂽ
		return 0; // IDOK;
	}
	//	tH_͑IȂ
	return 1; // IDCANCEL;
}

/////////////////////////////////////////////////////////////////////////////
//	SHBrowseForFolder()pR[obN֐

int CALLBACK CFolderDialog::SHBrowseProc(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	if( uMsg == BFFM_INITIALIZED && lpData )
	{
		//	ftHgőIpX̎w
		::SendMessage( hWnd, BFFM_SETSELECTION, TRUE, lpData);
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//	VXemۂITEMIDLISTJȂ΂ȂȂ

void CFolderDialog::_SHFree(ITEMIDLIST* pidl)
{
	IMalloc*  pMalloc;
	::SHGetMalloc( &pMalloc );
	if ( pMalloc )
	{
		pMalloc->Free( pidl );
		pMalloc->Release();
	}
}

/////////////////////////////////////////////////////////////////////////////
//	CFileDialog
/////////////////////////////////////////////////////////////////////////////
}}
#include <Commdlg.h>

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

LRESULT CFileDialog::GetOpenFile(string& strFileName,const string& DefaultFolder
	 ,const string& Title)
{
	
	OPENFILENAME ofn = { sizeof (OPENFILENAME) };
#if (_WIN32_WINNT >= 0x0500)
		ofn.lStructSize = OPENFILENAME_SIZE_VERSION_400;
#endif
	//	Windows95/NT4.0łɂႢ@̎ʎq
	//	WIN32_WINNT̒l0x0500̏ꍇA`ƂȂ
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	ofn.nMaxFile = 1;
	ofn.lpstrTitle = Title.c_str();

	BOOL b = ::GetOpenFileName(&ofn);
	if (!b) {
		return -1; // okȊONbN?
	} else {
		strFileName = ofn.lpstrFile;
		return 0;
	}
}


/////////////////////////////////////////////////////////////////////////////
//	CRegistry
/////////////////////////////////////////////////////////////////////////////
//#include <tchar.h>

CRegistry::CRegistry (const string& strPath, HKEY hkeyRoot) :
		m_strPath (strPath), m_hkeyRoot (hkeyRoot){}

CRegistry::~CRegistry (){}

///

LRESULT CRegistry::CreateFolder (const string& strSection)
{
	HKEY hKey;
	string strTemp;

	if (!strSection.empty ())
	{
		strTemp = string("\\") + strSection;
	}
	DWORD dwDisposition;
	string fullname;
	fullname = m_strPath + strTemp;
	if (::RegCreateKeyEx (
		m_hkeyRoot,
		fullname.c_str(),
		0, "", REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition) !=
		ERROR_SUCCESS)
	{
		return 1;
	}

	::RegCloseKey (hKey);
	return 0;
}

LRESULT CRegistry::DeleteFolder (const string& strSection)
{
	HKEY hKey;

	if (::RegOpenKeyEx (
		m_hkeyRoot, m_strPath.c_str(), 0, KEY_ALL_ACCESS, &hKey) !=
		ERROR_SUCCESS)
	{
		return 1;
	}

	if (::RegDeleteKey (hKey, strSection.c_str()) != ERROR_SUCCESS)
	{
		::RegCloseKey (hKey);
		return 1;
	}

	::RegCloseKey (hKey);
	return 0;
}

LRESULT CRegistry::DeleteKey (const string& strSection,
							   const string& strKey)
{
	HKEY hKey;

	string strTemp;
	if (!strSection.empty ())
	{
		strTemp = string("\\") + strSection;
	}
	string fullname;
	fullname = m_strPath + strTemp;
	if (::RegOpenKeyEx (
		m_hkeyRoot, fullname.c_str() , 0, KEY_WRITE, &hKey) !=
		ERROR_SUCCESS)
	{
		return 1;
	}
	if (::RegDeleteValue (hKey, strKey.c_str()) != ERROR_SUCCESS)
	{
		::RegCloseKey (hKey);
		return 1;
	}

	::RegCloseKey (hKey);
	return 0;
}

///

LRESULT CRegistry::GetValue (const string& strSection,
		const string& strKey, string& strValue)
{
	HKEY  hKey;

	string fullname;
	fullname = m_strPath + '\\' + strSection;
	if (::RegOpenKeyEx (m_hkeyRoot,fullname.c_str() , 0, KEY_READ, &hKey)
		!= ERROR_SUCCESS)
	{
		return 1;
	}

	BYTE pbyBuf [256];
	DWORD dwSize = sizeof(pbyBuf);
	DWORD dwType;
	if (::RegQueryValueEx (hKey, strKey.c_str(), NULL, &dwType, pbyBuf, &dwSize)
		!= ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return 1;
	}

	::RegCloseKey(hKey);

	if  (dwType != REG_SZ){ // f[^^Cv񂶂Ȃ
		return 2;
	}

	strValue = (LPCSTR)&pbyBuf[0];
	return 0;
}

LRESULT CRegistry::GetValue (const string& strSection,
		const string& strKey, DWORD &dwValue)
{
	HKEY  hKey = 0;

	string fullname;
	fullname = m_strPath + '\\' + strSection;
	if (::RegOpenKeyEx (m_hkeyRoot, fullname.c_str() , 0, KEY_READ, &hKey)
		!= ERROR_SUCCESS)
	{
		return 1;
	}

	DWORD dwSize = sizeof(DWORD);
	DWORD dwType;
	if (::RegQueryValueEx (hKey, strKey.c_str(), NULL, &dwType,
		(BYTE*)&dwValue, &dwSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return 1;
	}

	::RegCloseKey(hKey);
	if (dwType!=REG_DWORD) return 2; // ^Ⴄ

	return 0;
}

LRESULT CRegistry::SetValue (const string& strSection,
		const string& strKey, const string& strValue)
{
	HKEY hKey;

	string fullname;
	fullname = m_strPath + '\\' + strSection;
	if (::RegOpenKeyEx (m_hkeyRoot, fullname.c_str(), 0, KEY_WRITE, &hKey)
		!= ERROR_SUCCESS)
	{
		DWORD dwDisposition;
		if (::RegCreateKeyEx (m_hkeyRoot, fullname.c_str(), 0
			, "" , REG_OPTION_NON_VOLATILE,
			  KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition) !=
			  ERROR_SUCCESS)
		{
			 return 1;
		}
	}

	if (::RegSetValueEx (hKey, strKey.c_str(), NULL, REG_SZ,
			(const BYTE*)strValue.c_str(), strValue.size()) !=
				ERROR_SUCCESS)
	{
		::RegCloseKey (hKey);
		return 1;
	}

	::RegCloseKey (hKey);
	return 0;
}

LRESULT CRegistry::SetValue (const string& strSection,
		const string& strKey, DWORD dwValue)
{
	HKEY hKey;

	string fullname;
	fullname = m_strPath + '\\' + strSection;
	if (::RegOpenKeyEx (m_hkeyRoot, fullname.c_str(), 0, KEY_WRITE, &hKey)
		!= ERROR_SUCCESS)
	{
		DWORD dwDisposition;
		if (::RegCreateKeyEx (m_hkeyRoot, fullname.c_str(), 0, "", REG_OPTION_NON_VOLATILE,
			KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition) != ERROR_SUCCESS)
		{
			return 1;
		}
	}

	if (::RegSetValueEx (hKey, strKey.c_str(), NULL, REG_DWORD,
		(BYTE*)&dwValue, sizeof(DWORD)) != ERROR_SUCCESS)
	{
		::RegCloseKey (hKey);
		return 1;
	}

	::RegCloseKey (hKey);
	return 0;
}

///////////////////////////////////////////////////////////////////////////////

//template <class T>
LRESULT CRegistry::SetValue (const string& strSection,
		const string& strKey, BYTE*pData,int nSize)
{
	HKEY hKey;

	string fullname;
	fullname = m_strPath + '\\' + strSection;
	if (::RegOpenKeyEx (m_hkeyRoot, fullname.c_str(), 0, KEY_WRITE, &hKey)
		!= ERROR_SUCCESS)
	{
		DWORD dwDisposition;
		if (::RegCreateKeyEx (m_hkeyRoot, fullname.c_str(), 0, "", REG_OPTION_NON_VOLATILE,
			KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition) != ERROR_SUCCESS)
		{
			return 1;
		}
	}

//	if (obj.isNull()) return -1; // IuWFNgւ񂩂(_G)
	if (::RegSetValueEx (hKey, strKey.c_str(), NULL, REG_BINARY,
		pData /*(BYTE*)obj.get()*/, nSize /*obj.size()*sizeof(BYTE)*/ ) != ERROR_SUCCESS)
	{
		::RegCloseKey (hKey);
		return 1;
	}

	::RegCloseKey (hKey);
	return 0;
}

//template <class T>
LRESULT CRegistry::GetValue (const string& strSection,
		const string& strKey, BYTE *pData,int &nSize)
{
	HKEY  hKey = 0;

	string fullname;
	fullname = m_strPath + '\\' + strSection;
	if (::RegOpenKeyEx (m_hkeyRoot, fullname.c_str() , 0, KEY_READ, &hKey)
		!= ERROR_SUCCESS)
	{
		return 1;
	}

//	DWORD dwSize = obj.size()*sizeof(BYTE);
//	if (obj.isNull()) return -1; // IuWFNgւ񂩂(_G)
	//	ŎOŊmۂĂ񂾂DD
	DWORD dwType;
	if (::RegQueryValueEx (hKey, strKey.c_str(), NULL, &dwType,
		pData/*(BYTE*)obj.get()*/, (DWORD*)&nSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return 2;
	}

	::RegCloseKey(hKey);
	if (dwType!=REG_BINARY) return 3; // ^Ⴄ

	return 0;
}

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd
