#ifndef __yaneStringMap_h__
#define __yaneStringMap_h__


#include "yaneSerialize.h"

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

class IStringMap {
public:
	typedef map<string,string> mymap;

	virtual void	Write(const string& strKey,const string& strData)=0;
	virtual void	Write(const string& strKey,LONGLONG nData)=0;
	virtual void	Append(const string& strKey,const string& strData)=0;
	virtual void	Append(const string& strKey,LONGLONG nData)=0;
	virtual LRESULT	Read(const string& strKey,string& strData)=0;
	virtual LRESULT	Read(const string& strKey,LONGLONG& nData)=0;
	virtual string	GetStr(const string& strKey,const string& strDefault="")=0;
	virtual int		GetNum(const string& strKey,int nDefault=0)=0;
	virtual LONGLONG	GetLongNum(const string& strKey,LONGLONG nDefault=0)=0;
	virtual bool	Delete(const string& strKey)=0;
	virtual void	Clear()=0;
	virtual LRESULT ReadFromConfigFile(const string& strFileName)=0;
	virtual LRESULT WriteToConfigFile(const string& strFileName)=0;
	virtual void	Replace(string& s,bool bCaseSensitive=false)=0;
	virtual mymap* GetMap()=0;

	virtual ~IStringMap(){}
};

//	string to string̘AzL^W
class CStringMap : public IStringMap , public IArchive {
/**
L[ijƃf[^Ƃ̘AzL񋟂܂B
PerlŎg悤ȁAȂłϐ~̂ō܂B
CGIƂƂɕ֗łB

Iɂ́Amap<string , string >ƂĎĂ܂B

class IArchive hNXȂ̂ŁÂ܂܃VACY邱Ƃo܂B
*/
public:

	///	L[ɑ΂f[^̏
	virtual void	Write(const string& strKey,const string& strData);
	virtual void	Write(const string& strKey,LONGLONG nData);
	///		ˁ@̃L[ɑ݂ꍇ́A㏑B

	///	L[ɑ΂f[^̒ǉ
	virtual void	Append(const string& strKey,const string& strData);
	virtual void	Append(const string& strKey,LONGLONG nData);
/**
ˁ@stringo[WiOҁĵق́A񂪉ZBLONGLONGo[Wiҁj̏ꍇ́AWriteƓB
*/

	///	L[ɑ΂f[^̓ǂݏo
	virtual LRESULT	Read(const string& strKey,string& strData);
	virtual LRESULT	Read(const string& strKey,LONGLONG& nData);

	///	L[ɑ΂f[^̒ڎ擾
	///	(̃L[݂ȂƂ́AstrDefault or lDefaultԂ)
	virtual string	GetStr(const string& strKey,const string& strDefault="");
	virtual int		GetNum(const string& strKey,int nDefault=0);
	/**	LONGLONĜ̂iȉ́jÁAƂǂ
			VC++releaseo[WƓRpCG[
			ȂƂB炭ALONGLONG̍œK̃oOB
	*/
	virtual LONGLONG	GetLongNum(const string& strKey,LONGLONG nDefault=0);

	///	L[ɑ΂f[^̍폜
	virtual bool	Delete(const string& strKey);
	///		폜Ƃɂtrue

	///	܂邲ƍ폜
	virtual void	Clear();	//	clear all data..

	///	`t@Cf[^ǂݏoāAi[@\
	///	(VACYƂ͈ႢÂ悤ȃtH[}bg̃t@Cǂݏo)
	/**
		// _uXbVs̓Rg
		#string1 string2 // ̂悤#ŊJnāAPCQȂׂ
		//	̂ƂAXy[XZp[^B
		ƁAstring1AstrKey,string2szDataƂāA
		ۑ(Write)B
		āA`t@Cǂݍ݌AGetStr("string1");̂悤ɂ
		string2擾łƌ킯I(ށ)o
	*/
	virtual LRESULT ReadFromConfigFile(const string& strFileName);

	///	̌`̃t@CƂďoo[W
	virtual LRESULT WriteToConfigFile(const string& strFileName);


	//	f[^܂邲ƕ\(fobOp)
	void	Out(){
		mymap::iterator it;
		printf ("StringMap::Out() \n");
		for(it = GetMap()->begin();it!=GetMap()->end();it++){
			printf("%s => %s\n",(static_cast<string>(it->first).c_str())
							   ,(static_cast<string>(it->second).c_str()));
		}
	}

	///	̘AzLŒu
	virtual void	Replace(string& s,bool bCaseSensitive=false);

	///	AzL̂擾B
	virtual mymap* GetMap() { return& m_vStringMap; }

/*	//	ςAȂ̗pӂAzANZX₱Ȃł߁AA
	//	AzL[̒ڎwIy[^
	const string operator [] (string strKey);
	string operator [] (string strKey);
*/

protected:
	///	override from IArchive
	virtual void Serialize(ISerialize&s);

	mymap m_vStringMap;
};

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd

#endif
