// DirectDraw Wrapper
//

#include "stdafx.h"
#include "yaneDirectDraw.h"

/////////////////////////////////////////////////////////////////////////////
//	DirectDraw(COM) wrapper

namespace yaneuraoGameSDK3rd {
namespace Draw {

CDirectDraw::CDirectDraw(bool bEmulationOnly){
	m_nStatus = 0;
	if (GetDirectDraw()->CreateInstance(CLSID_DirectDraw,IID_IDirectDraw)!=0){
			m_nStatus = 1;
			return ;
	}
	if(GetDirectDraw()->get()==NULL) {
		Err.Out("CDirectDraw::CDirectDrawDirectDrawInterfaceȂ");
		// DirectX3͓Ƃ̂H
		m_nStatus = 2;
		return ;
	}

	if (bEmulationOnly) {
		if (GetDirectDraw()->get()->Initialize((GUID*)DDCREATE_EMULATIONONLY)!=DD_OK) {
			Err.Out("CDirectDraw::CDirectDrawEmulationOnlyɏoȂ");
			//	ꉞAHALgC
			if (GetDirectDraw()->get()->Initialize(NULL)!=DD_OK) {
				Err.Out("CDirectDraw::CDirectDrawHALɎs");
				m_vDirectDraw.Release();	//	]I
				m_nStatus = 4;
				return ;
			} else {
				///	HAL̏ɐI
				m_nStatus = 3;
			}
			return ;
		}
	} else {
		if (GetDirectDraw()->get()->Initialize(NULL)!=DD_OK) {
			Err.Out("CDirectDraw::CDirectDrawHALɎs");
			m_vDirectDraw.Release();
			m_nStatus = 4;
			return ;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
//	DirectDrawSurfacẽ^Cv𒲂ׂ

int CDirectDrawSurfaceManager::GetSurfaceType(LPDIRECTDRAWSURFACE pSurface){
	//	ʂbppςƂ́Å֐ĂяoĂˁI
	if (pSurface==NULL) return -1;

	DDSURFACEDESC dddesc = { sizeof(dddesc) };
	// PixelFormat𓾂̂ɁALockKv͂ȂAMillenium G400/450Ȃǂ
	// PrimaryLock邱ƂłȂB
	dddesc.ddsCaps.dwCaps = DDSD_PIXELFORMAT;
	if(DD_OK!=pSurface->GetSurfaceDesc( &dddesc )){
		Err.Out("CDirectDrawSurfaceManager::GetSurfaceTypeGetSurfaceDescɎs");
		return 0;	//	Ɏs
	}

	//-------------------------------
	int nBpp = dddesc.ddpfPixelFormat.dwRGBBitCount;
	DWORD	RMask = dddesc.ddpfPixelFormat.dwRBitMask;
	DWORD	GMask = dddesc.ddpfPixelFormat.dwGBitMask;
	DWORD	BMask = dddesc.ddpfPixelFormat.dwBBitMask;

	int nType;
	switch (nBpp){
	case 8:
		nType = 2;	//	8bpp
		break;
	case 16:
		if		(RMask == 0xf800 && GMask == 0x07e0 && BMask == 0x001f) {
			nType = 3;	// RGB565
		} ef	(RMask == 0x7c00 && GMask == 0x03e0 && BMask == 0x001f) {
			nType = 4;	// RGB555
		} else {
			Err.Out("CDirectDrawSurfaceManager::16bpp̕ssNZtH[}bgo");
			Err.Out("BMask=0x%x BMask=0x%x BMask=0x%x",RMask,GMask,BMask);
			nType = 1;	//	16bpp̕ssNZtH[}bgDD
		}
		break;
	case 24:
		if		(RMask == 0xff0000 && GMask == 0xff00 && BMask == 0xff) {
			nType = 5;	// RGB888
		}	ef	(RMask == 0xff	   && GMask == 0xff00 && BMask == 0xff0000) {
			nType = 6;	// BGR888
		} else {
			Err.Out("CDirectDrawSurfaceManager::24bpp̕ssNZtH[}bgo");
			Err.Out("BMask=0x%x BMask=0x%x BMask=0x%x",RMask,GMask,BMask);
			nType = 1;	//	24bpp̕ssNZtH[}bgDD
		}
		break;
	case 32:
		if		(RMask == 0xff0000 && GMask == 0xff00 && BMask == 0xff) {
			nType = 7;	// XRGB888
		}	ef	(RMask == 0xff	   && GMask == 0xff00 && BMask == 0xff0000) {
			nType = 8;	// XBGR888
		} else {
			Err.Out("CDirectDrawSurfaceManager::32bpp̕ssNZtH[}bgo");
			Err.Out("BMask=0x%x BMask=0x%x BMask=0x%x",RMask,GMask,BMask);
			nType = 1;	//	32bpp̕ssNZtH[}bgDD
		}
		break;
	default:
		Err.Out("CDirectDrawSurfaceManager::bpps̃sNZtH[}bgo");
		Err.Out("nBpp=%d BMask=0x%x BMask=0x%x BMask=0x%x",nBpp,RMask,GMask,BMask);
		nType = 1;	//	Ȃł́AHOOG
		break;
	}
	//	IłAI`(ށ)o
	return nType;
}

/////////////////////////////////////////////////////////////////////////////
//	WindowClipper
LRESULT CDirectDrawClipper::SetClipper(LPDIRECTDRAW lpDraw,LPDIRECTDRAWSURFACE lpPrimary,HWND hWnd){
	//	Window[hłȂΈӖ͖

	Release();

	if (lpDraw==NULL || lpPrimary==NULL) return 1;

	if (lpDraw->CreateClipper(0,&m_lpClipper,NULL)!=DD_OK){
		Err.Out("CDirectDrawClipper::ClipClipper\zs");
		return 2;
	}
	if (m_lpClipper->SetHWnd(0,hWnd)!=DD_OK){
		Err.Out("CDirectDrawClipper::CliphWNDZbgłȂ");
		return 3;
	}
	if (lpPrimary->SetClipper(m_lpClipper)!=DD_OK){
		Err.Out("CDirectDrawClipper::ClipSetClipperɎs");
		return 4;
	}

	return 0;
}

void	CDirectDrawClipper::Release(){
	RELEASE_SAFE(m_lpClipper);
}

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd
