//
//	DirectDrawSurface and MemorySurface Wrapper
//

#include "stdafx.h"

#ifdef USE_FastDraw

#include "yaneDirectDraw.h"
#include "yaneFastDraw.h"
#include "yaneFastPlane.h"
#include "yaneGTL.h"
#include "../Window/yaneWindow.h"
#include "../AppFrame/yaneAppManager.h"	//	GetHWnd
#include "../AppFrame/yaneAppBase.h"

//////////////////////////////////////////////////////////////////////////////
//	CFastDraw : ʉ𑜓x؂ւȂ
//////////////////////////////////////////////////////////////////////////////

namespace yaneuraoGameSDK3rd {
namespace Draw {

CFastDraw::CFastDraw() :
	m_DirectDrawBase(true),	//	DirectDraw emulation only
	//	ƁADirectDrawEmulation OnlŷقI	
	m_Primary(GetThis()),
	m_Secondary256(GetThis()),
	m_Secondary(GetThis())
{
	CFastPlane::SetDefaultFastDraw(this);

//	m_nScreenXSize	= 640;
//	m_nScreenYSize	= 480;
	//	́AĂEBhDTCYɏق񂿂H
	IWindow* pWin = CAppManager::GetMyWindow();
	CWindowOption* opt;
	if (pWin!=NULL){
		opt = pWin->GetWindowOption();
	} else {
		opt = NULL;
	}
	if (opt==NULL){
		m_nScreenXSize	= 640;
		m_nScreenYSize	= 480;
	} else {
		m_nScreenXSize = opt->size_x;
		m_nScreenYSize = opt->size_y;
	}

	m_nScreenColor	= 16;
	m_bFullScr		= false;

	//	FullScr̃tbv̎gpBĝȂΎgقǂ
//	m_bUseFlip		= false;

	{
	RECT rc,rc2;
	::SetRect(&rc,0,0,0,0);
	::SetRect(&rc2,0,0,0,0);
	::AdjustWindowRect(&rc,WS_CAPTION | WS_SYSMENU,true);
	::AdjustWindowRect(&rc2,WS_CAPTION ,false);
	//	tXN[̃j[TCY𐳊mɎZo邽߁Aj[𒲂ׂ(c)yaneurao'00/12/15
	//	iȂƃj[͂nrƂɈقȂOOG j
	m_nMenu = (rc.bottom-rc.top) - (rc2.bottom-rc2.top);
	}

	m_nSecondaryOffsetX = 0;
	m_nSecondaryOffsetY = 0;

	m_nBrightness	= 256;
	m_bLostSurface	= false; 

	m_hWnd	= CAppManager::GetHWnd();
	CAppManager::Add(this);
	CAppManager::Hook(this);		//	tbNJn

	//	vC}̓n[hEFAɊm
	GetPrimary()->SetSystemMemoryUse(false);
//	GetPrimary2()->SetSystemMemoryUse(false);
	//	ȊÓAׂăVXeɊmۂ
	//	CFastPlanéAfBtHgŃVXeȂ̂ŁAłnj

	//	ZJ_ɊւẮAXgAT[tF[XƂĂ
	//	iǂAOnDraw̓I[o[ChĂȂ̂Łj
//	GetPrimary2()->SetAutoRestore(true);
	GetSecondary()->SetAutoRestore(true);

	// yaneGTL.hŎgpAuhe[u
	CFastPlaneBlendTable::InitTable();	
}

CFastDraw::~CFastDraw(){
	CAppManager::Unhook(this);		//	tbNB
	CAppManager::Del(this);
}

//////////////////////////////////////////////////////////////////////////////

int		CFastDraw::GetMenuHeight(){
//	j[ĂȂ΁Ãj[Ԃ
//	iĂȂ΂Oj
	if (::GetMenu(m_hWnd)!=NULL) return m_nMenu;
	return 0;
}

//////////////////////////////////////////////////////////////////////////////

void CFastDraw::BeginChangeDisplay(){
	GetCriticalSection()->Enter();	//	rbNĂ

	m_bDisplayChanging = true;
	m_bChangeDisplayMode = false;
	if (GetDDraw()==NULL) return ;

	// FullScreenModeFlippɃA^b`ĂAKvȂ...
	//	ZJ_ANbpAvC}̉
 
	m_Secondary256.Release();
//	m_Secondary.Release();
	//	̃ZJ_́AVXeɍ쐬ꂽ
	//	zZJ_T[tF[XȂ̂ŉKv
	//	iނAȂƂɂāAAutoRestorȇΏۂƂj

	m_WindowClipper.Release();
//	m_Primary2.Release();
	m_Primary.Release();

	if (m_bFullScr) {	//	tXN[[hȂ΂߂Kv
		if (GetDDraw()->SetCooperativeLevel(m_hWnd,DDSCL_NORMAL)){
			Err.Out("CFastDraw::BeginChangeDisplaySetCooperativeLevelɎs..");
		}
		// EBhD[hɂƂ́AsȂKv
		if (GetDDraw()->RestoreDisplayMode()){
			Err.Out("CFastDraw::BeginChangeDisplayRestoreDisplayModeɎs..");
		}
	}
}

void CFastDraw::TestDisplayMode(int nSX,int nSY,bool bFullScr,int nColor){
	if (!m_bDisplayChanging) return ; // already changing!!
	if (GetDDraw()==NULL) return ;

	// EChE[hŃfBXvC[hύXȂ
	m_bChangeDisplayMode |= (m_bFullScr!=bFullScr) || m_bFullScr;// ǉ
	if (m_bChangeDisplayMode) CAppManager::GetMyWindow()->SetResized(true);

	//	ʃ[h𔽉f...
	m_bFullScr	= bFullScr;

	if (!bFullScr) {
		// Window[h̎w肪ȂΎdȂB
		if (GetDDraw()->SetCooperativeLevel(m_hWnd,DDSCL_NORMAL)){
			Err.Out("CFastDraw::TestDisplayModeSetCooperativeLevelDDSC_NORMALŎs");
			return ; // ł񂩂͂茾ăVȂ̂₯...
		}
	} else {
		if (GetDDraw()->SetCooperativeLevel(m_hWnd,DDSCL_EXCLUSIVE|DDSCL_FULLSCREEN)!=DD_OK){
			Err.Out("CFastDraw::TestDisplayModeSetCooperativeLevelDDSC_EXCLUSIVEŎs");
			return ; // ̃AvgĂ񂿂ႤH
		}
		if (GetDDraw()->SetDisplayMode(nSX,nSY,nColor)!=DD_OK){
			Err.Out("CFastDraw::TestDisplayModeSetDisplayModeɎs");
			return ; // ΉH
		}
	}

	//	m_bUseFlip	: tbvgp̂Hi[U[̈ӎv	j
	//	m_bUseFlip2 : tbvۂɃn[hEFAIɎgāA
	//				ĎgƂtrue

//	m_bUseFlip2 = m_bUseFlip;

	bool bUseFilp = false;
	//	vC}T[tF[X̍쐬
	if (m_Primary.CreatePrimary(bUseFilp,nSX,nSY)!=0) {
		Err.Out("CFastDraw::TestDisplayModeCreatePrimaryɎs");
		return ;
	}

	//	EBhD[hȂ΃Nbpd|
	m_WindowClipper.Release();
	if (!bFullScr){
		if (m_WindowClipper.SetClipper(GetDDraw(),m_Primary.GetSurface(),m_hWnd)!=0) {
			Err.Out("CFastDraw::TestDisplayModeClipɎs");
			return ;
		}
	}

/*
	if (m_bUseFlip2){
		if (m_Primary2.CreatePrimary2(&m_Primary,m_bUseFlip2)!=0){
			//	ꎸsĂAtbvgpȂAƂ
			m_bUseFlip2 = false;
		}
	}
*/

	bool b256 = m_Primary.GetSurfaceType()==2;
	if (b256) {
		m_Secondary.m_bSecondary256DIB = true;
		//	RGB555DIBɂĂ炤ŁI
	}

	//	ZJ_T[tF[X̍쐬
	if (m_Secondary.CreateSecondary(&m_Primary,bUseFilp)!=0) {
		Err.Out("CFastDraw::TestDisplayModeCreateSecondaryɎs");
		return ;
	}

/*
	// 256łȂȂ΃pbg̐ݒ͖Ӗ
	if (b256) InstallPalette();
*/

	//	AtXN[[h256FłAtbvgpȂ΁A
	//	Secondary256͕svȂ̂DDD
	if (b256) {
		//	256ϊpT[tF[X
		m_Secondary256.InnerCreateSurface(nSX,nSY,false,true);
	}

	//	ŃEBhD[h𔽉fĂ
	CAppManager::GetMyWindow()->ChangeScreen(bFullScr);
	CAppManager::GetMyWindow()->ChangeWindowStyle();

	m_bDisplayChanging	= false;	//	ʃ[h̕ύXɐI
	m_nScreenColor	= nColor;
	m_nScreenXSize	= nSX;
	m_nScreenYSize	= nSY;
	return ;
}

LRESULT CFastDraw::EndChangeDisplay(){
	struct tmpclass {
		tmpclass(CCriticalSection*c):c_(c){}
		~tmpclass() { c_->Leave();}
		CCriticalSection*c_;
	};
	tmpclass t(GetCriticalSection());
	//	ƂBeginChangeDisplayłrbN悤

	if (GetDDraw()==NULL) return 1;
	
	if (m_bDisplayChanging) { // ChangeĂȂII
		Err.Out("CFastDraw::BeginChangeDisplay`EndChangeDisplayɎs");
		return 1;
	}

	// EChE[hŁAfBXvC[hςĂȂȂ҂Ȃ
	if(m_bChangeDisplayMode) {// ǉ
		::Sleep(500);	//	rfI[h̕ύX̗]g󂯂\
	}

/*
	// pbg̍č\z
	m_bBrightnessChanged = true;
*/

	// Oŕ`悷ȂΊ֌WȂ̂...
	// CAppManager::GetMyWindow()->ShowCursor(!m_bFullScr);
	// EBhDTCY̕ύX
	CAppManager::GetMyWindow()->SetSize(m_nScreenXSize,m_nScreenYSize);
	// EBhDX^C̕ύX

	CAppManager::GetMyWindow()->ChangeScreen(m_bFullScr);
	//	̏EBhDɂ͍mĂB
	//	i{́AׂẴEBhEɃu[hLXgKvj
	CAppManager::GetMyWindow()->ChangeWindowStyle();

	// v[̍č\ziĂ΁j
	RestoreAll();

	//	ipbg̃ACYɁj
	// yaneGTL.hŎgpARGB555256̕ϊe[ȕ
	//	(A256F[hȊÔƂ́Aɖ߂Ă)
	CFastPlaneBlendTable::OnChangePalette();	

	return 0;
}

/////// gp:p) ////////////////////////////////////////////////////////////

LRESULT CFastDraw::ChangeDisplay(bool bFullScr){
	if (GetDDraw()==NULL) return 1; //	߂...
	BeginChangeDisplay();
		if (bFullScr) {
			TestDisplayMode(m_nScreenXSize,m_nScreenYSize,true,m_nScreenColor);
		}
		TestDisplayMode(m_nScreenXSize,m_nScreenYSize); // EBhD[h
	if (EndChangeDisplay()) return 2;	//	fBXvC[hύXɎs
	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//	fBXvC[h̐ݒ聨ύX

LRESULT		CFastDraw::SetDisplay(bool bFullScr,int nSizeX,int nSizeY,int nColorDepth){
	if (nSizeX!=0) {
		m_nScreenXSize	=	nSizeX;
	}
	if (nSizeY!=0) {
		m_nScreenYSize	=	nSizeY;
	}
	if (nColorDepth!=0) {
		m_nScreenColor	=	nColorDepth;
	} else {
		m_nScreenColor	=	16; // fixed '01/04/08
	}
	ChangeDisplay(bFullScr);
	//	̃p[^͂ɓn
	//	im_bFullScr݂͌̉ʃ[hێĂ̂Łj
	return 0;
}

void		CFastDraw::GetDisplay(bool&bFullScr,int &nSizeX,int &nSizeY,int &nColorDepth){
	bFullScr		=	m_bFullScr;
	nSizeX			=	m_nScreenXSize;
	nSizeY			=	m_nScreenYSize;
	nColorDepth		=	m_nScreenColor;
}

void		CFastDraw::GetSize(int &nSizeX,int &nSizeY){	// GetDisplayModex,y
	nSizeX			=	m_nScreenXSize;
	nSizeY			=	m_nScreenYSize;
}
	
bool	CFastDraw::IsFullScreen(){
	return		m_bFullScr;
}

void	CFastDraw::CheckSurfaceLost(){
	LPDIRECTDRAWSURFACE lpSurface = GetPrimary()->GetSurface();
	//	VXẽT[tF[XLostȂ̂łOOG
	if (lpSurface==NULL) return ;
	if (lpSurface->IsLost()){
		ChangeDisplay(m_bFullScr);
		//	vC}T[tF[X̍č\zsȂׂ
	}
}

/*
int		CFastDraw::GetBpp(){	// ݂Bpp̎擾
	return GetPrimary()->GetBpp();
}
*/

void	CFastDraw::SetBrightness(int nBright){
	if (m_nBrightness == nBright) return ;
	m_nBrightness = nBright;
}

//////////////////////////////////////////////////////////////////////////////

void	CFastDraw::SetOffset(int ox,int oy){
	//	ZJ_̓]ItZbg
	m_nSecondaryOffsetX =	ox;
	m_nSecondaryOffsetY =	oy;
}

void	CFastDraw::OnDraw(LPCRECT lpRect,bool bLayerCallBack){

	//	ŏĂȂΕ`悹Ƀ^[
	if (CAppManager::GetMyWindow()->IsMinimized()) return ;

	//	MenuPopup
	int nMenu = 0;
	//	FullScrŁAj[ŁA}EXʏ̃j[̈ɂ̂Ȃ...
	if (IsFullScreen() && ::GetActiveWindow()==m_hWnd) {
	//						ɃCEChEANeBu(_CAOȂǂĂяoĂȂ)
		POINT point;
		::GetCursorPos(&point);
		if (point.y<m_nMenu) {
			if (::GetMenu(m_hWnd)!=NULL){
//				̃j[TCY𐳊mɎZo邽߁Aj[𒲂ׂ(c)yaneurao'00/12/15
				nMenu = m_nMenu;
				//	PaintȂ[
//				::SetMenu(m_hWnd,GetMenu(m_hWnd));	//	j[̈̍ĕ`
				::DrawMenuBar(m_hWnd);
			}
		}
	}
	
	//	AT[tF[XĂ...
	if (m_bLostSurface) {
		//	XbhĵȂ΃XgA͖...
		if (!CAppManager::GetMyApp()->IsThreadValid()) return ;
		CheckSurfaceLost();
		//	̃tÓAbZ[W|v
		//	XgACxgɉĐݒ肳
		m_bLostSurface = false;
		return ;
	}
	
	LPDIRECTDRAWSURFACE lpPrimary = GetPrimary()->GetSurface();
	if (lpPrimary==NULL) return ;

	//////////////////////////////////////////////////////////
	//	Layer callback
	if ( bLayerCallBack ){
		//	LayerZJ_ɕ`悵Ă炤OO
		m_LayerList.OnDraw(GetSecondary());
		
		//	HDCLayerZJ_ɕ`悵Ă炤OO
		if (!m_HDCLayerList.IsEmpty()){
			HDC hdc = GetSecondary()->GetDC();
			if (hdc!=NULL){
				m_HDCLayerList.OnDraw(hdc);
				GetSecondary()->ReleaseDC();
			}
//			Invalidate();	//	ŁAtOĂ
		}
		
		//	AfterLayerZJ_ɕ`悵Ă炤OO
		m_AfterLayerList.OnDraw(GetSecondary());

		//	uCglXɉāAZJ_
		RealizeBrightness(m_nBrightness);
	}
	//////////////////////////////////////////////////////////
	
	//	vC}ĂȂ΃^[
	//	if (!m_bDirty) return ;
	//	DirtyRectǗ͍sȂĂȂ
	//	ǂFullScreenFlipgƍŏXVł͊ǗłȂ
	
	LPDIRECTDRAWSURFACE lpSecondary;
	CFastPlane* lpSecondarySurface;
	if (m_Primary.GetSurfaceType()==2){	//	8bpp...
		//	SecondarýARGB555Ȃ̂œ]ĂKv
		GetSecondary256()->BltFast(GetSecondary(),0,0);
		lpSecondary = GetSecondary256()->GetSurface();
		lpSecondarySurface = GetSecondary256();
	} else {
		lpSecondary = GetSecondary()->GetSurface();
		lpSecondarySurface = GetSecondary();
	}
	if (lpSecondary==NULL) return ;

	RECT r; // source rect
	::SetRect(&r,0,0,m_nScreenXSize,m_nScreenYSize);
	
	if (m_nSecondaryOffsetX || m_nSecondaryOffsetY) {
		//	]ItZbgĂ̂H
		RECT r2; // distination rect
		if ( lpRect == NULL ){	// XVH
			::SetRect(&r2,0,0,m_nScreenXSize,m_nScreenYSize);	//	TCYƉ肵ėǂ
			//	a clipping algorithm
			//		between the same size rect (C) yaneurao'1999
			if (m_nSecondaryOffsetX>0) {
				r.right		-= m_nSecondaryOffsetX;
				r2.left		+= m_nSecondaryOffsetX;
			} else {
				r.left		-= m_nSecondaryOffsetX;
				r2.right	+= m_nSecondaryOffsetX;
			}
			if (m_nSecondaryOffsetY>0) {
				r.bottom	-= m_nSecondaryOffsetY;
				r2.top		+= m_nSecondaryOffsetY;
			} else {
				r.top		-= m_nSecondaryOffsetY;
				r2.bottom	+= m_nSecondaryOffsetY;
			}
			
			if (CWindow::IsFullScreen()){
				// tXN[łABltȂ̂I
				DDBLTFX fx;
				ZERO(fx);	//	ꉞ
				fx.dwSize = sizeof(fx);
				fx.dwFillColor = lpSecondarySurface->GetFillColor();
				RECT br;
				::SetRect(&br,0,nMenu,m_nScreenXSize,r2.top);					//	̈
				lpPrimary->Blt(&br,NULL,NULL,DDBLT_COLORFILL|DDBLT_WAIT,&fx);
				//	main摜
				lpPrimary->BltFast(r2.left,r2.top,lpSecondary,&r,DDBLTFAST_WAIT);
				::SetRect(&br,0,r2.top,r2.left,r2.bottom);				//	̈
				lpPrimary->Blt(&br,NULL,NULL,DDBLT_COLORFILL|DDBLT_WAIT,&fx);
				::SetRect(&br,r2.right,r2.top,m_nScreenXSize,r2.bottom);	//	Ë
				lpPrimary->Blt(&br,NULL,NULL,DDBLT_COLORFILL|DDBLT_WAIT,&fx);
				::SetRect(&br,0,r2.bottom,m_nScreenXSize,m_nScreenYSize);	//	̈
				lpPrimary->Blt(&br,NULL,NULL,DDBLT_COLORFILL|DDBLT_WAIT,&fx);
				
			} else {
				// DirectDrawClipper𗘗pɂBltɂȂĂ͂ȂȂB
				// AȂ񂿂[Bɂė~>ClipperNI
				POINT cp;
				cp.x = cp.y = 0;
				::ClientToScreen(m_hWnd,&cp); // NCAgEBhD̋`I
				
				DDBLTFX fx;
				ZERO(fx);	//	ꉞ
				fx.dwSize = sizeof(fx);
				fx.dwFillColor = lpSecondarySurface->GetFillColor();
				
				RECT br;
				::SetRect(&br,0,0,m_nScreenXSize,r2.top);					//	̈
				::OffsetRect(&br,cp.x,cp.y);
				lpPrimary->Blt(&br,NULL,NULL,DDBLT_COLORFILL|DDBLT_WAIT,&fx);
				
				//	main摜
				br = r2;
				::OffsetRect(&br,cp.x,cp.y);
				lpPrimary->Blt(&br,lpSecondary,&r,DDBLT_WAIT,NULL);
				
				::SetRect(&br,0,r2.top,r2.left,r2.bottom);					//	̈
				::OffsetRect(&br,cp.x,cp.y);
				lpPrimary->Blt(&br,NULL,NULL,DDBLT_COLORFILL|DDBLT_WAIT,&fx);
				::SetRect(&br,r2.right,r2.top,m_nScreenXSize,r2.bottom);	//	Ë
				::OffsetRect(&br,cp.x,cp.y);
				lpPrimary->Blt(&br,NULL,NULL,DDBLT_COLORFILL|DDBLT_WAIT,&fx);
				::SetRect(&br,0,r2.bottom,m_nScreenXSize,m_nScreenYSize);	//	̈
				::OffsetRect(&br,cp.x,cp.y);
				lpPrimary->Blt(&br,NULL,NULL,DDBLT_COLORFILL|DDBLT_WAIT,&fx);
			}
		}else{
			// XV
				r = *lpRect;	// source rest;
				r2 = *lpRect;	// dest	 rest;
			if (CWindow::IsFullScreen()){
				// from CPlane DRAW_CLIPPER
				RECT& sr = r;			
				int x = m_nSecondaryOffsetX;
				int y = m_nSecondaryOffsetY;
				{
					RECT clip;
					::SetRect(&clip,0,0,m_nScreenXSize,m_nScreenYSize);
					int x2,y2;													
					x2 = x + sr.right - sr.left; /* x + Width  */				
					y2 = y + sr.bottom - sr.top; /* y + Height */				
					if (x2<clip.left || y2<clip.top								
						|| x>=clip.right || y>=clip.bottom) return;	 /* ʊO */ 
					int t;														
					t = clip.left-x;										
					if (t>0)	{ sr.left	+= t;	x = clip.left;	}		
					t = clip.top -y;										
					if (t>0)	{ sr.top	+= t;	y = clip.top;	}		
					t = x2-clip.right;										
					if (t>0)	{ sr.right	-= t;	x2= clip.right; }		
					t = y2-clip.bottom;										
					if (t>0)	{ sr.bottom -= t;	y2= clip.bottom;}		
					if (sr.right<=sr.left || sr.bottom<=sr.top) return; // invalid rect
				}
				lpPrimary->BltFast(x,y,lpSecondary,&r,DDBLTFAST_WAIT);
			}else{
				// ItZbg]̕XVȂ̂ŁAꂽwi͕`悵Ȃ
				// DirectDrawClipper𗘗pɂBltɂȂĂ͂ȂȂB
				// AȂ񂿂[Bɂė~>ClipperNI
				POINT cp;
				cp.x = cp.y = 0;
				::ClientToScreen(m_hWnd,&cp); // NCAgEBhD̋`I
				::OffsetRect(&r2,m_nSecondaryOffsetX,m_nSecondaryOffsetY);
				::OffsetRect(&r2,cp.x,cp.y); 
				lpPrimary->Blt(&r2,lpSecondary,&r,DDBLT_WAIT,NULL);
			}
			
		}
		
	} else {
		//	]ItZbgw肳ĂȂtc[̏ꍇ
		
		if (CWindow::IsFullScreen()){
			if (/*m_bUseFlip2*/ false && lpRect == NULL ){
				lpPrimary->Flip(NULL,DDFLIP_WAIT);
			} else {
				if ( lpRect != NULL ){
					r = *lpRect;
				}
				//	Aj[\ΉI(yane'02/01/13)
				if ( nMenu && nMenu > r.top ) {
					r.top = nMenu;
				}
				lpPrimary->BltFast(r.left,r.top,lpSecondary,&r,DDBLTFAST_WAIT);
			}
		} else {
			// DirectDrawClipper𗘗pɂBltɂȂĂ͂ȂȂB
			// AȂ񂿂[Bɂė~>ClipperNI
			POINT cp;
			cp.x = cp.y = 0;
			::ClientToScreen(m_hWnd,&cp); // NCAgEBhD̋`I
			if ( lpRect != NULL ) {
				r = *lpRect;
			}
			RECT sr = r;
			::OffsetRect(&sr,cp.x,cp.y);
			lpPrimary->Blt(&sr,lpSecondary,&r,DDBLT_WAIT,NULL);
		}
	}
	
//	m_bDirty = false;
}

//////////////////////////////////////////////////////////////////////////////
void	CFastDraw::RealizeBrightness(int nBrightness){
	if (m_nBrightness==256) return ;
	//	ꂾł񂩁OOG@OOG
	GetSecondary()->FadeEffect(nBrightness);
}

//////////////////////////////////////////////////////////////////////////////

void	CFastDraw::RestoreAll(){ // Sv[̃[h
	GetFastPlaneList()->for_each(&CFastPlane::Restore);
	return ;
}

//////////////////////////////////////////////////////////////////////////////
LRESULT		CFastDraw::WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){

	switch(uMsg){
	case WM_PAINT : {
		//	dirty rect
//		m_bDirty = true;
//		if (!CWindow::IsFullScreen()) OnDraw();	//	ꉞAĕ`悵Ă܂B
//		OnDraw();
		/*
			OĂ̂ARgOƂĂ
			WM_PAINT̏ɂGetDC͎gȂ̂ŒӂKvB
			iGetDCŎ擾foCXReLXgɕ`悷WM_PAINT邩j
			WM_PAINT̏WM_PAINTŁAAvP[VWM_PAINT
			łȂȂI
		*/
		return 0;	//	DefWindowProcĂяoɍsB
					//	ĂяoĂȂƍēxWM_PAINTĂ
					}

	case WM_ACTIVATEAPP: {
		UINT bActive = wParam;
		if(bActive) {
			//	bZ[W|vł͂ȂA[J[XbhŃXgAׂ...
			m_bLostSurface = true;
		}
		return 0;
						 }

	case WM_PALETTECHANGED: {
		//	ipbg̃ACYɁj
		// yaneGTL.hŎgpARGB555256̕ϊe[ȕ
		CFastPlaneBlendTable::OnChangePalette();	
		return 0;
							}

	} // end switch


	return 0;
}

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif // USE_FastDraw
