#include "stdafx.h"

#include "yaneFont.h"

//////////////////////////////////////////////////////////////////////////////

namespace yaneuraoGameSDK3rd {
namespace Draw {

CFont::CFont(){
	SetSize(16);
	SetHeight(20);
	SetFont(0);	// MS SVbN
//	SetColor(RGB(128,192,128));
//	SetBackColor(RGB(64,128,64));
	SetColor(RGB(255,255,255));
	SetBackColor(RGB(128,128,128));
	SetBGColor(CLR_INVALID);
	SetQuality(2);
	SetVerticalFont(false);
	SetWeight(FW_LIGHT);
	SetItalic(false);
	SetUnderLine(false);
	SetStrikeOut(false);
	SetShadowOffset(2,2);
}

CFont::~CFont(){
}

//////////////////////////////////////////////////////////////////////////////

void	CFont::SetQuality(int nQuality){
	switch(nQuality) {
	case 0: m_nQuality = DEFAULT_QUALITY; break;
	case 1: m_nQuality = DRAFT_QUALITY; break;
	case 2: m_nQuality = PROOF_QUALITY; break;
	case 3: m_nQuality = ANTIALIASED_QUALITY; break;
	case 4: m_nQuality = NONANTIALIASED_QUALITY; break;
	default: WARNING(true,"CFont::SetQuality KO̐l");
	}
}

void	CFont::SetSize(int nSize){
	m_nSize = nSize;
	m_nHeight = nSize;	//	XV鉿lH
}

void	CFont::SetColor(COLORREF rgb){
	m_nRgb = rgb;
}

void	CFont::SetBackColor(COLORREF rgb){
	m_nBkRgb	= rgb;
}

void	CFont::SetBGColor(COLORREF rgb){
	m_nBGRgb	= rgb;
}

void	CFont::SetHeight(int nHeight){
	m_nHeight = nHeight;
}

void	CFont::SetWeight(int nWeight){
	m_nWeight = nWeight;
}

////////////////////////////////////////////////////////////////////
//	fontݒ`擾

void	CFont::SetFont(int nFontNo){
	string name;
	switch (nFontNo) {
	case 0: name ="lr SVbN"; break;
	case 1: name ="lr oSVbN"; break;
	case 2: name ="lr "; break;
	case 3: name ="lr o"; break;
	default: name="";
	}
	if (m_FontName==name) return ;
	m_FontName=name;
}
void	CFont::SetFont(const string& fontname){
	if (m_FontName==fontname) return ;
	m_FontName=fontname;
}

string	CFont::GetFont() const {
	if (!IsVerticalFont()){
	} else {
		if (!m_FontName.empty() && m_FontName[0]=='@'){
			//	ŏctHgȂ̂ŉȂ
		} else {
			return '@' + m_FontName;
		}
	}
	return m_FontName;
}

////////////////////////////////////////////////////////////////////

void	CFont::SetText(const string& s){
	m_String = s;
}

void	__cdecl CFont::SetText(LPSTR fmt, ... ){
	CHAR buf[512];
	wvsprintf(buf,fmt,(LPSTR)(&fmt+1));
	SetText((string)buf);
}

void CFont::SetText(int i){
	CHAR buf[16];
	wsprintf(buf,"%d",i);
	SetText(buf);
}

void	CFont::SetItalic(bool b){
	m_bItalic = b;
}

void	CFont::SetUnderLine(bool b){
	m_bUnderLine = b;
}

void	CFont::SetStrikeOut(bool b){
	m_bStrikeOut = b;
}

void	CFont::SetShadowOffset(int nOx,int nOy){
	m_nShadowOffsetX = nOx;
	m_nShadowOffsetY = nOy;
}

/////////////////////////////////////////////////////////////////////////////////////////

//	drawing

void	CFont::OnDraw(HDC hdc,int x,int y){

	//	񂪐ݒ肳ĂȂ΋A
	if (m_String.empty()) return ;

	string strFontName = GetFont();
	HFONT hFont = ::CreateFont(m_nSize,0,0,0,m_nWeight,m_bItalic,m_bUnderLine,m_bStrikeOut,SHIFTJIS_CHARSET,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, m_nQuality,FF_MODERN,strFontName.c_str());

	if (hFont==NULL) return ; // ̂IH

	HFONT hFontLast = (HFONT)::SelectObject(hdc,hFont);

	//	wiFtŕ`悷Ȃ΁A
	//	ŏ̈opaque,ڈȍ~transparent,
	bool bFirst = true;

	if (m_nBkRgb!=CLR_INVALID){
		//	Ad˂鉿lȂDD
		POINT point[5] = {
			{m_nShadowOffsetX,m_nShadowOffsetY},		// 1
//			{2,2},		// 1
			{0,1},
			{2,1},		// 2
			{1,2},
			{2,2}		// 3
		};

		::SetTextColor(hdc,m_nBkRgb);
		//	F̕ύX

		//	wiF̐ݒ
		if (m_nBGRgb==CLR_INVALID) {
			::SetBkMode(hdc, TRANSPARENT);
		} else {
			::SetBkMode(hdc, OPAQUE);
			::SetBkColor(hdc,m_nBGRgb);
		}
		bFirst = false;

		for(int i=0;i<1 /* 5 */;i++){
			TextOut(hdc,x + point[i].x,y + point[i].y,m_String);
			//	̕\iWIN32APIł͂ȂÃNXstatic֐ł邱ƂɒӁj
		}
	}
	if (m_nRgb!=CLR_INVALID){
		//	wiF̐ݒ
		if (bFirst){
			if (m_nBGRgb==CLR_INVALID) {
				::SetBkMode(hdc, TRANSPARENT);
			} else {
				::SetBkMode(hdc, OPAQUE);
				::SetBkColor(hdc,m_nBGRgb);
			}
		} else if (m_nBGRgb!=CLR_INVALID) {
			//	Qڈȍ~̕`Ȃ̂œߐݒɖ߂ĂȂẮDD
			::SetBkMode(hdc, TRANSPARENT);
		}

		::SetTextColor(hdc,m_nRgb);
		TextOut(hdc,x,y,m_String);	//	̕\
	}
	::SelectObject(hdc,hFontLast);
	::DeleteObject(hFont);		// ł񂩁H
}

LRESULT	CFont::GetSize(int& sx,int& sy){
	sx = 0; sy = 0;	// fail safe΍

	//	񂪐ݒ肳ĂȂ΋A
	if (m_String.empty()) return 1;

	string strFontName = GetFont();
	HFONT hFont = ::CreateFont(m_nSize,0,0,0,m_nWeight,m_bItalic,m_bUnderLine,m_bStrikeOut,SHIFTJIS_CHARSET,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, m_nQuality,FF_MODERN,strFontName.c_str());
	if (hFont==NULL) return 1; // [

	SIZE size;
	HDC hdc = ::CreateCompatibleDC(NULL);
	HFONT hFontLast = (HFONT)::SelectObject(hdc,hFont);

	LPCSTR p = m_String.c_str();
	CHAR buf[256];	//	̒܂łvsOOG
	LPSTR q=buf;
	size.cx=0; size.cy=0;
	SIZE size2;
	for(;;){
		*q = *(p++);
		if (*q=='\n') {
			*q=0;	// sR[hȂΒׂ 
			::GetTextExtentPoint32(hdc,buf,::lstrlen(buf),&size2);
			//GetTextExtentPoint͓̏󋵂łPhbgꂪ邻^^;
//			size.cy+=size2.cy;
			size.cy+=m_nHeight;	//	fixed by 
			if (m_bItalic) size2.cx+=m_nSize/4;	//	APIΑ̂̃TCYbug΍
			if (size.cx<size2.cx) size.cx=size2.cx;
			q=buf;
			continue;	//	̂ƂqZĂ͍
		} else if (*q=='\0') {
			::GetTextExtentPoint32(hdc,buf,::lstrlen(buf),&size2);
			//GetTextExtentPoint͓̏󋵂łPhbgꂪ邻^^;
			size.cy+=size2.cy;
			if (m_bItalic) size2.cx+=m_nSize/4;	//	APIΑ̂̃TCYbug΍
			if (size.cx<size2.cx) size.cx=size2.cx;
			break;	// ɂďI`
		}
		q++;
	}
	sx = size.cx + 3;	//	ɂ͉ê
	sy = size.cy + 3;	//

	::SelectObject(hdc,hFontLast);
	::DeleteObject(hFont);	// ł񂩁H

	::DeleteDC(hdc);	//	ŌɂƂŁI(by TearDrop_Stone)

	return 0;
}

void	CFont::TextOut(HDC hdc,int x,int y,const string& s){

	//	񂪐ݒ肳ĂȂ΋A
	if (m_String.empty()) return ;

	//	ő̗_́A񒆂\n𖄂ߍނƂŉso邱ƂłB

	CHAR buf[256];
	LPCSTR p = s.c_str();
	LPSTR q=buf;
	for(;;){
		*q = *(p++);
		if (*q=='\n') {
			*q=0;	// sR[hȂΒׂ 
			::TextOut(hdc,x,y,buf,::lstrlen(buf));
			y+=m_nHeight;
			q=buf;
			continue;	//	̂ƂqZĂ͍
		} else if (*q=='\0') {
			::TextOut(hdc,x,y,buf,::lstrlen(buf));
			break;	// ɂďI`
		}
		q++;
	}
}

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd
