// yaneLayer.h

#ifndef __yaneLayer_h__
#define __yaneLayer_h__


#if defined(yaneSDK_CodeWarrior_Mode)
#include "yaneSurface.h" //	NX̒`t@CincludeĂȂƂ
#endif

namespace yaneuraoGameSDK3rd {
namespace Draw {

class ISurface;
class ILayerList;

class ILayerBase {
/**
	C̊NXB
	A`惆jbg(CFastDraw)̃CR[obNɓo^ĎgpB

*/
public:
	///		`悷R[obN(ȉ̂ǂ炩I[o[Ch)
	virtual	void	OnDraw(ISurface*lpDraw) {}
	virtual	void	OnDraw(HDC) {}

	///		|WVw/擾
	void	SetPos(int x,int y)	 { m_nX = x; m_nY = y; }
	void	GetPos(int& x,int& y) const { x = m_nX; y = m_nY; }

	///		`L^(fBtHgŗL)
	void	Enable(bool bEnable) { m_bEnable = bEnable; }
	bool	IsEnable() const { return m_bEnable; }

	///		LayerListRXgN^œn΁AIɃtbN
	ILayerBase(ILayerList*pLayerList=NULL);

	void	SetLayerList(ILayerList*pLayerList);
	/**
		LayerListݒ肷B(̏uԂɃtbN)
	*/

	///		fXgN^ŁALayerListtbNĂ̂O
	virtual ~ILayerBase();

protected:
	int		m_nX,m_nY;	//	ItZbgW
	bool	m_bEnable;

	ILayerList* m_pLayerList;
	/*
		tbNĂ郌CXgێĂAfXgN^
		tbN
	*/
};

class ILayerList {
public:
	virtual void	Add(ILayerBase*)=0;
	virtual void	Del(ILayerBase*)=0;
	virtual void	Clear()=0;
	virtual bool	IsEmpty() const=0;
	
	virtual void	OnDraw(ISurface*)=0;
	virtual void	OnDraw(HDC)=0;

	virtual ~ILayerList(){}
};

class CLayerList : public ILayerList {
public:
	virtual void	Add(ILayerBase*);			///	gtbNɉ
	virtual void	Del(ILayerBase*);			///	gtbNO
	virtual void	Clear();					///	ׂĂNA
	virtual bool	IsEmpty() const;			///	ł邩H

	///	̕ێĂtbNXgɑ΂OnDrawĂяo
	virtual void	OnDraw(ISurface*);
	virtual void	OnDraw(HDC);

protected:
	list_chain<ILayerBase>	m_listLayer;	//	tbNXg
	list_chain<ILayerBase>* GetList() { return& m_listLayer; }
};

////////////////////////////////////////////////////////////////////////////

class CSurfaceLayer : public ILayerBase {
/**
	ISurface*ێĂāAOnDraw(ISurface)ɂāA
	BltNaturalŕ`悷邾̃C
*/
public:

	CSurfaceLayer(ISurface* pSurface,ILayerList*pLayerList=NULL)
		: m_pSurface(pSurface) , ILayerBase(pLayerList) {}
	CSurfaceLayer(const smart_ptr<ISurface>& pSurface,ILayerList*pLayerList=NULL)
		: m_pSurface(pSurface),ILayerBase(pLayerList) {}

protected:
	virtual void	OnDraw(ISurface*);
	smart_ptr<ISurface>	m_pSurface;
};

}}

#include "yaneFont.h"

namespace yaneuraoGameSDK3rd {
namespace Draw {

class CTextLayer : public ILayerBase {
/**
	CFontāAOnDrawɂāACFont::OnDrawĂяoĕ`悷
*/
public:
	///	ŃtHg擾ĐݒsȂ
	CFont* GetFont() { return& m_vFont; }

	CTextLayer(ILayerList*pLayerList=NULL):ILayerBase(pLayerList){}
	///	HDCoRŕ`悵Ă̂ŁAHDCLayerɃtbN邱ƁI

protected:
	virtual void	OnDraw(HDC);
	CFont	m_vFont;
};

} namespace Timer { class CFPSTimer; } namespace Draw {

class CFPSLayer : public CTextLayer {
public:

	CFPSLayer(CFPSTimer*pFPSTimer,ILayerList*pLayerList=NULL);

	CFPSTimer* GetFPSTimer() { return m_pFPSTimer; }

protected:
	virtual void	OnDraw(HDC);
	CFPSTimer* m_pFPSTimer;
};

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif
