
#include "stdafx.h"
#include "yaneSprite.h"
#include "yaneSurface.h"
#include "../Auxiliary/yaneFile.h"
#include "../Auxiliary/yaneStringScanner.h" // CLineParser
#include "yanePlane.h"

namespace yaneuraoGameSDK3rd {
namespace Draw {

//////////////////////////////////////////////////////////////////////////////
//	CSprite

void	CSimpleSprite::set(ISurface*lp){
	//	v[S̃XvCgƂ
	WARNING(lp==NULL,"CSimpleSprite::SetSurfacelp==NULL");

	pSurface = lp;
	int	sx,sy;
	pSurface->GetSize(sx,sy);
	::SetRect(&rcRect,0,0,sx,sy);
	nOx = nOy = 0;
	nHeight	= sy;
	bFast	= true;
}

void	CSimpleSprite::set(ISurface*lp,const RECT &rc){
	//	v[S̃XvCgƂ
	WARNING(lp==NULL,"CSimpleSprite::SetSurfacelp==NULL");

	pSurface = lp;
	rcRect = rc;
	nOx = nOy = 0;
	nHeight	= rc.bottom-rc.top;
	bFast	= true;
}

//////////////////////////////////////////////////////////////////////////////
//	CSprite

CSprite::CSprite() {
	m_nAnimation	= 0;
	m_nDirection	= 0;
	m_nOx			= 0;
	m_nOy			= 0;
	m_nPriority		= 0;	//	ꂪfBtHgi[Ӗ͖j
	m_bVisible		= true;
	m_nHeight		= 0;	//	[Ӗ͂Ȃ
	m_vSprtieVector.Add(new spritevectorofvector);
}

CSprite::~CSprite(){
}

void	CSprite::setOffset(int nOffsetX,int nOffsetY){
	m_nOx = nOffsetX;
	m_nOy = nOffsetY;
}

void	CSprite::getOffset(int& nOffsetX,int& nOffsetY){
	nOffsetX = m_nOx;
	nOffsetY = m_nOy;
}

void	CSprite::incMotion(){
	m_nAnimation++;
	if (m_nAnimation >= (int)getDirectionalSprite()->size()) {
		m_nAnimation = 0;
	}
}

void	CSprite::setDirection(int nDirection){
	//	̕ύXꍇ̓AjJE^ZbgȂidlj
	if (m_nDirection != nDirection) {
		m_nAnimation = 0;
	}
	m_nDirection = nDirection;
}

//////////////////////////////////////////////////////////////////////////////

void	CSpriteEx::Blt(ISurface*pSurface,LPRECT lpClip){
	Blt(pSurface,0,0,lpClip);
}

void	CSpriteEx::Blt(ISurface*pSurface,int x,int y,LPRECT lpClip){
	BltFix(pSurface,x,y,lpClip);
	incMotion();
}

void	CSpriteEx::BltFix(ISurface*pSurface,LPRECT lpClip){
	int x,y;
	getPos(x,y);
	BltFix(pSurface,x,y,lpClip);
}

void	CSpriteEx::BltFix(ISurface*pSurface,int x,int y,LPRECT lpClip){
	//	LH
	if (!isEnable()) return ;

	//	CDirectDrawŕ`悷ꍇLayer
	CSimpleSprite &s = *getSprite();

	int ox,oy;
	getOffset(ox,oy);
	ox+=x+s.nOx;
	oy+=y+s.nOy;

	//	̂܂܈ϏĂ܂Ƃ`
	if (!s.bFast) {
		pSurface->Blt(s.pSurface,ox,oy,NULL,&s.rcRect,lpClip);
	} else {
		pSurface->BltFast(s.pSurface,ox,oy,NULL,&s.rcRect,lpClip);
	}
}

void	CSpriteEx::BltOnce(ISurface*pSurface,int x,int y,LPRECT lpClip){
	BltFix(pSurface,x,y,lpClip);
	
	//	PcɂȂĂAȏ͉ZȂ
	int n=getMotion();
	incMotion();
	if (getMotion()==0) {
		setMotion(n);
	}
}

//////////////////////////////////////////////////////////////////////////////
///	yaneSDK2nd̂ԂB܂肢ł͂Ȃ̂Ń}lȂŃl

void	CSpriteChara::Release()
{
	m_apSurface.clear();
	m_vSpriteVector.Delete();
}

LRESULT	CSpriteChara::Load(const string& strFileName)
{
	Release();
	m_vSpriteVector.Add(new CSprite::spritevectorofvector);
	CFile file;
	if (file.Read(strFileName)!=0) return 1;

	//	ReadLine()ňs͂ăXvCgݒsȂ

	//	XvCgXCX̗p
	CSimpleSprite ssprite[256];
	ZERO(ssprite);

	int		nLine = 0;
	CHAR	szBuf[256];
	while (true) {
		nLine++;

		CLineParser		lineParser;
		if( file.ReadLine( szBuf ) !=0 ) break;
		lineParser.SetLine( szBuf );					//	C p[T[ɕZbg

		//////////////////////////////////////////////////
		// eR}hʂɎs

		// XvCg`̐ݒ
		if ( lineParser.IsMatch( "#SpriteMax" ) ){
			int		n;
			if ( lineParser.GetNum( n ) != 0 ) { Err.Out("CSpriteChara::Load#SpriteMaxɎs"); return 2; }
//			m_lpSprite.resize(n);
//			m_nSpriteMax = n;
			m_vSpriteVector->resize(n);
			continue;
		}
		////	őv@ SpriteMax > SpriteF > Sprite
		//	XvCgx̋`z̐ݒ (F͖)
		if ( lineParser.IsMatch( "#SpriteF" ) ){
			WARNING(m_vSpriteVector->empty(),"CSpriteChara::LoadSpriteMaxȂ#SpriteL");
			int		n,m;
			lineParser.GetNum(n);
			while (true){
				if (lineParser.GetNum(m)) break;
				ssprite[m].bFast=true;

				//	́A
				ssprite[m].nHeight = 32;
					//	͂œꂵق悳...
					//	ύXKvȏꍇ́AeLNXŕύX邱

				(*m_vSpriteVector)[n].push_back(ssprite[m]);
			}
			continue;
		}
/*
	ˁ@ꊇ`
	#SpritePlane 0,0,34					//	XvCg0`34́Av[035(v[34)ƂB
	#SpritePlaneF 0,0,34					//	XvCg0`34́Av[035(v[34)ƂBF͖
*/

		//	zXvCgx̐ݒ
		if ( lineParser.IsMatch( "#SpritePlaneF" ) ){
			WARNING(m_vSpriteVector->empty(),"CSpriteChara::LoadSpriteMaxȂ#SpriteL");
			int		n,m,l;
			lineParser.GetNum(n);
			if (lineParser.GetNum(m)) break;
			if (lineParser.GetNum(l)) break;

			CSimpleSprite s = {0};
			for(int i=n;i<n+l;i++){
				ssprite[i].bFast=true;
				//	́A
				ssprite[i].nHeight = 32;
				//	͂œꂵق悳...
				//	ύXKvȏꍇ́AeLNXŕύX邱
				s.pSurface = m_apSurface[m+i].get();
				{
					int sx,sy;
					s.pSurface->GetSize(sx,sy);
					::SetRect(&s.rcRect,0,0,sx,sy);
				}
//				m_lpSprite[i].SetSpriteAdd(&s);
				(*m_vSpriteVector)[n].push_back(s);
			}
			continue;
		}

		//	zXvCgx̐ݒ
		if ( lineParser.IsMatch( "#SpritePlane" ) ){
			WARNING(m_vSpriteVector->empty(),"CSpriteChara::LoadSpriteMaxȂ#SpriteL");
			int		n,m,l;
			lineParser.GetNum(n);
			if (lineParser.GetNum(m)) break;
			if (lineParser.GetNum(l)) break;

			CSimpleSprite s = {0};
			for(int i=n;i<n+l;i++){
				ssprite[i].bFast=false;
				//	́A
				ssprite[i].nHeight = 32;
				//	͂œꂵق悳...
				//	ύXKvȏꍇ́AeLNXŕύX邱
				s.pSurface = m_apSurface[m+i].get();
				{
					int sx,sy;
					s.pSurface->GetSize(sx,sy);
					::SetRect(&s.rcRect,0,0,sx,sy);
				}
//				m_lpSprite[i].SetSpriteAdd(&s);
				(*m_vSpriteVector)[n].push_back(s);
			}
			continue;
		}


		//	XvCgx̋`z̐ݒ
		if ( lineParser.IsMatch( "#Sprite" ) ){
			WARNING(m_vSpriteVector->empty(),"CSpriteChara::LoadSpriteMaxȂ#SpriteL");
			int		n,m;
			lineParser.GetNum(n);
			while (true){
				if (lineParser.GetNum(m)) break;
				ssprite[m].bFast=false;

				//	́A
				ssprite[m].nHeight = 32;
					//	͂œꂵق悳...
					//	ύXKvȏꍇ́AeLNXŕύX邱
				
//				m_lpSprite[n].SetSpriteAdd(&ssprite[m]);
				(*m_vSpriteVector)[n].push_back(ssprite[m]);
			}
			continue;
		}

		// w肵v[pɃXvCgf[^ǂݍ
		if ( lineParser.IsMatch( "#Plane" ) ){
			int		n;
			lineParser.GetNum( n );
			//	śAnew
			while ((int)m_apSurface.size()<=n){
				m_apSurface.insert(CPlane::GetFactory()->CreateInstance());
			}
			string szFile;
			lineParser.GetStr(szFile);
			m_apSurface[n]->Load(szFile);
			continue;
		}

		//	w肵v[p̔FWŎw
		if ( lineParser.IsMatch( "#ColorKeyA" ) ){
			int		n,m;
			lineParser.GetNum( n );
			lineParser.GetNum( m );
			//	śAnew
			//	(Aneŵɑ΂SetColorKey͕sDD)
			while ((int)m_apSurface.size()<=m){
				m_apSurface.insert(CPlane::GetFactory()->CreateInstance());
			}
			int x,y;
			lineParser.GetNum( x );
			lineParser.GetNum( y );
			for(int i=n;i<=m;i++) {
				m_apSurface[i]->SetColorKeyPos(x,y);
			}
			continue;
		}

		//	w肵v[p̔FRGBŎw
		if ( lineParser.IsMatch( "#ColorKeyB" ) ){
			int		n,m;
			lineParser.GetNum( n );
			lineParser.GetNum( m );
			//	śAnew
			while ((int)m_apSurface.size()<=m){
				m_apSurface.insert(CPlane::GetFactory()->CreateInstance());
			}
			int r,g,b;
			lineParser.GetNum( r );
			lineParser.GetNum( g );
			lineParser.GetNum( b );
			for(int i=n;i<=m;i++) {
				m_apSurface[i]->SetColorKey(ISurface::makeRGB(r,g,b));
			}
			continue;
		}

		//	w肵v[p̔FWŎw
		if ( lineParser.IsMatch( "#ColorKey" ) ){
			int		n;
			lineParser.GetNum( n );
			//	śAnew
			while ((int)m_apSurface.size()<=n){
				m_apSurface.insert(CPlane::GetFactory()->CreateInstance());
			}
			int x,y;
			lineParser.GetNum( x );
			lineParser.GetNum( y );
			m_apSurface[n]->SetColorKeyPos(x,y);
			continue;
		}

		//	őv@ (RectOffset > RectA > Rect)
		//	`ab܂łɁA(x,y)̃ItZbg^
		if ( lineParser.IsMatch( "#RectOffset" ) ){
			int		a,b;
			lineParser.GetNum( a );
			lineParser.GetNum( b );
			int		x,y;
			lineParser.GetNum(x);
			lineParser.GetNum(y);
			for(int i=a;i<=b;i++){
				ssprite[i].nOx = x;
				ssprite[i].nOy = y;
			}
			continue;
		}

		//	`aAv[pɑ΂āA(x,y)W~HŉxAcyšJւ`s
		if ( lineParser.IsMatch( "#RectA" ) ){
			int		n;
			lineParser.GetNum( n );
			int		nPlane;
			lineParser.GetNum( nPlane );

			int		x,y,w,h,xt,yt;
			lineParser.GetNum(x);
			lineParser.GetNum(y);
			lineParser.GetNum(w);
			lineParser.GetNum(h);
			lineParser.GetNum(xt);
			lineParser.GetNum(yt);
			for(int j=0;j<yt;j++){
				for(int i=0;i<xt;i++){
					::SetRect( &ssprite[n+i+j*xt].rcRect,x+w*i,y+h*j,x+w*(i+1),y+h*(j+1));
					ssprite[n+i+j*xt].pSurface = m_apSurface[nPlane].get();
				}
			}
			continue;
		}

		//	`aƂăv[p(x,y)W~H̋`Ƃ
		if ( lineParser.IsMatch( "#Rect" ) ){
			int		n;
			lineParser.GetNum( n );
			WARNING(n<0||n>255,"CSpriteChara::Loadn<0||n>255");
			int		nPlane;
			lineParser.GetNum( nPlane );
			int		x,y,sx,sy;
			lineParser.GetNum(x);
			lineParser.GetNum(y);
			lineParser.GetNum(sx);
			lineParser.GetNum(sy);
			::SetRect( &ssprite[n].rcRect,x,y,x+sx,y+sy);
			ssprite[n].pSurface = m_apSurface[nPlane].get();
			continue;
		}

		/*
		//	XvCgs1s2̓C[LƂĒ`ifBtHg5j
		if ( lineParser.IsMatch( "#Layer" ) ){
			int		a,b;
			lineParser.GetNum( a );
			lineParser.GetNum( b );
			int		nLayer;
			lineParser.GetNum(nLayer);
			for(int i=a;i<=b;i++){
				m_lpSprite[i].SetLayer(nLayer);
			}
			continue;
		}
		*/
		if (lineParser.IsMatch("#")){
			Err.Out("CSpriteChara::Load%s%dsɕsȖ",strFileName,nLine);
			return 1;
		}
	}

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////

/*
	XvCg`t@C̃tH[}bg
	E啶͋ʂȂ
	EPs͂QTU܂
	E``256܂
	EXvCgƂ́AA̓iCSimpleSpritej`
	EXvCg`́A`ԂɎw肷邱ƂɂčsȂ
	EesA//ȍ~̓RgƂł
	Ev[͖ɗpł
	E`ƂƂɁÄʒuix[XCjw肷邱Ƃ
	E`ƂƂɁAItZbgw肷邱Ƃ
	EXvCgE`ԍ͂On܂
	#SpriteMax	4			//	XvCg`͂SB͐擪Ŏw肷
	#Plane 0,"test.bmp"		//	v[0Ƃtest.bmpǂݍ
	#ColorKey 0,4,10		//	0Ԃ̃v[̔FʒuŎw肵A(4,10)Ƃ(fBtHg(0,0))
	#Plane 1,"test2.bmp"	//	v[1Ƃtest2.bmpǂݍ
	#Rect 0,1,48,48,64,128	//	`0Ƃăv[1(48,48)W64~H128̋`Ƃ
	#Rect 1,1,112,48,64,128	//	`1Ƃăv[1(112,48)W64~H128̋`Ƃ
	#Sprite 1,0,1,1,0		//	XvCg1͋`0`1`1`0ƂzƂ
	#SpriteF 0,0,1,1,0		//	XvCg0͋`0`1`1`0ƂzƂBF͖


	ˁ@ꊇ`
	#SpritePlane 0,0,34					//	XvCg0`34́Av[035(v[0v[34)ƂB
	#SpritePlaneF 0,0,34				//	XvCg0`34́Av[035(v[0v[34)ƂBF͖
	#ColorKeyA 0,34,4,10				//	0`34̃v[̃J[L[͈ʒuŎw肵A(4,10)Ƃ(fBtHg(0,0))
	#ColorKeyB 0,107,0,255,0			
	//	0-107Ԃ̃v[̔FRGBŎw肵A(0,255,0)Ƃ

//	#SpriteA 0,0,34						//	XvCg0`34́A`035ڂ̋`܂łƂBij

	#RectA	12,0,10,15,32,64,4,3	//	`12`́Av[0ɑ΂AW32~H64̃TCYłA
									//	(10,15)Ɏn܂A4Ac3s12񕪌Jւ
									//	`B܂`12`23܂łCɒ`
	#RectOffset 10,16,5,6	//	`1016܂łɁA(5,6)̃ItZbg^

//	#Layer 1,3,5			//	XvCg13Layer5ƂĒ`ifBtHg5j
//

*/

}} // end of namespace
