//
//	yaneSurface.h
//		T[tF[XNX
//
//	yaneSurface1.cpp c {
//	yaneSurface2.cpp c ʏBltn
//	yaneSurface3.cpp c ʏEffectn
//	yaneSurface4.cpp c [tBOn

#ifndef __yaneSurface_h__
#define __yaneSurface_h__


/////////////////////////////////////////////////////////////////////

namespace yaneuraoGameSDK3rd {
namespace Draw {

class ISurfaceLocker {
/**
	SurfaceLock@\|[tBbNɒ񋟂

	class CSurfaceLockerGuard QƂ̂ƁB
*/
public:
	/**
		̊֐͎ۂconstł͖A]T[tF[Xlock`unlock̂
		]T[tF[XĂ킯ł͂Ȃ̂ŁAT[tF[Xconst
		ۂĂĂƍlBāALock`Unlockconstƍl邱ƂɂB
	*/
	virtual LRESULT Lock() const = 0;
	virtual LRESULT Unlock() const = 0;
	virtual ~ISurfaceLocker(){}
};

class INullSurfaceLocker : public ISurfaceLocker {
///	class ISurfaceLocker  Null Device
public:
	virtual LRESULT Lock() const { return 0; }
	virtual LRESULT Unlock() const { return 0; }
};

class IDisableSurfaceLocker : public ISurfaceLocker {
///	class ISurfaceLocker  Disable Device
/**
	Locks\ił邩mȂjDirectDrawSurface
	vC}T[tF[X́A蓖ĂĂDDƂH
*/
public:
	virtual LRESULT Lock() const { return 1; }
	virtual LRESULT Unlock() const { return 1; }
};

class CSurfaceLockerGuard {
/**
	fXgN^UnlockĂяõIuWFNg
	CSurfaceInfo::GetPixel ŎۂɎgĂ̂ŁA
	QƂ̂ƁB
*/
public:
	CSurfaceLockerGuard(const ISurfaceLocker*pLocker)
		: m_pSurfaceLocker(pLocker) {}
	CSurfaceLockerGuard(const smart_ptr<ISurfaceLocker>& vLocker)
		: m_pSurfaceLocker(vLocker.get()) {}
	~CSurfaceLockerGuard(){ m_pSurfaceLocker->Unlock(); }
private:
	const ISurfaceLocker* m_pSurfaceLocker;
};

/////////////////////////////////////////////////////////////////////

///	ISurfaceRGBDWORD[Ƃ
typedef DWORD ISurfaceRGB;

class ISurface;
class CSurfaceInfo : public ISurfaceLocker {
/**
	LockƂ̃T[tF[Xێ邽߂̍\
	ꉞAclass CSurfaceLockerGuard g悤ɁA
	̃NX́AISurfaceLockerhĂB
*/
public:

	////////////////////////////////////////////////////
	//	֐
	////////////////////////////////////////////////////
	void	Init(void* lpSurfacePtr,LONG lPitch,const SIZE &size
		,int nSurfaceType = 0) {
		m_lpSurface = lpSurfacePtr; m_lPitch = lPitch; m_size = size,
		m_bInit = true, m_nSurfaceType = nSurfaceType;
	}
	/**
		ŗ^̂́Aȉ̂́BiƂłʂɐݒłj
		ɁAlock`unlockɍۂāAɏKvȂ
		SetLockerŁAݒ肷邱ƁB
	
		lpSurfacePtr	:	T[tF[X̃C[Wւ̃|C^
			T[tF[X̃C[W̍̍W̃AhX
		lPitch			:	PC̃oCg
		size			:	SurfacẽTCY
		nSurfaceType	:	T[tF[X̎

		0:	iOnChangeSurface܂ĂяoĂȂ)
		1:	siȉ̈ȊOj

		//	ʏ̃T[tF[X
		2:	8bpp
		3:	16(RGB565)
		4:	16(RGB555)
		5:	24(RGB888)
		6:	24(BGR888)
		7:	32(XRGB8888)
		8:	32(XBGR8888)

		//	T[tF[X
		10:	16+a4(ARGB4565)
		11:	16+a4(ARGB4555)
		12:	32(ARGB8888)
		13:	32(ABGR8888)
	*/

	bool	IsInit() const { return m_bInit; }
	void	SetInit(bool b) { m_bInit = b; }

	////////////////////////////////////////////////////
	//	property...
	////////////////////////////////////////////////////

	///	T[tF[X̍̃|C^̐ݒ^擾
	void*	GetPtr() const { return m_lpSurface; }
	void	SetPtr(void*lpSurface){ m_lpSurface=lpSurface; }

	///	T[tF[X̃X^sb`
	LONG	GetPitch() const { return m_lPitch; }
	void	SetPitch(LONG lPitch) { m_lPitch = lPitch; }

	///	T[tF[X̍L`ݒ^擾
	SIZE	GetSize() const { return m_size; }
	void	SetSize(const SIZE& size) { m_size = size; }

	///	T[tF[X̂PsNZ̃oCg
	int		GetPixelSize() const;

	///	rfIDirectDrawSurfaceLockƂ񂩁H
	///	iVXeDirectDrawSurfaceȂ΁A
	///	𖳎āAړǂݏĂ܂Ij
	bool	IsLocked() const { return m_bLock; }
		///	lockĂ邩H
	void	SetLock(bool bLock) const {
		CSurfaceInfo* pThis = const_cast<CSurfaceInfo*>(this);
		pThis->m_bLock = bLock;
	}
		///	lockĂ邩̏ݒ肷

	///	Lock`Unlock
	///	(QdbNƁACRuntimeException)
	/**
		̊֐͎ۂconstł͖A]T[tF[Xlock`unlock̂
		]T[tF[XĂ킯ł͂Ȃ̂ŁAT[tF[Xconst
		ۂĂĂƍlBāALock`Unlockconstƍl邱ƂɂB
	*/
	virtual LRESULT Lock() const
		#ifdef USE_EXCEPTION
			throw(CRuntimeException)
		#endif
			;
	virtual LRESULT Unlock() const
		#ifdef USE_EXCEPTION
			throw(CRuntimeException)
		#endif
			;

	/**
		^ꂽ`ÃT[tF[XŃNbvāAc`Ԃ
		lpRect==NULLȂ΂̃T[tF[XS
	*/
	RECT	GetClipRect(const LPCRECT lpRect) const;

	///	SurfaceType擾
	int		GetSurfaceType() const { return m_nSurfaceType; }
	void	SetSurfaceType(int n) { m_nSurfaceType = n; }

	///	SurfaceLockerSet/Reset
	smart_ptr<ISurfaceLocker> GetLocker() const { return m_vLocker; }
	void SetLocker(const smart_ptr<ISurfaceLocker>& locker) { m_vLocker = locker; }

	///	J[L[̐ݒ^擾(̃T[tF[XpɃsNZtH[}bgϊ)
	void	SetColorKey(ISurfaceRGB dw){ m_rgbColorKey = dw; }
	ISurfaceRGB	GetColorKey() const { return m_rgbColorKey; }

	///	FillColor̐ݒ^擾(ClearĂяoƂ͂̐FŃNA)
	void	SetFillColor(ISurfaceRGB dw) { m_rgbFillColor = dw; }
	ISurfaceRGB	GetFillColor() const { return m_rgbFillColor; }

	virtual LRESULT Save(const string& strBitmapFileName,LPCRECT lpRect=NULL);
		///	摜̃t@Cւ̏o(lpRect͏öBNULLȂΑS)

	virtual LRESULT SaveYGA(const string& strBitmapFileName,LPCRECT lpRect=NULL,bool bCompress=true);
		///	YGA摜`ł̃t@Co(lpRect͏öBNULLȂΑS)
		///	bCompress==trueȂCLZSSňkĕۑBfBtHgtrue

	CSurfaceInfo(){
		m_bInit			= false; // Ă܂ւInit()Ă͂
		m_bLock			= false;
		m_lpSurface		= NULL;
		m_nSurfaceType	=	0;
		SetLocker(smart_ptr<ISurfaceLocker>(new INullSurfaceLocker));
		//	null lockerdefault
		m_rgbColorKey	=	0;
		m_rgbFillColor	=	0;
	}

	///	ʓIBltter & Effector

	///	--- ėpsNZ(x)
	LRESULT GetPixel(int x,int y,ISurfaceRGB&rgba) const;
	/**
		rgbaŕԂB񃿃T[tF[X̏ꍇArgbaa0ԂB
		T[tF[X͈͊ÔƂ́A0Ԃ
		Lock`UnlocksȂB
	*/

	LRESULT	GetMatchColor(ISurfaceRGB rgb,DWORD& dw) const;
	/**
		FÃT[tF[Xłǂ\邩Ԃ
		񃿃T[tF[X̏ꍇArgb̃l͖
	*/

	enum EBltType {
	///	]̎(T[tF[XT[tF[Xւ̓]ɑ΂ėL)
	/**
		KɂẮAISurface::Blt`̂ƂQƂ邱ƁB
	*/
		eSurfaceBltFast	,			///	ʏBltBF
		eSurfaceBlt		,			///	ʏBltBFL
		eSurfaceBltAddColorFast,	///	FBFB\[XT[tF[XB
		eSurfaceBltSubColorFast,	///	FBFB\[XT[tF[XB
		eSurfaceBltAddColor,		///	FBFL
		eSurfaceBltSubColor,		///	FBFL

		///	ȉ̂S͒ǉp[^pAdditionalParameter[0]Ń(fade)w(0-255)
		eSurfaceBltAddColorFastFade,	///	~ĂFBFB\[XT[tF[XB
		eSurfaceBltSubColorFastFade,	///	~Ă猸FBFB\[XT[tF[XB
		eSurfaceBltAddColorFade,		///	~ĂFBFL
		eSurfaceBltSubColorFade,		///	~Ă猸FBFL

		eSurfaceBltAlphaFast,			///	T[tF[XA񃿁^T[tF[X֓]

		///	ȉ̂R͒ǉp[^pAdditionalParameter[0]Ń(fade)w(0-255)
		eSurfaceBltFastFade,			///	~ĂBltFast
		eSurfaceBltFade,				///	~ĂBlt
		eSurfaceBltAlphaFade,			///	~ĂBltAlpha(]T[tF[X)
		/// 3͓]ƃuhł͂ȂB]͖āAIɓ]~
		///	gƂ͂ȂƎv̂Ŗ

		///	ȉ̂Q͒ǉp[^pAdditionalParameter[0]Ń(fade)w(0-255)
		eSurfaceBlendBltFast,			///	ʏuhBF
		eSurfaceBlendBlt	,			///	ʏuhBFL

		///	ȉ̂Q͒ǉp[^pAdditionalParameter[0],[1]Ń1,2(fade)w(0-255)
		eSurfaceBlendConstBltFast,		///	ʏuhBuhŒBF
		eSurfaceBlendConstBlt	,		///	ʏuhBuhŒBFL

	};

	enum EEffectType {
	///@GtFNg̎(̃T[tF[Xɑ΂ėL)
		///	̃T[tF[XŐݒ肵Ăfillcolor(ISurfaceRGB)ŃNA
		eSurfaceFill	,		///	hԂ

		///	pAdditionalParameter[0]ŁAtF[h[gw(0-255)
		///	255Ȃ100%̈ӖŁAʂɕωȂ
		eSurfaceFade	,		///	ʏFade

		///	pAdditionalParameter[0]ŉF^FISurfaceRGBw
		eSurfaceAddColor,		///	F
		eSurfaceSubColor,		///	F

		eSurfaceFlush,			///	ʂtbVi]j

		/// pAdditionalParameter[0]ŗʎqxw肷
		eSurfaceMosaic,			///	UCN

	};

	struct CBltInfo {
	LPCPOINT	pDstPoint;		///	]W(pDstPoint==NULLȂ΍)
	LPCSIZE		pDstSize;		///	]TCY(pSize==NULLȂΓ{)
	LPCRECT		pSrcRect;		///	]W(pSrcPoint==NULLȂ΃T[tF[XS)
	LPCRECT		pDstClip;		///	]̃Nbv
									///	(͈̔͂͂ݏo͈͂ɂ͕`悳Ȃ)
	int			nBasePoint;		// x[Xʒu
	/**
		ipSrcPointŎw肵Ă̂́A]́Aǂ̓_Ȃ̂Hj
		0: 1:^ 2:E
		3:^ 4: 5:^E
		6: 7:^ 8:E
	*/
	CBltInfo(
		LPCPOINT	_pDstPoint=NULL,
		LPCSIZE		_pDstSize=NULL,
		LPCRECT		_pSrcRect=NULL,
		LPCRECT		_pDstClip=NULL,
		int			_nBasePoint=0
		) : pDstPoint(_pDstPoint),pDstSize(_pDstSize),pSrcRect(_pSrcRect),
			pDstClip(_pDstClip),nBasePoint(_nBasePoint){}
	};

	struct CMorphInfo {
		LPCPOINT lpSrcPoint;	///	]W
		LPCPOINT lpDstPoint;	///	]W
		LPCRECT lpClipRect;		///	]Nbv`
		bool bContinual;		///	Eڑ邩̂悤ɓ]̂
			/// (ׂ荇킹Ƀ[tBO]̌qڂ𒲐)
		int nAngle;				///	point̐BangelBRȂ΂Rp`B

		CMorphInfo(){} // ̏ꍇ́ÂInitĂяoď邱ƁB
		CMorphInfo(
			LPCPOINT _lpSrcPoint,
			LPCPOINT _lpDstPoint,
			LPCRECT _lpClipRect,
			bool _bContinual,
			int _nAngle
		) : lpSrcPoint(_lpSrcPoint),lpDstPoint(_lpDstPoint),
			lpClipRect(_lpClipRect),bContinual(_bContinual),nAngle(_nAngle){}

		void Init(LPCPOINT _lpSrcPoint,LPCPOINT _lpDstPoint,LPCRECT _lpClipRect,bool _bContinual,int _nAngle){
			lpSrcPoint=_lpSrcPoint; lpDstPoint=_lpDstPoint;
			lpClipRect=_lpClipRect; bContinual=_bContinual; nAngle=_nAngle;
		}

	};

	//------------------------------------------------------------------------
	//	invoke - execution ̂߂helper

	static smart_ptr<void> getWrappedPtr(
		CSurfaceInfo::EBltType type, CSurfaceInfo::CBltInfo*& info, DWORD*& pAdditionalParameter);
	//	^ꂽ|C^̒gdeep copyāAsmart_ptr<void>wrapĕԂ
	//	āA^ꂽ|C^̊evf(|C^܂)A
	//	deep copyꂽق̗vfw悤ɂĕԂ

	static smart_ptr<void> getWrappedPtr(
	CSurfaceInfo::EBltType type, CSurfaceInfo::CMorphInfo*& info, DWORD*& pAdditionalParameter);
	//	^ꂽ|C^̒gdeep copyāAsmart_ptr<void>wrapĕԂ
	//	āA^ꂽ|C^̊evf(|C^܂)A
	//	deep copyꂽق̗vfw悤ɂĕԂ

	static smart_ptr<void> getWrappedPtr(
	CSurfaceInfo::EEffectType type, LPCRECT& prc, DWORD*& pAdditionalParameter);
	//	^ꂽ|C^̒gdeep copyāAsmart_ptr<void>wrapĕԂ
	//	āA^ꂽ|C^̊evf(|C^܂)A
	//	deep copyꂽق̗vfw悤ɂĕԂ

	//------------------------------------------------------------------------

	///	]gkpMorph̍\̏p
	///	CMorphInfo\̂AQp[^ȉœnɊÂď
	LRESULT InitRotateParam(CMorphInfo& info,const CSurfaceInfo* lpSrc, int x,int y, int nAngle,int nRate,int nType, LPCRECT lpSrcRect, LPCRECT lpClipDstRect,
		RECT& rcSrc,POINT aSrcPoint[4],POINT aDstPoint[4]);

	/**
		ISurface̓̊֐̉֐

		ŁABltEffect`Ă̂ŁAhNX
		n[hEFAANZ[^ɂē]̂łȂ΁A
		ɈϏ邾œ]B
	*/
	LRESULT GeneralBlt(EBltType type,const CSurfaceInfo*pSrc,const CBltInfo* pInfo,DWORD*pAdditionalParameter=NULL);
	LRESULT GeneralEffect(EEffectType type,LPCRECT prc=NULL,DWORD*pAdditionalParameter=NULL);
	LRESULT GeneralMorph(EBltType type,const CSurfaceInfo*pSrc,const CMorphInfo* pInfo,DWORD*pAdditionalParameter=NULL);

	///----- surfacepiterator --------------------------------------------
	class iterator {
	/**
		T[tF[Xiterator̎g
		CSurfaceInfo::iterator it = GetSurfaceInfo()->begin();
		while (it!=GetSurfaceInfo()->end()){
			it.SetRGB(r,g,b,a);
			it++;
		}
		̋@\ɂAǂȃT[tF[Xɑ΂Ă悤
		sNZ𑀍łixǁj
	*/
	public:
		iterator(const CSurfaceInfo*pInfo,int x=0,int y=0)
			: m_pInfo(pInfo),m_nX(x),m_nY(y) {}

		/**
			RGB̐ݒ^擾
				Lock`Unlock͍sȂȂ̂ł̊OLock`UnlocksȂ
		*/
		void	SetRGB(BYTE r,BYTE g,BYTE b,BYTE a=0);
		void	SetRGB(ISurfaceRGB rgb){
			SetRGB((BYTE)((rgb>>16)&0xff),(BYTE)((rgb>>8)&0xff),(BYTE)(rgb&0xff),(BYTE)((rgb>>24)&0xff));
		}

		ISurfaceRGB	GetRGB() const;
		///	񃿃T[tF[Xɑ΂ẮAl0Zbg

		void inc() { m_nX++; if (m_nX >= GetSurfaceInfo()->GetSize().cx) { m_nX=0; m_nY++; }}
		void dec() { m_nX++; if (m_nX<0) { m_nX=GetSurfaceInfo()->GetSize().cx-1; m_nY--; }}

		iterator& operator++() { inc(); return (*this); }
		iterator operator++(int)
		{ iterator _Tmp = *this; inc(); return (_Tmp); }
		iterator& operator--() { dec(); return (*this); }
		iterator operator--(int)
		{ iterator _Tmp = *this; dec(); return (_Tmp); }
		iterator& operator+=(int _N)
		{ m_nX += _N; int cx = m_pInfo->GetSize().cx;
		  m_nY += m_nX%cx; m_nX %= cx; return (*this); }
		iterator& operator-=(int _N)
		{ m_nX -= _N; if (m_nX<0) { int cx = m_pInfo->GetSize().cx;
			int sy = (-m_nX) % cx; m_nY-=sy; m_nX = (m_nX + sy*cx) % cx; }
			return (*this); }
		iterator operator+(int _N) const
		{iterator _Tmp = *this; return (_Tmp += _N); }
		iterator operator-(int _N) const
		{iterator _Tmp = *this; return (_Tmp -= _N); }

		///	r̂߂̃Iy[^
		bool operator==(const iterator & _X) const
		{ return m_pInfo == _X.m_pInfo && m_nX == _X.m_nX && m_nY == _X.m_nY; }
		bool operator!=(const iterator& _X) const
			{return (!(*this == _X)); }
		bool operator<(const iterator& _X) const
		{return (m_nY < _X.m_nY ||	(m_nY == _X.m_nY && m_nX < _X.m_nX)); }
		bool operator>(const iterator& _X) const
		{return (_X < *this); }
		bool operator<=(const iterator& _X) const
		{return (!(_X < *this)); }
		bool operator>=(const iterator& _X) const
		{return (!(*this < _X)); }

		/// ----	property...

		///	T[tF[X̃|C^̐ݒ^擾
		void SetSurfaceInfo(const CSurfaceInfo*pInfo) { m_pInfo=pInfo; }
		const CSurfaceInfo* GetSurfaceInfo() const { return m_pInfo; }

		///	ݎw肵ĂW̐ݒ^擾
		void	SetXY(int x,int y) { m_nX = x; m_nY = y; }
		void	GetXY(int&x,int&y) { x = m_nX; y = m_nY; }

	protected:
		const CSurfaceInfo* m_pInfo;	//	iterateĂT[tF[X
		int			m_nX,m_nY;	//	wĂꏊ
	};
	iterator begin() const { return iterator(this,0,0); }
	iterator end() const { return iterator(this,0,GetSize().cy); }

private:
	bool	m_bInit;			//	ς݂H
	void*	m_lpSurface;		//	̃T[tF[X̍̃sNZ̃|C^
	LONG	m_lPitch;			//	̃T[tF[X̃sb`
								//	ĩX^[܂ł̃oCgj
	SIZE	m_size;				//	̃T[tF[X̃TCY
	bool	m_bLock;			//	bNH
	int		m_nSurfaceType;		//	T[tF[X̎ނɕێĂ

	///	(ȉ́ÃT[tF[XpɃsNZtH[}bgϊ)
	ISurfaceRGB	m_rgbColorKey;		//	̃T[tF[X̃J[L[
	ISurfaceRGB	m_rgbFillColor;		//	̃T[tF[X̓hԂɎgF

	smart_ptr<ISurfaceLocker> m_vLocker;	//	surfacelock邽߂̃IuWFNg

};

class ISurface {
/**
	Surface̊NXB
		class ISurfaceDefault , class CFastPlane Ql̂ƁB
*/
public:
	///	typedef DWORD ISurfaceRGB;
	///	̃T[tF[Xł́AʂāARGBlŎw肷

	static inline ISurfaceRGB makeRGB(DWORD r,DWORD g,DWORD b,DWORD a=0)
		#ifdef USE_EXCEPTION
			throw(CRuntimeException)
		#endif
	/**
		IPlaneŎg߂RGBsNZl̐
		F	́AARGB8888(DIB32Ǝdl͓)̐
	*/
	{
#ifdef _DEBUG
		if (r>=256 || g>=256 || b>=256 || a>=256){
		#ifdef USE_EXCEPTION
			throw CRuntimeException();
		#else
			r = g = b = a = 0;
		#endif
		}
#endif
		return (a<<24) | (r<<16) | (g<<8) | b ;
	}

	static inline void	getRGB(ISurfaceRGB rgb,BYTE& a,BYTE& r,BYTE& g,BYTE& b)
	/**
		IPlaneŎg߂RGBsNZl̕
		F	ARGB8888(DIB32Ǝdl͓)Ɠ
	*/
	{
		a = (BYTE)((rgb >> 24) & 0xff);
		r = (BYTE)((rgb >> 16) & 0xff);
		g = (BYTE)((rgb >>	8) & 0xff);
		b = (BYTE)((rgb		 ) & 0xff);
	}

	virtual int GetType() const = 0;
	/**
		T[tF[X̃^CvԂ(RTTIǂ)
		0:	Null Device
		1:	CFastPlane
		2:	CDIB32
	*/

	//////////////////////////////////////////////////////////////////////
	///	ėpBltter
	//////////////////////////////////////////////////////////////////////

	virtual LRESULT GeneralBlt(CSurfaceInfo::EBltType type,const CSurfaceInfo*pSrc,const CSurfaceInfo::CBltInfo* pInfo,DWORD*pAdditionalParameter=NULL)
	///	ĉꂽBltter
	/**
		type : ][h(F]ł邾ƂAFł邾Ƃ)
		pSrc : ]CSurfaceInfo
		pInfo: ]p[^
		pAdditionalParameter : ǉŕKvƂȂp[^ւ̃|C^
	*/
	{
		///	Ϗ邾ŗǂƎv
		return GetSurfaceInfo()->GeneralBlt(type,pSrc,pInfo,pAdditionalParameter);
	}

	//////////////////////////////////////////////////////////////////////////
	/// ---- {IBltter͎OɗpӂĂ
	//////////////////////////////////////////////////////////////////////////

	/**
		Bltter̖KF

		j
			MorphBltAlphaFastFade
			(1)	  (2) (3) (4) (5)

			BlendConstBltFast
			(6)	 (7)  (1) (4)

			(1)...Morph...[tBOnł邱ƂӖ
			(2)...Blt.....]֐ł邱ƂӖ
			(3)...Alpha...]alphaT[tF[Xł邱ƂӖ
					ꂪĂȂꍇAalphaT[tF[X
					T|[gĂ邩ǂ́Ã\bhɂ
			(4)...Fast....F͖邱ƂӖ
			(5)...Fade....]̂ƂɃtF[hwł邱ƂӖ
				tF[hij́ABYTE(0-255)Ŏw肵A
				255w肷100%(),0w肷0%
				(̂ƂA]͍ƂĈ)
			(6)...Blend...uhn]ł邱ƂӖB
					]̃sNZƃuhi킹j
					Ƃ64(=25%ȂȂ255~25%=64)w肷΁A
					]25%Ɠ]75%̔䗦ŃuhB
			(7)...Const...uh̔䗦Œł邱ƂӖ
					uh䗦́ABYTE(0-255)ӂƂB
					̂ӂPCQƂ΁A
					]@@]~P{]~Q
				ƂȂBAP{QQTTłȂĂ͂ȂȂ
	*/

	LRESULT Blt(const ISurface*pSrc,int x=0,int y=0,LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
	/**
		FL]
		x,y		 : ]W
		pDstSize : ]TCY(NULLȂΓ{)
		pSrcRect : ]`
		pDstClip : ]NbsO`(͈̔͂ɂ͕`悳Ȃ)
		nBasePoint:]ʒu

		//	class CSurfaceInfo::CBltInfo QƂ̂ƁB
  */
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBlt,pSrc->GetConstSurfaceInfo(),&info);
	}

	///	F]
	LRESULT BltFast(const ISurface*pSrc,int x=0,int y=0,LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
	///	p[^̈Ӗ́ABltƓ
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBltFast,pSrc->GetConstSurfaceInfo(),&info);
	}

	///	F(FȂ)
	///	p[^̈Ӗ́ABltƓ
	///	\[XT[tF[XB
	LRESULT AddColorBltFast(const ISurface*pSrc,int x=0,int y=0,LPCSIZE pDstSize=NULL,
		LPCRECT	 pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBltAddColorFast,pSrc->GetConstSurfaceInfo(),&info);
	}
	///	F(F)
	///	p[^̈Ӗ́ABltƓ
	LRESULT AddColorBlt(const ISurface*pSrc,int x=0,int y=0,LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBltAddColor,pSrc->GetConstSurfaceInfo(),&info);
	}
	///	F(FȂ)
	///	p[^̈Ӗ́ABltƓ
	///	\[XT[tF[XB
	LRESULT SubColorBltFast(const ISurface*pSrc,int x=0,int y=0,LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBltSubColorFast,pSrc->GetConstSurfaceInfo(),&info);
	}
	///	F(F)
	///	p[^̈Ӗ́ABltƓ
	LRESULT SubColorBlt(const ISurface*pSrc,int x=0,int y=0,LPCSIZE pDstSize=NULL,
		LPCRECT	 pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBltSubColor,pSrc->GetConstSurfaceInfo(),&info);
	}

	/// -------- ȉAt̉FB
	///	@alphaDWORDœnĂ邪ABYTE(0-255)ˁB

	///	~F(FȂ)
	///	p[^̈Ӗ́ABltƓ
	///	\[XT[tF[XB
	LRESULT AddColorBltFastFade(const ISurface*pSrc,int x=0,int y=0,DWORD nAlpha=255,
		LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBltAddColorFastFade,pSrc->GetConstSurfaceInfo(),&info,&nAlpha);
	}
	///	~F(F)
	///	p[^̈Ӗ́ABltƓ
	LRESULT AddColorBltFade(const ISurface*pSrc,int x=0,int y=0,DWORD nAlpha=255,
		LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBltAddColorFade,pSrc->GetConstSurfaceInfo(),&info,&nAlpha);
	}
	///	~F(FȂ)
	///	p[^̈Ӗ́ABltƓ
	///	\[XT[tF[XB
	LRESULT SubColorBltFastFade(const ISurface*pSrc,int x=0,int y=0,DWORD nAlpha=255,
		LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBltSubColorFastFade,pSrc->GetConstSurfaceInfo(),&info,&nAlpha);
	}
	///	~F(F)
	///	p[^̈Ӗ́ABltƓ
	LRESULT SubColorBltFade(const ISurface*pSrc,int x=0,int y=0,DWORD nAlpha=255,
		LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBltSubColorFade,pSrc->GetConstSurfaceInfo(),&info,&nAlpha);
	}

	///	T[tF[X̉摜̓]n
	///	p[^̈Ӗ́ABltƓ
	LRESULT BltAlphaFast(const ISurface*pSrc,int x=0,int y=0,LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBltAlphaFast,pSrc->GetConstSurfaceInfo(),&info);
	}

	///	p[^̈Ӗ́ABltƓ
	///	BlendBltFastBltFastFade͓
	LRESULT BlendBltFast(const ISurface*pSrc,int x=0,int y=0,DWORD nAlpha=255,
		LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBlendBltFast,pSrc->GetConstSurfaceInfo(),&info,&nAlpha);
	}
	///	p[^̈Ӗ́ABltƓ
	///	BlendBltBltFade͓
	LRESULT BlendBlt(const ISurface*pSrc,int x=0,int y=0,DWORD nAlpha=255,
		LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBlendBlt,pSrc->GetConstSurfaceInfo(),&info,&nAlpha);
	}
	///	p[^̈Ӗ́ABltƓ
	LRESULT BlendConstBltFast(const ISurface*pSrc,int x=0,int y=0,DWORD nAlpha1=255,DWORD nAlpha2=255,
		LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		DWORD anAlpha[] = { nAlpha1,nAlpha2 };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBlendConstBltFast,pSrc->GetConstSurfaceInfo(),&info,&anAlpha[0]);
	}
	///	p[^̈Ӗ́ABltƓ
	LRESULT BlendConstBlt(const ISurface*pSrc,int x=0,int y=0,DWORD nAlpha1=255,DWORD nAlpha2=255,
		LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0){
		POINT DstPoint = { x , y };
		DWORD anAlpha[] = { nAlpha1,nAlpha2 };
		CSurfaceInfo::CBltInfo info(&DstPoint,pDstSize,pSrcRect,pDstClip,nBasePoint);
		return GeneralBlt(CSurfaceInfo::eSurfaceBlendConstBlt,pSrc->GetConstSurfaceInfo(),&info,&anAlpha[0]);
	}

	/////////////////////////////////////////////////////////////
	///	⏕Bltter

	///	Rȓ](Blt,yga摜ȂBltAlphaFast)
	LRESULT BltNatural(const ISurface* pSrc,int x,int y,LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0) {
		if (!pSrc->IsAlpha()) {
			return Blt(pSrc,x,y,pDstSize,pSrcRect,pDstClip,nBasePoint);
		} else {
			return BltAlphaFast(pSrc,x,y,pDstSize,pSrcRect,pDstClip,nBasePoint);
		}
	}
	LRESULT BltNatural(const ISurface* pSrc,int x,int y,BYTE nFadeRate,LPCSIZE pDstSize=NULL,
		LPCRECT pSrcRect=NULL,LPCRECT	pDstClip=NULL,int nBasePoint=0) {
		if (nFadeRate==255) {
			return BltNatural(pSrc,x,y,pDstSize,pSrcRect,pDstClip,nBasePoint);
		}
		if (!pSrc->IsAlpha()) {
			return BlendBlt(pSrc,x,y,nFadeRate,pDstSize,pSrcRect,pDstClip,nBasePoint);
		} else {
			return BlendBltFast(pSrc,x,y,nFadeRate,pDstSize,pSrcRect,pDstClip,nBasePoint);
		}
	}

	//////////////////////////////////////////////////////////////////////////
	///	--- SurfacẽGtFN^

	virtual LRESULT GeneralEffect(CSurfaceInfo::EEffectType type,LPCRECT prc=NULL,DWORD*pAdditionalParameter=NULL)
	///	ĉꂽEffector
	/**
		type : ][h(ʏFade]ł邾ƂAFł邾Ƃ)
		prc	 : GtFNg`͈(NULLȂΑS)
		pAdditionalParameter : ǉŕKvƂȂp[^ւ̃|C^
			type : eEffectFade Ȃ΁A[0] Fade(BYTE:0-255)
			type : eAddColor,eSubColor Ȃ[0]͂̒萔(ISurfaceRGB)
	*/
	{
		return GetSurfaceInfo()->GeneralEffect(type,prc,pAdditionalParameter);
	}

	//////////////////////////////////////////////////////////////////////////
	/// ---- {Ieffecter͎OɗpӂĂ
	///	́ÃT[tF[Xɑ΂ăGtFNg
	///	LPCRECT prćANULLȂ΃T[tF[XS
	//////////////////////////////////////////////////////////////////////////

	///	tF[h alpha̓tF[h(0-255)
	virtual LRESULT FadeEffect(BYTE alpha,LPCRECT prc=NULL){
		DWORD dw = alpha; // n炵ǁA܂
		return GeneralEffect(CSurfaceInfo::eSurfaceFade,prc,&dw);
	}

	///	F
	virtual LRESULT AddColorFast(ISurfaceRGB c,LPCRECT prc=NULL){
		return GeneralEffect(CSurfaceInfo::eSurfaceAddColor,prc,(DWORD*)&c);

	}

	///	F
	virtual LRESULT SubColorFast(ISurfaceRGB c,LPCRECT prc=NULL){
		return GeneralEffect(CSurfaceInfo::eSurfaceSubColor,prc,(DWORD*)&c);
	}

	///	UCN
	virtual LRESULT MosaicEffect(DWORD nLevel,LPCRECT prc=NULL){
		return GeneralEffect(CSurfaceInfo::eSurfaceMosaic,prc,(DWORD*)&nLevel);
	}

	///	flush
	virtual LRESULT FlushEffect(LPCRECT prc=NULL){
		return GeneralEffect(CSurfaceInfo::eSurfaceFlush,prc);
	}

	//////////////////////////////////////////////////////////////////////////
	///	Rotate

	virtual LRESULT GeneralMorph(CSurfaceInfo::EBltType type,const CSurfaceInfo*pSrc,const CSurfaceInfo::CMorphInfo* pInfo,DWORD*pAdditionalParameter=NULL)
	///	ĉꂽBltter
	/**
		type : ][h(F]ł邾ƂAFł邾Ƃ)
		pSrc : ]CSurfaceInfo
		pInfo: ]p[^
		pAdditionalParameter : ǉŕKvƂȂp[^ւ̃|C^
	*/
	{
		///	Ϗ邾ŗǂƎv
		return GetSurfaceInfo()->GeneralMorph(type,pSrc,pInfo,pAdditionalParameter);
	}

	LRESULT RotateBlt(const ISurface* lpSrc, int x,int y, int nAngle=0,int nRate=1<<16,int nType=0, LPCRECT lpSrcRect=NULL, LPCRECT lpClipDstRect=NULL){
		CSurfaceInfo::CMorphInfo info;
		RECT rcSrc;
		POINT aSrcPoint[4];
		POINT aDstPoint[4];
		if (GetSurfaceInfo()->InitRotateParam(info,lpSrc->GetConstSurfaceInfo(),x,y,nAngle,nRate,nType,lpSrcRect,lpClipDstRect,rcSrc,aSrcPoint,aDstPoint)!=0) return 1;
		return GeneralMorph(CSurfaceInfo::eSurfaceBlt,lpSrc->GetConstSurfaceInfo(), &info);
	}
	LRESULT RotateBltFast(const ISurface* lpSrc, int x,int y, int nAngle=0,int nRate=1<<16,int nType=0, LPCRECT lpSrcRect=NULL, LPCRECT lpClipDstRect=NULL){
		CSurfaceInfo::CMorphInfo info;
		RECT rcSrc;
		POINT aSrcPoint[4];
		POINT aDstPoint[4];
		if (GetSurfaceInfo()->InitRotateParam(info,lpSrc->GetConstSurfaceInfo(),x,y,nAngle,nRate,nType,lpSrcRect,lpClipDstRect,rcSrc,aSrcPoint,aDstPoint)!=0) return 1;
		return GeneralMorph(CSurfaceInfo::eSurfaceBltFast,lpSrc->GetConstSurfaceInfo(), &info);
	}
	LRESULT RotateAlphaBltFast(const ISurface* lpSrc, int x,int y, int nAngle=0,int nRate=1<<16,int nType=0, LPCRECT lpSrcRect=NULL, LPCRECT lpClipDstRect=NULL){
		CSurfaceInfo::CMorphInfo info;
		RECT rcSrc;
		POINT aSrcPoint[4];
		POINT aDstPoint[4];
		if (GetSurfaceInfo()->InitRotateParam(info,lpSrc->GetConstSurfaceInfo(),x,y,nAngle,nRate,nType,lpSrcRect,lpClipDstRect,rcSrc,aSrcPoint,aDstPoint)!=0) return 1;
		return GeneralMorph(CSurfaceInfo::eSurfaceBltAlphaFast,lpSrc->GetConstSurfaceInfo(), &info);
	}

	//////////////////////////////////////////////////////////////////////////
	///	--- SurfaceƂāA펯IɕKvȂ

	///	--- F̐ݒ^擾
	virtual	LRESULT SetColorKey(ISurfaceRGB rgb);
	virtual ISurfaceRGB GetColorKey() const;

	virtual LRESULT SetColorKeyPos(int x,int y);
	///@(x,y)̓_𓧉߃L[ɐݒ肷

	virtual LRESULT SetColorKeyRGB(int r,int g,int b){ return SetColorKey(makeRGB(r,g,b)); }
	///	RGBŔFw肷Brgb͂ꂼ0`255

	///	--- T[tF[X̃TCYݒ^擾
	virtual LRESULT GetSize(int& x,int& y) const =0;
	///		̃T[tF[XȂGetSizéA-1ԂîƂx==y==0j
	virtual LRESULT SetSize(int x,int y)=0;
	/**
		SetSizéA݃TCYƈႤ̂ł΁A炽Create
	*/

	///		T[tF[X̎ނԂ
	virtual int GetSurfaceType() const
	{ return GetConstSurfaceInfo()->GetSurfaceType(); }

	///		T[tF[XǂԂ
	bool	IsAlpha() const { return GetSurfaceType()>=10; }

	///////////////////////////////////////////////////////
	///	T[tF[Xɑ΂ărbg}bvf[^ǂݍ݂
	///	T|[g⏕\bh
	/**
		̃TCY̎w^CṽT[tF[X쐬
		(ɁAIɗp)
		(sx,sy) : T[tF[X̃TCY
		Ŏw肷nTypéA쐬T[tF[X̃^Cv(CSurfaceInfoƓ)
		iō쐬ꂽT[tF[X́ANAȂj
	*/
	virtual LRESULT CreateSurfaceByType(int sx,int sy,int nType)=0;

	/**
		w肳ꂽnTypeŃT[tF[XALCreateSurfaceByTypeō쐬A
		rbg}bvf[^ǂݍށB(YGAΉ)
		YGA摜̂Ƃ́AnTypeŎw肳ꂽ̂T[tF[XŖȂ΁A		IɂɑΉ郿T[tF[Xɂ
	*/
	virtual LRESULT LoadByType(const string& strBitmapName,int nType);

	///	virtual void ClearMSB();
	/*
		rfIJ[h̃oO΍ōŏʃoCgׂ
		(HDCoRXRGB8888,XBGR8888ɓǂݍ񂾂ƂɁANAKv)
		ˁ@OœǂݍނƂɂBǂݍ߂ȂƂ́A24bppDIB쐬
		ǂݍށBāAL̃oỎe͎󂯂Ȃ̂ł̃\bh
		p~
	*/

	///////////////////////////////////////////////////////

	virtual LRESULT		Clear(LPCRECT lpRect=NULL);			///	`NA
	virtual void		SetFillColor(ISurfaceRGB c);		///	ClearFw肷(Default==RGB(0,0,0))
	virtual ISurfaceRGB	GetFillColor() const;				///	ClearF̎擾
		///	˂AtT[tF[Xɑ΂CleaŕA
		///		 == 0ɂȂ邱Ƃۏ؂̂Ƃ
	/**
		ŁAݒ肳ꂽFillColoŕAēxݒ肳܂ŗLB
		fBtHgRGB(0,0,0) Ȃ킿łB
	*/

	///////////////////////////////////////////////////////

	///@--- rbg}bv֘A
	virtual LRESULT Load(const string& strBitmapFileName){
		///	摜̓ǂݍ
		return 0;
	}
	virtual LRESULT Save(const string& strBitmapFileName,LPCRECT lpRect=NULL){
		///	摜̃t@Cւ̏o(lpRect͏öBNULLȂΑS)
		return GetSurfaceInfo()->Save(strBitmapFileName,lpRect);
	}
	virtual LRESULT SaveYGA(const string& strBitmapFileName,LPCRECT lpRect=NULL,bool bCompress=true){
		///	YGA摜`ł̃t@Co(lpRect͏öBNULLȂΑS)
		///	bCompress==trueȂCLZSSňkĕۑBfBtHgtrue
		return GetSurfaceInfo()->SaveYGA(strBitmapFileName,lpRect,bCompress);
	}

	virtual LRESULT	Release(){ return 0; }
	///	ǂݍ񂾉摜̉

	//////////////////////////////////////////////////////////////////////////
	///	T[tF[X
	///	(ꂳ΁A擾ē]邱Ƃo)

		///	gύXȂo[W
	virtual const CSurfaceInfo* GetConstSurfaceInfo() const
	{ return m_vSurfaceInfo.get(); }

		///	gύXo[W
	virtual CSurfaceInfo* GetSurfaceInfo()
	{ return m_vSurfaceInfo.get(); }

	//////////////////////////////////////////////////////////////////////////

	virtual smart_ptr<ISurface> clone()=0;
	/**
		^̃IuWFNg𐶐ĕԂB
		AT[tF[X̓e̓Rs[킯ł͂ȂB
	*/

	ISurface();
	virtual ~ISurface() {}	//	merely place holder

protected:
	///	T[tF[X\
	smart_ptr<CSurfaceInfo>	m_vSurfaceInfo;
	smart_ptr<ISurfaceLocker> m_vSurfacelocker;

	// ---------------------- ߃L[֘A ----------------------------
	//	default(ResetColorKey̓)łm_bUsePosColorKey==true
	//		m_nColorKeyX=m_nColoyKeyY=0
	//	Ȃ킿ÃhbgF
	void	ResetColorKey();
	//	J[L[̃Zbg(T[tF[X̍쐬ɂĂяoƗǂ)
	bool	m_bUsePosColorKey;			//@true:ʒuw^ColorKey
										//	false:Fw^ColorKey
	int		m_nColorKeyX,m_nColorKeyY;	//@ʒuw^@߃J[L[
	ISurfaceRGB m_rgbColorKey;			//	J[L[̐F
	/*
		Aʒuw^̏ꍇÃT[tF[Xł͐F[xsĂ
		{̐FƂ͌Ȃ̂ŁÂƉʂ̐F[x[ƂɁA
		̈ʒuɂsNZ͈قȂFɂȂĂ܂\B
		ʒuw^J[L[̏ꍇɂȂāAT[tF[X̐F[xύX
		ȂƂɁAēxAȉUpdateColorKey\bhĂяoȂĂ
		ȂȂ킯łB
	*/
	LRESULT	UpdateColorKey();	//	ApiIɎgpj


	///	T[tF[XɑΉYGAT[tF[XԂ
	int	GetYGASurfaceType(int nSurfaceType) const;

};	//	Ƃ肠AꂾΏ\OOG

class ISurfaceFactory {
/*
	ISurfacefactory
*/
public:
	virtual smart_ptr<ISurface> CreateInstance() = 0;
	virtual ~ISurfaceFactory(){}
};

/////////////////////////////////////////////////////////////////////////////

class CSurfaceNullDevice : public ISurface {
/**
	class IPlane NullDevice
	vɁAȂBvirtual proxy(smart_ptr<ISurface>)gƂ̂߁B
*/
public:
	virtual LRESULT GeneralBlt(CSurfaceInfo::EBltType type,const CSurfaceInfo* pSrc,
		const CSurfaceInfo::CBltInfo* lpDst,DWORD*pAdditionalParameter=NULL) { return 0; }
	virtual LRESULT GeneralEffect(CSurfaceInfo::EEffectType type,LPCRECT prc=NULL,
		DWORD*pAdditionalParameter=NULL) { return 0; }
	virtual int GetType() const { return 0; }
	virtual LRESULT GetSize(int& x,int& y) const { return 0; }
	virtual LRESULT SetSize(int x,int y) { return 0; }
	virtual	LRESULT SetColorKey(ISurfaceRGB rgb) { return 0; }
	virtual ISurfaceRGB GetColorKey() const { return 0; }
	virtual LRESULT SetColorKeyPos(int x,int y){ return 0; }
	virtual smart_ptr<ISurface> clone() { return smart_ptr<ISurface>(new CSurfaceNullDevice);}
	virtual LRESULT		Clear(LPCRECT lpRect=NULL){ return 0;}
	virtual void		SetFillColor(ISurfaceRGB c) {}
	virtual ISurfaceRGB	GetFillColor() const { return 0;}
	virtual LRESULT CreateSurfaceByType(int sx,int sy,int nType) { return 0; }
};

/////////////////////////////////////////////////////////////////////////////

struct CYGAHeader {
///		YGÃwb_[
	DWORD dwIdentifier;
	DWORD dwSizeX;
	DWORD dwSizeY;
	DWORD bCompress;
	DWORD dwOriginalSize;
	DWORD dwCompressSize;
	CYGAHeader() { dwIdentifier = 0x616779; /* "yga" */ }
};

/////////////////////////////////////////////////////////////////////////////

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif
