//
//		Q[pAėpJE^
//

#ifndef __yaneCounter_h__
#define __yaneCounter_h__


#include "../Auxiliary/yaneSerialize.h"

namespace yaneuraoGameSDK3rd {
namespace Math {

class ICounter;

class ICounterFactory {
/**
	[U[œƎɃJE^(ICounterhNX)pӂꍇA
	GetTypeŁA1000ȏuniqueȐԂ悤ɂāA
	FactoryhNXŁACreateInstanceI[o[ChāA
	̐󂯎ƂɁÃNXnewĕԂ悤ɂāA
	FactoryAICounter::SetFactoryΗǂB

	΁ACProxyCounterɂA̐VJE^
	VACY\ƂȂB
*/
public:
	virtual ICounter* CreateInstance(int n)=0;

	virtual ~ICounterFactory(){}
};

class ICounter : public IArchive {
/**
		JE^p̊NX
*/
public:
	///		intƂ̐ea
	virtual operator int () const=0;
	virtual const int operator = (int n)=0;

	///		Z
	virtual void	Inc()=0;
	virtual void	Dec()=0;

	///		ʒuH
	virtual bool IsBegin() const = 0;
	///		I[ɒB̂H
	virtual bool IsEnd() const = 0;

	virtual int GetType() const = 0;
	static	ICounter* CreateInstance(int nType);
	/**
		蓮RTTI
			CNullCounter		:	0
			CRootCounter		:	1
			CSaturationCounter	:	2
			CInteriorCounter	:	3
		GetTypéAIȌ^ԍŎ擾
		CreateInstancéAԍÃIuWFNg𐶐邽߂factory
		L̔ԍȊOł΁ASetFactoryŐݒ肳ꂽfactorypĐ
	*/
	static	void	SetFactory(const smart_ptr<ICounterFactory>& v)
		{	m_vFactory = v; }
	static	smart_ptr<ICounterFactory>	GetFactory()
		{ return m_vFactory; }

	virtual ~ICounter(){}

protected:
	static	smart_ptr<ICounterFactory> m_vFactory;
};

class CNullCounter : public ICounter {
/**
		class ICounter Null Device
*/
public:
	virtual operator int () const { return 0; }
	virtual const int operator = (int n) { return n; }
	virtual void	Inc() {}
	virtual void	Dec() {}
	virtual bool IsBegin() const { return false;}
	virtual bool IsEnd() const { return false; }
	virtual int GetType() const { return 0; }
	virtual void Serialize(ISerialize&) {}
};

/////////////////////////////////////////////////////////////////////////

class CProxyCounter : public ICounter {
/**
	ICounter̂߂̑㗝B́AfVACŶƂ
	ICounterfactorypāÃIuWFNgČ
*/
public:
	CProxyCounter() : m_vCounter(new CNullCounter) {}
	CProxyCounter(const smart_ptr<ICounter>& p) : m_vCounter(p){}

	///		intƂ̐ea
	virtual operator int () const { return *m_vCounter.get(); }
	virtual const int operator = (int n) { return ((*m_vCounter.get()) = n);}

	///		Z
	virtual void	Inc() { m_vCounter->Inc(); }
	virtual void	Dec() { m_vCounter->Dec(); }

	///		ʒuH
	virtual bool IsBegin() const { return m_vCounter->IsBegin(); }
	///		I[ɒB̂H
	virtual bool IsEnd() const { return m_vCounter->IsEnd(); }

protected:
	smart_ptr<ICounter>	m_vCounter;
	ICounter* GetCounter() { return m_vCounter.get(); }

	//	overriden from IArchive
	virtual void Serialize(ISerialize&);
};

/////////////////////////////////////////////////////////////////////////

class CRootCounter : public ICounter {
/**
	l(nStart)EIl(nEnd)AĕKvȂΑl(nStep)ݒ肵܂B
	̂ƁAInc֐sƁA1܂B(nStepݒ肳Ă΁A
	̐܂)@āAZʁAnEndȏɂȂƎI
	nStartɖ߂܂B(nEndɂ͂Ȃ܂)

	Reset֐́AJE^llnStartɖ߂܂B
	邢́ASetInit֐Reset̏lݒ肳Ă΁A̒lɂ܂B

	܂Aint^Ƃ̑ݕϊ\ł̂ŁAint^̕ϐł邩̂悤
	g܂B

	j
	CRootCounter r;
	r.Set ( 0, 256 , -5 );
	// nStart == 0 , nEnd == 256Ƃ悤ɃJE^ݒ肷
	r = 128;

	̏ԂŁAr++; TsƂTڂ r == 129ɂȂBr--;
	TsƂTڂ r == 127ɂȂB

	܂AnStartnEndłȂėǂ̂łB
	܂AZ( Inc / ++ )ł́AnEndփCNg܂B
	Z( Dec / -- )ł́AnStartփCNg܂B

	܂AStep}CiXłꍇ́A
	̐Βl񐔂Inco֐̌ĂяoɂāA1nEndɐi݂܂B
*/
public:
	///	nStep͈̑̐ΒlB}CiX1/nStep̈Ӗ
	///	nStartnEndłȂėǂ
	void	Set(int nStart,int nEnd,int nStep=1)
		{ m_nStart=nStart; m_nEnd=nEnd; m_nStep=nStep; Reset(); }
	void	SetStep(int nStep) { m_nStep = nStep; }
	void	SetStart(int nStart) { m_nStart = nStart; }
	void	SetEnd(int nEnd) { m_nEnd = nEnd; }

	///	擾
	int		GetStep() const { return m_nStep; }
	int		GetStart() const { return m_nStart; }
	int		GetEnd() const { return m_nEnd; }

	///	JE^̃Zbg
	void	Reset() { m_nRootCount= m_nStart; m_nRate=0; }

	///	property..
	virtual bool	IsBegin() const { return m_nRootCount == m_nStart; }
	virtual bool	IsEnd() const { return m_nRootCount == m_nEnd; }

	CRootCounter();
	CRootCounter(int nEnd);
	CRootCounter(int nStart,int nEnd,int nStep=1);

	//	intƂ̑ݕϊ
	operator int () const { return m_nRootCount; }
	const int operator = (int n) { m_nRootCount = n; return n; }
	int		Get () const { return m_nRootCount; }

	//	JE^̃CNg(I[܂ŒBƁAŒ~)
	void	Inc() { inc(true); }
	void	Dec() { inc(false); }
	//	ZiEndփCNgj^ZiStartւ̃CNgj
	CRootCounter& operator++()
		{ Inc(); return (*this); }
	CRootCounter operator++(int)
		{ CRootCounter _Tmp = *this; Inc(); return (_Tmp); }
	CRootCounter& operator--()
		{ Dec(); return (*this); }
	CRootCounter operator--(int)
		{ CRootCounter _Tmp = *this; Dec(); return (_Tmp); }

	virtual int GetType() const { return 1; }

protected:
	void	inc(bool bAdd=true);

	int		m_nRootCount;
	int		m_nStart;
	int		m_nEnd;
	int		m_nStep;
	int		m_nRate;	//	nStep<0̂Ƃ́AInc()+1

	virtual void Serialize(ISerialize&s) {
		s << m_nRootCount << m_nStart << m_nEnd << m_nStep << m_nRate;
	}
};

class CSaturationCounter : public ICounter {
/**
	OaJE^Bclass CRootCounter ̃oG[VB
	uJE^++ĂAIlɂȂƂɁAŃJE^
	~vƂقȂB
*/
public:
	///	nStep͈̑̐ΒlB}CiX1/nStep̈Ӗ
	///	nStartnEndłȂėǂ
	void	Set(int nStart,int nEnd,int nStep=1)
		{ m_nStart=nStart; m_nEnd=nEnd; m_nStep=nStep; Reset(); }
	void	SetStep(int nStep) { m_nStep = nStep; }
	void	SetStart(int nStart) { m_nStart = nStart; }
	void	SetEnd(int nEnd) { m_nEnd = nEnd; }

	///	擾
	int		GetStep() const { return m_nStep; }
	int		GetStart() const { return m_nStart; }
	int		GetEnd() const { return m_nEnd; }

	///	JE^̃Zbg
	void	Reset() { m_nRootCount= m_nStart; m_nRate=0; }

	///	property..
	virtual bool	IsBegin() const { return m_nRootCount == m_nStart; }
	virtual bool	IsEnd() const { return m_nRootCount == m_nEnd; }

	CSaturationCounter();
	CSaturationCounter(int nEnd);
	CSaturationCounter(int nStart,int nEnd,int nStep=1);

	//	intƂ̑ݕϊ
	operator int () const { return m_nRootCount; }
	const int operator = (int n) { m_nRootCount = n; return n; }
	int		Get () const { return m_nRootCount; }

	//	JE^̃CNg(I[܂ŒBƁAŒ~)
	void	Inc() { inc(true); }
	void	Dec() { inc(false); }
	//	ZiEndփCNgj^ZiStartւ̃CNgj
	CSaturationCounter& operator++()
		{ Inc(); return (*this); }
	CSaturationCounter operator++(int)
		{ CSaturationCounter _Tmp = *this; Inc(); return (_Tmp); }
	CSaturationCounter& operator--()
		{ Dec(); return (*this); }
	CSaturationCounter operator--(int)
		{ CSaturationCounter _Tmp = *this; Dec(); return (_Tmp); }

	virtual int GetType() const { return 2; }

protected:
	void	inc(bool bAdd=true);

	int		m_nRootCount;
	int		m_nStart;
	int		m_nEnd;
	int		m_nStep;
	int		m_nRate;	//	nStep<0̂Ƃ́AInc()+1

	virtual void Serialize(ISerialize&s) {
		s << m_nRootCount << m_nStart << m_nEnd << m_nStep << m_nRate;
	}
};

class CInteriorCounter : public ICounter {
/**
	JE^񋟂܂B

	Seto֐ŁAl(nStart)EIl(nEnd)A
	ĕ(nFrames)ݒ肵܂B

	΁ÃJE^nStartn܂A
	nFrameInco֐̌ĂяoɂnEndɓB悤
	JE^ƂȂ܂B

	܂AInćAoperator++ƂĂ`Ă܂B
	Inc̋tłDecAoperator--ƂĂ`Ă܂B
*/
public:
	CInteriorCounter();

	///	intƂ̑ݕϊ
	virtual operator int () const { return m_nNow; }
	virtual const int operator = (int n) { m_nNow = m_nStart = n; m_nFramesNow = 0; return n; }

	virtual void	Inc();		///	Z
	CInteriorCounter& operator++() { Inc(); return (*this); }
	CInteriorCounter operator++(int) { CInteriorCounter _Tmp = *this; Inc(); return (_Tmp); }

	virtual void	Dec();		///	Z
	CInteriorCounter& operator--() { Dec(); return (*this); }
	CInteriorCounter operator--(int) { CInteriorCounter _Tmp = *this; Dec(); return (_Tmp); }

	void	Set(int nStart,int nEnd,int nFrames);
	/**
		l(nStart)EIl(nEnd)Aĕ(nFrames)ݒ肵܂B
	*/

	///	݂̒liꎞIɁjύXBInc/DecŁAȒlɖ߂
	void	Set(int nNow) { *this = nNow; }

	virtual bool	IsBegin() const { return (m_nNow == m_nStart);}
	virtual bool	IsEnd() const { return (m_nNow == m_nEnd);}

	///	property
	int		GetFrame() const { return m_nFrames; }
	int		GetStart() const { return m_nStart;}
	int		GetEnd() const { return m_nEnd;}
	///		݂̃t[(inc)̎擾B
	int		GetFrameNow() const { return m_nFramesNow; }

	virtual int GetType() const { return 3; }

protected:
	int		m_nNow;			//	݂̒l
	int		m_nStart;		//	l
	int		m_nEnd;			//	Il
	int		m_nFrames;		//	t[iIlɂȂ܂ŉInc΂̂j
	int		m_nFramesNow;	//	݁At[ڂH

	virtual void Serialize(ISerialize&s) {
		s << m_nNow << m_nStart << m_nEnd << m_nFrames << m_nFramesNow;
	}
};

/////////////////////////////////////////////////////////////////////////

} // end of namespace Math
} // end of namespace yaneuraoGameSDK3rd

#endif
