
//
//	Audio Mixer :
//		珑I
//			programmed by yaneurao (M.Isozaki) '02/03/22
//

#include "stdafx.h"
#include "yaneAudioMixer.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

CAudioMixer::CAudioMixer()
{
	m_hMixer = NULL;				//	~LTfoCX̃nh
	m_MixerID = NULL;				//	Lȃ~LTfoCX̎ʎq
	m_dwVol = 0;					//	̃{[ݒ(Abs)
	m_lPan = 0;						//	̃pݒ

	Open();
}

CAudioMixer::~CAudioMixer(){
	Close();
}

//////////////////////////////////////////////////////////////////////////////

LRESULT		CAudioMixer::Open( )
{
	m_bSuccessInit = false;

	if ( Close()!=0 ) return 1;

	if ( ::mixerGetNumDevs() == 0 ) {
		Err.Out( "CAudioMixer::Open ~LTfoCX 0AG[܂" );
		return 2;
	}

	// ~LTfoCXI[v
	MMRESULT	res;
	res = ::mixerOpen( &m_hMixer, m_MixerID, 0, 0, MIXER_OBJECTF_MIXER );
	if ( res != MMSYSERR_NOERROR ) {
		ErrAudioMixer( res, "~LTfoCXI[vł܂ł\n" );		
		return 3;
	}

	//	~LTfoCX擾
	if ( GetMixerDev() != 0 ) return 4;

	//	̃{[𓾂
	for ( int i = 0 ; i < 4 ; i++ ) {
		// ̃~LTRg[𓾂
		if ( GetMixerLineControl( i ) != 0 ) continue;
		// ̃{|ۑ
		int nSize = m_MCD_UnSigned.size();
		if (nSize!=0){
			GetAudioInfo()[i].m_dwOriginalVol.resize(nSize);
			for (int j=0;j<nSize;j++){
				GetAudioInfo()[i].m_dwOriginalVol[j] = m_MCD_UnSigned[j].dwValue;//	̃{[ݒ(`l1)
			}
		} else {
			GetAudioInfo()[i].m_dwOriginalVol.clear();
		}
	}

	//	̎_ŏ
	m_bSuccessInit = true;
	return 0;
}


////////////////////////////////////
//	SetVolumeRel
//	{[̐ݒ()
////////////////////////////////////
LRESULT		CAudioMixer::SetVolumeRel( eAudioMix eDevice, double dRelVolume)
{
	if (!IsSuccessInit()) return -1; // ɎsĂ

	//	̃{[ɑ΂鉹ʂ̐ݒ
	vector<DWORD>	nowVol;

	GetVolumeOrg( eDevice, nowVol );	
	//	̃{[擾

	for(int i=0;i<(int)nowVol.size();i++){
		nowVol[i] = (DWORD)(nowVol[i] * dRelVolume);
	}

	// {[̐ݒ(Ϗ)
	return SetVolumeAbs( eDevice, nowVol);
}


///////////////////////////////////////////////////////////////
//	SetVolumeAbs
//	{[̐ݒ()
///////////////////////////////////////////////////////////////
LRESULT		CAudioMixer::SetVolumeAbs( eAudioMix eDevice, const vector<DWORD>& adwVol)
{
	if (!IsSuccessInit()) return -1; // ɎsĂ

	// ݂̃Rg[̎擾
	if (GetMixerLineControl( eDevice )!=0) return -1;

	for ( DWORD i = 0 ; i < m_MixerLine[eDevice].cChannels ; i++ ){
		DWORD dwVolume;
		if (i < adwVol.size()) {
			dwVolume = adwVol[i];
			if ( dwVolume > 65535 ) dwVolume = 65535;
//			if ( dwVolume < 0 ) dwVolume = 0;	//	Ȃ̂ł肦Ȃ
		} else {
			dwVolume = 0;
		}
		m_MCD_UnSigned[i].dwValue = dwVolume;
	}

	// {[̍XV
	SetMixerControlDetails( eDevice, false );

	return 0;
}


//////////////////////////////////////////
//	GetVolumeRel
//	{[̎擾()
//////////////////////////////////////////
LRESULT		CAudioMixer::GetVolumeRel(eAudioMix eDevice,double &dRelVolume) const {
	if (!IsSuccessInit()) return -1; // ɎsĂ

	// ݂̃{[l̎擾
	vector<DWORD>	nowVol;

	if ( GetVolumeAbs( eDevice, nowVol) != 0 ) return 1;

	//	̃{[ɑ΂鉹ʂ̐ݒ
	vector<DWORD>	orgVol;
	if (GetVolumeOrg( eDevice, orgVol )!=0 ) return 1;

	//	volvƁA݂volv̔䗦ŌvZ
	DWORD dwNow=0;
	{for(int i=0;i<(int)nowVol.size();i++){ dwNow += nowVol[i]; }}
	DWORD dwOrg=0;
	{for(int i=0;i<(int)orgVol.size();i++){ dwOrg += orgVol[i]; }}
	
	if (dwOrg!=0) {	//	̔肢..
		dRelVolume = (dwNow)/(double)(dwOrg);
	} else {
		if (dwNow==0){
			dRelVolume = 0;
		} else {
			dRelVolume = 0xffff;	// infinity..
		}
	}
	return 0;
}


//////////////////////////////////////////
//	GetVolumeAbs
//	{[̎擾()
//////////////////////////////////////////
LRESULT		CAudioMixer::GetVolumeAbs(eAudioMix eDevice,vector<DWORD> &dwVolume) const
{
	if (!IsSuccessInit()) return -1; // ɎsĂ

	if (const_cast<CAudioMixer*>(this)->GetMixerLineControl( eDevice )!=0) return -1;

	int nSize = m_MCD_UnSigned.size();
	if (nSize!=0) {
		dwVolume.resize(nSize);
		for(int i=0;i<nSize;i++){
			dwVolume[i] = m_MCD_UnSigned.get(i)->dwValue;		// ݂̉ʂ𓾂
		}
	} else {
		dwVolume.clear();
	}

	return 0;
}

////////////////////////////////////////
//	GetVolumeOrg
//	̃{[擾
////////////////////////////////////////
LRESULT	CAudioMixer::GetVolumeOrg( eAudioMix eDevice, vector<DWORD> &vol) const
{
	if (!IsSuccessInit()) return -1; // ɎsĂ

	vol = const_cast<CAudioMixer*>(this)->GetAudioInfo()[eDevice].m_dwOriginalVol;
	return 0;
}

////////////////////////////////////////
//	SetVolumeOrg
//	̃{[ɐݒ肷
////////////////////////////////////////
LRESULT	CAudioMixer::SetVolumeOrg(eAudioMix eDevice)
{
	if (!IsSuccessInit()) return -1; // ɎsĂ

	int nLineID = (int)eDevice;
	if ( m_hMixer == NULL ) return 1;
	if (GetMixerLineControl(nLineID)!=0) return 2;

	int nSize = m_MCD_UnSigned.size();
	for(int i=0;i<nSize;i++){
		if ((int)GetAudioInfo()[nLineID].m_dwOriginalVol.size()>i){
			m_MCD_UnSigned[i].dwValue = GetAudioInfo()[nLineID].m_dwOriginalVol[i];
		}
	}
	return SetMixerControlDetails(nLineID,false);
}

////////////////////////////////
//	Close
//	close audio mixer(and retrive volume)
////////////////////////////////
LRESULT		CAudioMixer::Close( ){

	LRESULT lr = 0;

	if ( m_hMixer != NULL ){
		for ( int i = 0 ; i < 4 ; i++ )
			SetVolumeOrg((eAudioMix)i);	//	̃{[lɖ߂

		MMRESULT	res = ::mixerClose ( m_hMixer );								//	~LTfoCX
		if ( res != MMSYSERR_NOERROR ) {
			ErrAudioMixer( res, "~LTfoCX܂ł\n" );
			lr = 1;
		}
	}

	//	~LTRg[̃vpeB擾Aݒł\̂̃
	m_MCD_UnSigned.Delete();
	return lr;
}

//////////////////////////////////////////////
//	GetMixerLineControl
//	I[fBIC̃Rg[𓾂
//////////////////////////////////////////////
LRESULT	CAudioMixer::GetMixerLineControl( int iLineID ){

	// ~LTfoCX̃nh\ߓĂ邩ۂ̔
	if ( m_hMixer == NULL ) {
		Err.Out( "~LTfoCX̃nh܂ł" );
		return 1;
	}

	// iLineIDT|[gĂ邩ۂ̔
	if (! GetAudioInfo()[iLineID].m_bAudioComponent ) {
		Err.Out("%dID̃I[fBI R|[lǵÃTEh{[hɂ̓T|[gĂ܂ł",iLineID);
		return 1;
	}

	return GetMixerLineControl(m_MixerLine[iLineID]);
}

LRESULT CAudioMixer::GetMixerLineControl(MIXERLINE& ml){

	if (ml.cControls<=0) return 1; // 炾߂

	// ~LTRg[ɓϐɃmۂ
	smart_ptr<MIXERCONTROL> pMc;
	pMc.AddArray(ml.cControls);

	// I[fBICRg[̏
	MIXERLINECONTROLS&	mlc =  m_MixerLineControl;
	mlc.cbStruct	= sizeof (MIXERLINECONTROLS);
	mlc.dwLineID	= ml.dwLineID;
	mlc.cControls	= ml.cControls;
	mlc.cbmxctrl	= sizeof (MIXERCONTROL);
	mlc.pamxctrl	= pMc.get();

	// I[fBICRg[𓾂
	MMRESULT	res;
	res = ::mixerGetLineControls( (HMIXEROBJ)m_hMixer, &mlc, MIXER_GETLINECONTROLSF_ALL );
	if ( res != MMSYSERR_NOERROR) {
		ErrAudioMixer( res, "I[fBIC̃Rg[𓾂܂ł\n" );
		return 1;
	}

	bool	bResult = false;
	for (DWORD i = 0 ; i < mlc.cControls ; i++ ){
		if ( pMc[i].dwControlType == MIXERCONTROL_CONTROLTYPE_VOLUME ){

			//	~LTRg[ԏ\̂𓾂
			//	~LTRg[̃vpeB擾Aݒł\̂̃m
			DWORD channels = ml.cChannels;
			if (channels == 0) {
//				Err.Out("%dID̃I[fBI R|[lg̓`l0ł",i);
				continue;
			}

/**
			m_MCD_UnSigned.AddArray(max(channels,2));
			//	channel1ł2ƂĈȂƁAʕۑ̕߂ǂOOG
*/

			m_MCD_UnSigned.AddArray(channels);

			// ~LTRg[ԏ\̂̏
			m_MCD.cbStruct		=	sizeof (MIXERCONTROLDETAILS);
			m_MCD.dwControlID	=	pMc[i].dwControlID;
			m_MCD.cChannels		=	channels;
			m_MCD.cMultipleItems=	pMc[i].cMultipleItems;
			m_MCD.cbDetails		=	sizeof (MIXERCONTROLDETAILS_UNSIGNED);
			m_MCD.paDetails		=	m_MCD_UnSigned.get();

			// ~LTRg[ԏ\̂̎擾
			res = ::mixerGetControlDetails( (HMIXEROBJ)m_hMixer, &m_MCD, MIXER_GETCONTROLDETAILSF_VALUE );
			if ( res != MMSYSERR_NOERROR ) {
//				ErrAudioMixer( res, "~LTRg[ԏ\̂̎擾ł܂ł\n" );
				continue;
			}

			//	悤₭Rs[
			m_MixerControl = pMc[i];
			bResult = true;
			break;
		}
	}

	// sĂ
	if ( !bResult ) {
		Err.Out( "MixerControl\̂Ɋ֘AtI[fBICRg[܂ł" );
		return 1;
	}

	return 0;
} // GetMixerControlDetails


///////////////////////////////////////////////
//	SetMixerControlDetails
//	~LTRg[ԏ\̂𓾂
///////////////////////////////////////////////
LRESULT	CAudioMixer::SetMixerControlDetails( int iLineID, bool bMono )
{
	// ~LTfoCX̃nh\ߓĂ邩ۂ
	if ( m_hMixer == NULL ) {
		Err.Out( "~LTfoCX̃nh܂ł" );
		return 1;
	}
	// iLineIDT|[gĂ邩ۂ̔
	if ( !GetAudioInfo()[iLineID].m_bAudioComponent) {
		Err.Out( iLineID + "ID̃I[fBI R|[lǵÃTEh{[hɂ̓T|[gĂ܂ł" );
		return 1;
	}

	if (m_MCD_UnSigned.size()==0) {
		//	~LT[H(;LEցE`)ް
		return 1;
	}

	// ~LTRg[ԏ\̂̏
	m_MCD.cbStruct		= sizeof (MIXERCONTROLDETAILS);
	m_MCD.dwControlID	= m_MixerControl.dwControlID;
	if ( bMono ) {
		m_MCD.cChannels		=	1;
	} else {
		m_MCD.cChannels		=	m_MixerLine[iLineID].cChannels;
	}
	m_MCD.cMultipleItems	=	m_MixerControl.cMultipleItems;
	m_MCD.cbDetails			=	sizeof (MIXERCONTROLDETAILS_UNSIGNED);
	m_MCD.paDetails			=	m_MCD_UnSigned.get();

	// ~LTRg[ԏ\̂̎擾
	MMRESULT	res;
	res = ::mixerSetControlDetails( (HMIXEROBJ)m_hMixer, &m_MCD, MIXER_GETCONTROLDETAILSF_VALUE );
	if ( res != MMSYSERR_NOERROR ){
		ErrAudioMixer( res, "~LTRg[ԏ\̂̎擾ł܂ł\n" );
		return 1;
	}

	return 0;
} // SetMixerControlDetails


/////////////////////////////////////////// Private /////////////////////////////////////////
//////////////////////////////
//private for Open
//	GetMixerDev
//	~LTfoCX擾
//////////////////////////////
LRESULT	CAudioMixer::GetMixerDev( )
{
	// ~LTfoCX̏𓾂
	MMRESULT	res;
	res = ::mixerGetDevCaps( (UINT)m_MixerID, &m_MixerCaps, sizeof (m_MixerCaps) );
	if ( res != MMSYSERR_NOERROR ) {
		ErrAudioMixer( res, "~LTfoCX𓾂܂ł\n" );
		return 1;
	}

	for (DWORD i = 0 ; i < m_MixerCaps.cDestinations ; i++ )
	{
		// ~LTfoCX̃fBXeBl\VA\[X𓾂
		MIXERLINE	ml = { sizeof(ml) };		//	I[fBICԂƃgbNX񂪓\
		// ~LTfoCX̃fBXeBl\V𓾂
		ml.dwDestination = i;

		res = ::mixerGetLineInfo( (HMIXEROBJ)m_hMixer, &ml, MIXER_GETLINEINFOF_DESTINATION );
		if ( res != MMSYSERR_NOERROR ) {
			ErrAudioMixer( res, "~LTfoCX̃fBXeBl\V𓾂܂ł\n" );
			return 1;
		}
		//	GetfBXeBl[VAI[fBIo͂ɑ΂R|[lgۂ
		//	肷(wbhzɓ)
		if ( ml.dwComponentType == MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ) {

			//	bug-fixed '00/09/13
			//	́ACo͂ł̂𒲂ׂāACo͂łȂ΁A擾
			if (GetMixerLineControl(ml)!=0) continue;	//	ȓz͎iȂIOOG

			m_MixerLine[0] = ml;
			GetAudioInfo()[0].m_bAudioComponent = true;
			///	ꂪ}X^[H[ɈႢ

			DWORD	iDstConnect = ml.cConnections;
			// ~LTfoCX̃\[X𓾂
			for (DWORD j = 0 ; j < iDstConnect ; j++ )
			{
				ml.cbStruct = sizeof (ml);
				ml.dwDestination = i;
				ml.dwSource = j;
				res = ::mixerGetLineInfo( (HMIXEROBJ)m_hMixer, &ml, MIXER_GETLINEINFOF_SOURCE );
				if ( res != MMSYSERR_NOERROR ) {
					ErrAudioMixer( res, "~LTfoCX̃\[X𓾂܂ł\n" );
					return 1;
				}
				int nLineNo=0;
				switch (ml.dwComponentType) {
				case MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT:
					nLineNo = 1; break;
				case MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER:
					nLineNo = 2; break;
				case MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC:
					nLineNo = 3; break;
				}

				//	ŏɎ擾Ƃ납㏑͏oȂ悤ɂ '00/09/13				//	ˁ@{́A
				//	̃TEhJ[hT|[gȂ΂ȂȂ̂ł́DD

				if (nLineNo!=0 && !GetAudioInfo()[nLineNo].m_bAudioComponent
					&& GetMixerLineControl(ml)==0) {
					m_MixerLine[nLineNo] = ml;
					GetAudioInfo()[nLineNo].m_bAudioComponent = true;
				}
			}
		}
	}
	return 0;
} // GetMixerDev

LRESULT	CAudioMixer::RestoreVolume(eAudioMix eDevice){
	vector<DWORD> adwVol;
	if (GetVolumeAbs(eDevice,adwVol)!=0){
		return 1;
	}
	GetAudioInfo()[eDevice].m_dwOriginalVol = adwVol;
	//	H[ʂƂăRs[I
	return 0;
}

/////////////////////////////////////
//	ErrAudioMixer
//	I[fBI~LT̃G[
/////////////////////////////////////
void	CAudioMixer::ErrAudioMixer( MMRESULT AMErr, LPCSTR strBuf )
{
	switch ( AMErr )
	{
		case MMSYSERR_NOERROR:
			Err.Out( "CAudioMixer::HNOERRORԂĂ܂" );
			break;
		case MMSYSERR_INVALHANDLE:
			Err.Out( "CAudioMixer::w肵foCXnhsł" );
			break;
		case MIXERR_INVALCONTROL:
			Err.Out( "CAudioMixer::Rg[̎QƂsł" );
			break;
		case MMSYSERR_BADDEVICEID:
			Err.Out( "CAudioMixer::foCXʎqs܂͗L͈͊Oł" );
			break;
		case MMSYSERR_INVALFLAG:
			Err.Out( "CAudioMixer::tO̎w肪sł" );
			break;
		case MMSYSERR_INVALPARAM:
			Err.Out( "CAudioMixer::AhXsł" );
			break;
		case MMSYSERR_NODRIVER:
			Err.Out( "CAudioMixer::foCXhCo݂܂ł" );
			break;
		case MMSYSERR_ALLOCATED:
			Err.Out( "CAudioMixer::w肵\[X́Aő勖ẽNCAgɂłɊ蓖ĂĂ܂" );
			break;
		case MMSYSERR_NOMEM:
			Err.Out( "CAudioMixer::Kvȃ蓖Ă邱Ƃł܂ł" );
			break;

		default:
			Err.Out( "CAudioMixer::s̃G[N܂" );
			break;
	}
	Err.Out( strBuf );
} // ErrAudioMixer

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd
