// yaneCDDA.h
//	CDDA wrapper
//
//		programmed by yaneurao(M.Isozaki) '99/07/08
//

#ifndef __yaneCDDA_h__
#define __yaneCDDA_h__


#include "../Window/yaneWinHook.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

struct CDDAInfo {
/**
	CDDÃgbNi[邽߂̍\
	class CCDDA Ŏg܂
*/
	DWORD	m_dwSongLength;	//	Ȃ̒i̔z[0]͑SȂ̒)
	DWORD	m_dwSongStart;	//	Ȃ̊Jn|WV
};

class ICDDA {
public:
	virtual LRESULT	Open(const string& strDriveName="")=0;
	virtual LRESULT	Close()=0;
	virtual LRESULT	Stop()=0;
	virtual LRESULT	Pause()=0;
	virtual LRESULT	Replay()=0;
	virtual LRESULT Play()=0;
	virtual int		GetPlayTrack()=0;

	virtual LRESULT PlayPrev(bool bEndless=true)=0;
	virtual LRESULT PlayNext(bool bEndless=true)=0;

	virtual LRESULT Play(int)=0;
	virtual LRESULT Play(int,int)=0;

	virtual LRESULT	GetCurrentPos(DWORD &dw)=0;

	virtual LRESULT PlayPosToPos(DWORD,DWORD,bool bReplay=false)=0;
	virtual LRESULT PlayPosToTrack(DWORD dwPos,bool bReplay=false)=0;
	virtual LRESULT PlayDWToEnd(DWORD dwPos,bool bReplay=false)=0;
	virtual void	SetStartPos(DWORD dw)=0;
	virtual bool	IsPlay() const=0;
	virtual void	SetLoopMode(bool bLoop)=0;
	virtual int		GetTrackMax()=0;
	virtual LRESULT	Eject(bool bEject)=0;
	virtual bool	IsOpen() const=0;
	virtual LRESULT ConvertToMealTime(DWORD dwPos,int& nTrack,int&nHour,int&nMin,int&nSec,int&nMS)=0;
	virtual LRESULT ConvertFromMealTime(DWORD& dwPos,int nTrack,int nHour,int nMin,int nSec,int nMS)=0;
	virtual vector <CDDAInfo>*	GetTrackInfo()=0;

	virtual ~ICDDA(){}
};

class CCDDA : public IWinHook , public ICDDA {
/**
	CDĐ̂߂̃R|[lgB
	}`hCułCDĐT|[gĂ܂B

	OpenƂPlayŒڍĐ邱Ƃo܂B
	Open郁bǵAȐEȒ
	GetTrackInfo()@XV邱ƁB

	bc]ăX^oĈPlayĂяo
	Đ̎ԂPbقǒZkł邱ƂłB

	CCDDÃRXgN^ɐsăEBhDĂKv̂ŁA
	class CAppFrame Ŏgp悤ɂĂB
*/
public:

	LRESULT	Open(const string& strDriveName="");
	///		CDBĂяoCD:p
	///		hCu̎woBjOpen("g"); // G Drive

	LRESULT	Close();
	///	CDgpIBCD̉]͎~܂B

	//////////////////////////////////////////////////////////////////

	LRESULT	Stop();			///	Đ~
	LRESULT	Pause();		///	Pause
	LRESULT	Replay();		///	Pauseł~Ă̂ĊJ

	LRESULT Play();			///	Đ

	int		GetPlayTrack();	
	///	ݍĐ̃gbNԂ

	LRESULT PlayPrev(bool bEndless=true);	///	ÕgbNĐ
	LRESULT PlayNext(bool bEndless=true);	///	̃gbNĐ

	LRESULT Play(int);			///	gbNԍIčĐ
	LRESULT Play(int,int);		///	QgbNԂ̍Đ

	LRESULT	GetCurrentPos(DWORD &dw);
	/**
	݂̍Đ|WV𓾂[MSF:Multimedia Sound Format]
	MSF`Ƃ́Ah: m: s:b f:t[(ZN^)ŕ\`łB
	*.cdał́Aʂf/s/m/h̏ŁAePoCgŕ\Ă܂B
	*/

	LRESULT PlayPosToPos(DWORD,DWORD,bool bReplay=false);
	/// Q|WVԂ̍Đ
	LRESULT PlayPosToTrack(DWORD dwPos,bool bReplay=false);
	/// ʒuw肵āA炻̃gbN݂̂ĐB
	LRESULT PlayDWToEnd(DWORD dwPos,bool bReplay=false);
	/// ʒuw肵āAIgbN̍Ō܂ōĐ
	/**
		LRPlay֐ŁAbReplay==trueɂƂ́A
		[vvĈƂɁASetStartPosŐݒ肵ꏊɖ߂
	*/
	void	SetStartPos(DWORD dw){
		m_nStartPos = dw;
	}

	bool	IsPlay() const;
	///	tȂ̂H

	void	SetLoopMode(bool bLoop);
	///	[vōĐ邩(default:false)

	int		GetTrackMax();
	///	Ȑ̎擾(OpenĂ邱ƂKv)

	LRESULT	Eject(bool bEject);
	///	CDEjectsȂB

	bool	IsOpen() const { return m_bOpen;}
	///	CDopenĂ邩

	virtual LRESULT ConvertToMealTime(DWORD dwPos,int& nTrack,int&nHour,int&nMin,int&nSec,int&nMS);
	virtual LRESULT ConvertFromMealTime(DWORD& dwPos,int nTrack,int nHour,int nMin,int nSec,int nMS);
	/**
		class CSoundBase ConvertToMealTime/ConvertFromMealTime
		dl̂́BAłtrackwł邱ƁA
		ă|WVƂĎĝ́A[ms]Pʂł͂Ȃ[MSF]
		邱ƂႤB

		CCDDA::GetCurrentPosŎ擾l̂܂܂̊֐ŕϊA
		gbNԍ{bтϊlPlay(DWORD,DWORD)ŁA
		̂܂܂̈ʒuĐłB
	*/

	//////////////////////////////////////////////////////////////////

	///	gbN̎擾
	vector <CDDAInfo>*	GetTrackInfo(){ return &m_aTrackInfo; }
	/**
		SȒ GetTrackInfo()[0].m_dwSongLength
		GetTrackInfo()[1].m_dwSongLength
			// 1gbNڂ̒
		GetTrackInfo()[1].m_dwSongStart
			// 1gbNڂ̃X^[g|WV[msf]
		GetTrackInfo()->rbegin()->m_dwSongStart
			//	Ō̃gbN̏I|WV[msf]
	*/

	//////////////////////////////////////////////////////////////////

	CCDDA();
	virtual ~CCDDA();

//////////////////////////////////////////////////////////////////////////////
protected:
	HWND	m_hWnd;			//	MM_MCINOTIFYʒm
	UINT	m_uDeviceID;	//	CD̃foCXID
	bool	m_bOpen;		//	I[vH(̊ԁAbc͉ςȂ)

	bool	m_bLoopPlay;	//	LoopĐ̂H
	DWORD	m_nStartPos;	//	LoopĐ̊Jnʒu
	DWORD	m_nEndPos;		//	LoopĐ̏Iʒu
	LRESULT	LoopPlay();		//	LoopPlayp

	DWORD	m_nPausePos;	//	Pause|WV
	int		m_bPaused;		//	PauseȂ̂H
	bool	m_bNowPlay;		//	PlayȂ̂H
	string	m_strDriveName;	//	hCu

	//	gbN
	vector <CDDAInfo>	m_aTrackInfo;

	LONG ConvertToSecond(DWORD dwPos);	// [MSF] -> [Sec]
	
	LRESULT PlayDW2(DWORD,DWORD,bool bReplay=false); // Q|WVԂ̍Đ

	// override from CWinHook
	LRESULT WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif
