#include "stdafx.h"
#include "../Multimedia/yaneDirectSound.h"
#include "../Multimedia/yaneSoundParameter.h"
#include "../Multimedia/yaneSoundBuffer.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

//////////////////////////////////////////////////////////////////////////////

// CDirectSoundBuffer
CDirectSoundBuffer::CDirectSoundBuffer(CDirectSound* p) : m_lpDirectSound(p)
{
	m_lpBuffer = NULL;
}

CDirectSoundBuffer::~CDirectSoundBuffer()
{
	RELEASE_SAFE(m_lpBuffer);
}

LRESULT CDirectSoundBuffer::GetStatus() const
{
	// obt@
	if ( !GetBuffer() ) return 0;

	DWORD dwStatus;
	GetBuffer()->GetStatus(&dwStatus);

	// XgĂ
	if ( dwStatus & DSBSTATUS_BUFFERLOST ) return 1;
	// Đ
	ef ( dwStatus & DSBSTATUS_PLAYING ) return 3;

	// ~܂Ă܂
	return 2;
}

LRESULT CDirectSoundBuffer::Lock(DWORD dwWriteCursor, DWORD dwLockBytes, BYTE** lplpLockedBuffer1, DWORD* lpdwLockedBytes1, BYTE** lplpLockedBuffer2/*=NULL*/, DWORD* lpdwLockedBytes2/*=NULL*/)
{
	// obt@
	if (!GetBuffer()) return 1;

	// DirectSoundobt@Lock
	HRESULT hr = GetBuffer()->Lock(dwWriteCursor, dwLockBytes,
									(void**)lplpLockedBuffer1, lpdwLockedBytes1,
									(void**)lplpLockedBuffer2, lpdwLockedBytes2, 0);
	// ́ÁAs邱Ƃ͑XL̂:p
	if ( hr==DSERR_BUFFERLOST ) {
		GetBuffer()->Restore(); // ŃIbP!i΁j
		hr = GetBuffer()->Lock(dwWriteCursor, dwLockBytes, 
								(void**)lplpLockedBuffer1, lpdwLockedBytes1,
								(void**)lplpLockedBuffer2, lpdwLockedBytes2, 0);
		// ŁAgĆII
	}

	if ( hr!=DS_OK ) {
		// Ń_ȂÂႤH
		return 2;
	}

	return 0;
}

LRESULT CDirectSoundBuffer::Unlock(BYTE* lpLockedBuffer1, DWORD dwLockedBytes1, BYTE* lpLockedBuffer2/*=NULL*/, DWORD dwLockedBytes2/*=0*/)
{
	// obt@
	if ( !GetBuffer() ) return 1;

	// DirectSoundobt@Unlock...
	if ( DS_OK!=GetBuffer()->Unlock(lpLockedBuffer1, dwLockedBytes1, lpLockedBuffer2, dwLockedBytes2) ) {
		// Ȃӂ[As邩...ǂȂ[[񂶂
		return 2;
	}

	return 0;
}

LRESULT CDirectSoundBuffer::Play(bool bLoop/*=false*/)
{
	// obt@
	if (!GetBuffer()) return 1;
	HRESULT hr = GetBuffer()->Play(0, 0, ((bLoop) ? DSBPLAY_LOOPING : 0));

	// ́[AXgĂ
	if (hr==DSERR_BUFFERLOST) return 2;

	if (hr!=DS_OK) return 3;
	return 0;
}

LRESULT CDirectSoundBuffer::Stop()
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->Stop()) return 2;
	return 0;
}

LRESULT CDirectSoundBuffer::Restore()
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->Restore()) return 2;
	return 0;
}

LRESULT CDirectSoundBuffer::SetFormat(LPCWAVEFORMATEX lpFormat)
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->SetFormat(lpFormat)) return 2;
	return 0;
}

LRESULT CDirectSoundBuffer::GetFormat(LPWAVEFORMATEX lpFormat) const
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->GetFormat(lpFormat, sizeof(WAVEFORMATEX), NULL)) return 2;
	return 0;
}

LRESULT CDirectSoundBuffer::SetCurrentPosition(DWORD dwPlayCursor)
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->SetCurrentPosition(dwPlayCursor)) return 2;
	return 0;
}

LRESULT CDirectSoundBuffer::GetCurrentPosition(DWORD& dwPlayCursor, DWORD& dwWriteCursor) const
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->GetCurrentPosition(&dwPlayCursor, &dwWriteCursor)) return 2;
	return 0;
}

LRESULT CDirectSoundBuffer::SetVolume(LONG lVolume)
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->SetVolume(lVolume)) return 2;
	return 0;
}

LRESULT CDirectSoundBuffer::GetVolume(LONG& lVolume) const
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->GetVolume(&lVolume)) return 2;
	return 0;
}

LRESULT CDirectSoundBuffer::SetPan(LONG lPan)
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->SetPan(lPan)) return 2;
	return 0;
}

LRESULT CDirectSoundBuffer::GetPan(LONG& lPan) const
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->GetPan(&lPan)) return 2;
	return 0;
}

LRESULT CDirectSoundBuffer::SetFrequency(DWORD dwFrequency)
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->SetFrequency(dwFrequency)) return 2;
	return 0;
}

LRESULT CDirectSoundBuffer::GetFrequency(DWORD& dwFrequency) const
{
	// obt@
	if (!GetBuffer()) return 1;
	if (DS_OK!=GetBuffer()->GetFrequency(&dwFrequency)) return 2;
	return 0;
}


// CDirectSoundPrimaryBuffer
LRESULT CDirectSoundPrimaryBuffer::Create(LPCWAVEFORMATEX lpWFormat, DWORD dwSize, bool bZeroClear/*=false*/, const CSoundParameter* pParam/*=NULL*/)
{
	DSBUFFERDESC dsbdDesc = { sizeof(DSBUFFERDESC) };
	// vC}
	dsbdDesc.dwFlags = DSBCAPS_PRIMARYBUFFER;

	// obt@[
	HRESULT ret = GetDirectSound()->Get()->CreateSoundBuffer(&dsbdDesc, &m_lpBuffer, NULL);

	// s[(;LD`)
	if ( ret!=DS_OK||!GetBuffer() ) return 1;

	return 0;
}


// CDirectSoundSeconderyBuffer
LRESULT CDirectSoundSeconderyBuffer::Create(LPCWAVEFORMATEX lpWFormat, DWORD dwSize, bool bZeroClear/*=false*/, const CSoundParameter* pParam/*=NULL*/)
{
	DSBUFFERDESC dsbdDesc = { sizeof(DSBUFFERDESC) };
	//	ftHgŃ{[Rg[\͂
	dsbdDesc.dwFlags = DSBCAPS_CTRLVOLUME | DSBCAPS_LOCSOFTWARE/* | DSBCAPS_GETCURRENTPOSITION2*/;
	//	O[otH[JXH
	if ( pParam&&pParam->IsGlobalFocus() ) dsbdDesc.dwFlags |= DSBCAPS_GLOBALFOCUS;
	//	pRg[H
	if ( pParam&&pParam->IsPanControl() ) dsbdDesc.dwFlags |= DSBCAPS_CTRLPAN;
	//	gRg[H
	if ( pParam&&pParam->IsFrequencyControl() ) dsbdDesc.dwFlags |= DSBCAPS_CTRLFREQUENCY;

	//	LPWAVEFORMATEXƃTCYw肷
	dsbdDesc.lpwfxFormat = const_cast<LPWAVEFORMATEX>( lpWFormat );
	dsbdDesc.dwBufferBytes = dwSize;

	//	obt@[
	HRESULT ret = GetDirectSound()->Get()->CreateSoundBuffer(&dsbdDesc, &m_lpBuffer, NULL);
	if ( ret!=DS_OK||!GetBuffer() ) return 1;	//	s[(;LD`)

	//	[NA
	if ( bZeroClear ) {
		BYTE* lpBuf = NULL;
		DWORD dwLockedSize = dsbdDesc.dwBufferBytes;
		ret = GetBuffer()->Lock(0, dwLockedSize, (void**)&lpBuf, &dwLockedSize, NULL, NULL, 0);
		if ( ret!=DS_OK ) return 2;		//	s[(;LD`)
		memset(lpBuf, 0, dwLockedSize);
		ret = GetBuffer()->Unlock(lpBuf, dwLockedSize, NULL, NULL);
		if ( ret!=DS_OK ) return 3;		//	s[(;LD`)
	}

	return 0;
}

smart_ptr<ISoundBuffer> CDirectSoundSeconderyBuffer::Clone()
{
	smart_ptr<CDirectSoundSeconderyBuffer> pNewBuffer(new CDirectSoundSeconderyBuffer(GetDirectSound()));

	//	DirectSoundDuplicateĂ炤
	HRESULT ret = GetDirectSound()->Get()->DuplicateSoundBuffer(GetBuffer(), &(pNewBuffer->m_lpBuffer));

	//	܂ƂĂ邩ȁH
	if ( ret==DS_OK&&pNewBuffer->GetBuffer()!=NULL ) {
		smart_ptr<ISoundBuffer> tmp;
		tmp.UpCast(pNewBuffer);
		return tmp;
	}

	//	s[(;LD`)
	return smart_ptr<ISoundBuffer>(new CNullSoundBuffer);
}

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd
