// yaneSoundBuffer.h
//		programmed by ENRA		'02/03/23

#ifndef __yaneSoundBuffer_h__
#define __yaneSoundBuffer_h__


namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class CSoundParameter;
class ISoundBuffer {
/**
	SoundBuffer𒊏ۉC^[tF[XNX
	class CDirectSoundBuffer, class CNullSoundBuffer ͂h
*/
public:
	ISoundBuffer(){};
	virtual ~ISoundBuffer(){};

	virtual int GetType() const = 0;
	/**
		RTTIǂBhNX̃^CvԂ
		0 : class CNullSoundBuffer
		1 : class CDirectSoundBuffer
		2 : 񂪂イ
	*/

	/// obt@쐬
	/// [in] lpWFormat @- WAVEFORMATEXւ̃|C^w肷
	/// [in] dwLockBytes - obt@̃TCYw肷
	/// [in] bZeroClear@- obt@̒g[NA邩ǂ
	/// [in] pParam@@@- CSoundParameterւ̃|C^w肷
	virtual LRESULT Create(LPCWAVEFORMATEX lpWFormat, DWORD dwSize, bool bZeroClear=false, const CSoundParameter* pParam=NULL) = 0;

	/// ̕Ԃ
	virtual smart_ptr<ISoundBuffer> Clone() = 0;

	/// obt@݂̌̏Ԃ𓾂
	/// @0 - obt@
	/// @1 - obt@XgĂ
	/// @2 - ~
	/// @3 - Đ
	virtual LRESULT GetStatus() const = 0;

	/// obt@̃tH[}bgWAVEFORMATEXƂāAݒE擾
	virtual LRESULT SetFormat(LPCWAVEFORMATEX lpFormat) = 0;
	virtual LRESULT GetFormat(LPWAVEFORMATEX lpFormat) const = 0;

	/// obt@̍Đ|WVݒE擾
	/// [in/out] dwPlayCursor@- Đʒuw肷/ĐʒuԂ
	/// [out]@@dwWriteCursor - ݈ʒuԂ
	virtual LRESULT SetCurrentPosition(DWORD dwPlayCursor) = 0;
	virtual LRESULT GetCurrentPosition(DWORD& dwPlayCursor, DWORD& dwWriteCursor) const = 0;

	/// obt@̃{[ݒE擾
	/// [in/out] lVolume - {[l(0`-10000)
	virtual LRESULT SetVolume(LONG lVolume) = 0;
	virtual LRESULT GetVolume(LONG& lVolume) const = 0;

	/// obt@̃pݒE擾
	/// [in/out] lPan - pl(-100000`+10000)
	virtual LRESULT SetPan(LONG lPan) = 0;
	virtual LRESULT GetPan(LONG& lPan) const = 0;

	/// obt@̍ĐgݒE擾
	/// [in/out] dwFrequency - gl(100`100000)
	virtual LRESULT SetFrequency(DWORD dwFrequency) = 0;
	virtual LRESULT GetFrequency(DWORD& dwFrequency) const = 0;

	/// obt@LockEUnlock
	/// [in]@dwWriteCursor @- Lockʒuw肷
	/// [in]@dwLockBytes @@- LockTCYw肷
	/// [out] lpLockedBuffer1 - Lockꂽobt@ւ̃|C^Ԃ
	/// [out] dwLockedBytes1@- LockꂽTCYԂ
	/// [out] lpLockedBuffer2 - Lock̈悪obt@݂̈͂łꍇAobt@擪ւ̃|C^Ԃ
	/// [out] dwLockedBytes2@- ͂ݏö̗̃TCYԂ
	virtual LRESULT Lock(DWORD dwWriteCursor, DWORD dwLockBytes, BYTE** lplpLockedBuffer1, DWORD* lpdwLockedBytes1, BYTE** lplpLockedBuffer2=NULL, DWORD* lpdwLockedBytes2=NULL) = 0;
	virtual LRESULT Unlock(BYTE* lpLockedBuffer1, DWORD dwLockedBytes1, BYTE* lpLockedBuffer=NULL, DWORD dwLockedBytes2=0) = 0;

	/// obt@Đ
	/// [in] bLoop - [vĐꍇtruew肷
	virtual LRESULT Play(bool bLoop = false) = 0;

	/// obt@~
	virtual LRESULT Stop() = 0;

	/// obt@XgĂ烊XgA
	virtual LRESULT Restore() = 0;
};

class CDirectSound;
class CDirectSoundBuffer : public ISoundBuffer {
/**
	DirectSoundɓ class ISoundBuffer hNX
	class CDirectSoundPrimaryBuffer @
	class CDirectSoundSeconderyBuffer ́Ah

	[ӓ_]@DirectSound́A{[l-1000w肵ƂƁA
	@@@@@-10dB̃{[lɂȂB
*/
public:
	CDirectSoundBuffer(CDirectSound* lpDirectSound);
	virtual ~CDirectSoundBuffer();

	/// override from class ISoundBuffer
	virtual int GetType() const { return 1; }
	virtual LRESULT Create(LPCWAVEFORMATEX lpWFormat, DWORD dwSize, bool bZeroClear=false, const CSoundParameter* pParam=NULL) = 0;
	virtual smart_ptr<ISoundBuffer> Clone() = 0;
	virtual LRESULT GetStatus() const;
	virtual LRESULT SetFormat(LPCWAVEFORMATEX lpFormat);
	virtual LRESULT GetFormat(LPWAVEFORMATEX lpFormat) const;
	virtual LRESULT SetCurrentPosition(DWORD dwPlayCursor);
	virtual LRESULT GetCurrentPosition(DWORD& dwPlayCursor, DWORD& dwWriteCursor) const;
	virtual LRESULT SetVolume(LONG lVolume);
	virtual LRESULT GetVolume(LONG& lVolume) const;
	virtual LRESULT SetPan(LONG lPan);
	virtual LRESULT GetPan(LONG& lPan) const;
	virtual LRESULT SetFrequency(DWORD dwFrequency);
	virtual LRESULT GetFrequency(DWORD& dwFrequency) const;
	virtual LRESULT Lock(DWORD dwWriteCursor, DWORD dwLockBytes, BYTE** lplpLockedBuffer1, DWORD* lpdwLockedBytes1, BYTE** lplpLockedBuffer2=NULL, DWORD* lpdwLockedBytes2=NULL);
	virtual LRESULT Unlock(BYTE* lpLockedBuffer, DWORD dwLockedBytes, BYTE* lpLockedBuffer2=NULL, DWORD dwLockedBytes2=0);
	virtual LRESULT Play(bool bLoop = false);
	virtual LRESULT Stop();
	virtual LRESULT Restore();

protected:
	/// LPDIRECTSOUNDBUFFERԂ
	LPDIRECTSOUNDBUFFER GetBuffer() const { return m_lpBuffer; }
	LPDIRECTSOUNDBUFFER m_lpBuffer;

	/// CDirectSoundԂ
	CDirectSound* GetDirectSound() const { return m_lpDirectSound; }
	CDirectSound* m_lpDirectSound;
};

class CDirectSoundPrimaryBuffer : public CDirectSoundBuffer {
/**
	DirectSoundBufferPrimaryBuffer̂߂̃NX
*/
public:
	CDirectSoundPrimaryBuffer(CDirectSound* lpDirectSound) : CDirectSoundBuffer(lpDirectSound) {};
	virtual ~CDirectSoundPrimaryBuffer() {};

	/// override from class ISoundBuffer
	/// ͑SĖ
	virtual LRESULT Create(LPCWAVEFORMATEX lpWFormat, DWORD dwSize, bool bZeroClear=false, const CSoundParameter* pParam=NULL);

	/// override from class ISoundBuffer
	virtual smart_ptr<ISoundBuffer> Clone() { return smart_ptr<ISoundBuffer>(); }
};

class CDirectSoundSeconderyBuffer : public CDirectSoundBuffer {
/**
	DirectSoundBufferSeconderyBuffer̂߂̃NX
*/
public:
	CDirectSoundSeconderyBuffer(CDirectSound* lpDirectSound) : CDirectSoundBuffer(lpDirectSound) {};
	virtual ~CDirectSoundSeconderyBuffer() {};

	/// override from class ISoundBuffer
	virtual LRESULT Create(LPCWAVEFORMATEX lpWFormat, DWORD dwSize, bool bZeroClear=false, const CSoundParameter* pParam=NULL);
	virtual smart_ptr<ISoundBuffer> Clone();
};

class CNullSoundBuffer : public ISoundBuffer {
/**
	class ISoundBuffer NullDeviceNX
*/
public:
	CNullSoundBuffer(){};
	virtual ~CNullSoundBuffer(){};

	/// override from class ISoundBuffer
	virtual int GetType() const { return 0; }
	virtual LRESULT Create(LPCWAVEFORMATEX lpWFormat, DWORD dwSize, bool bZeroClear=false, const CSoundParameter* pParam=NULL) { return -1; }
	virtual smart_ptr<ISoundBuffer> Clone() { return smart_ptr<ISoundBuffer>(new CNullSoundBuffer); }
	virtual LRESULT GetStatus() const { return -1; }
	virtual LRESULT SetFormat(LPCWAVEFORMATEX lpFormat) { return -1; }
	virtual LRESULT GetFormat(LPWAVEFORMATEX lpFormat) const { return -1; }
	virtual LRESULT SetCurrentPosition(DWORD dwPlayCursor) { return -1; }
	virtual LRESULT GetCurrentPosition(DWORD& dwPlayCursor, DWORD& dwWriteCursor) const { return -1; }
	virtual LRESULT SetVolume(LONG lVolume) { return -1; }
	virtual LRESULT GetVolume(LONG& lVolume) const { return -1; }
	virtual LRESULT SetPan(LONG lPan) { return -1; }
	virtual LRESULT GetPan(LONG& lPan) const { return -1; }
	virtual LRESULT SetFrequency(DWORD dwFrequency) { return -1; }
	virtual LRESULT GetFrequency(DWORD& dwFrequency) const { return -1; }
	virtual LRESULT Lock(DWORD dwWriteCursor, DWORD dwLockBytes, BYTE** lplpLockedBuffer1, DWORD* lpdwLockedBytes1, BYTE** lplpLockedBuffer2=NULL, DWORD* lpdwLockedBytes2=NULL) { return -1; }
	virtual LRESULT Unlock(BYTE* lpLockedBuffer1, DWORD dwLockedBytes1, BYTE* lpLockedBuffer2=NULL, DWORD dwLockedBytes2=0) { return -1; }
	virtual LRESULT Play(bool bLoop = false) { return -1; }
	virtual LRESULT Stop() { return -1; }
	virtual LRESULT Restore() { return -1; }
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif // __yaneSoundBuffer_h__
