// yaneSoundStream.h
//		programmed by ENRA		'02/03/25

#ifndef __yaneSoundStream_h__
#define __yaneSoundStream_h__


namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class ISoundStream {
/**
	TEhf[^PCM`œǂݏo߂̃C^[tF[X
*/
public:
	ISoundStream(){};
	virtual ~ISoundStream(){};

	/// I[v
	virtual LRESULT	Open(const char* filename) = 0;

	/// N[Y
	virtual LRESULT	Close() = 0;

	/// TEhf[^̒msecPʂŕԂ
	virtual LONG	GetLength() const = 0;

	/// ĐʒumsecPʂŐݒ肷
	virtual LRESULT	SetCurrentPos(LONG lPosition) = 0;

	/// ĐʒumsecPʂŕԂ
	virtual LONG	GetCurrentPos() const = 0;

	/// lpDestɁAdwSizePCM`œWJ
	/// [in] lpDest - WJobt@ւ̃|C^
	/// [in] dwSize - WJTCY
	virtual DWORD	Read(BYTE* lpDest, DWORD dwSize) = 0;

	/// WAVEFORMATEX\̂Ԃ
	virtual WAVEFORMATEX* GetFormat() const = 0;
};

class CNullSoundStream : public ISoundStream {
/**
	class ISoundStream NullDeviceNX
*/
public:
	CNullSoundStream(){};
	virtual ~CNullSoundStream(){};

	/// override from class ISoundStream
	LRESULT	Open(const char* filename) { return -1; }
	LRESULT	Close() { return -1; }
	LONG	GetLength() const { return -1; }
	LRESULT	SetCurrentPos(LONG dwPosition) { return -1; }
	LONG	GetCurrentPos() const { return -1; }
	DWORD	Read(BYTE* lpDest, DWORD dwSize) { return 0; }
	WAVEFORMATEX* GetFormat() const { return NULL; }
};

}}

namespace yaneuraoGameSDK3rd {namespace Auxiliary { class IStringMap; }}

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class ISoundStreamFactory {
/**
	class ISoundStream hNX𐶐factory ̃C^[tF[X
*/
public:
	ISoundStreamFactory(){};
	virtual ~ISoundStreamFactory(){};

	/// ISoundStream𐶐
	virtual smart_ptr<ISoundStream> Open(const string& filename) = 0;

	IStringMap* GetPlugInMap() { return m_vPlugInMap.get(); }
	/**
		gqːTEhPlugIñNX
		ւmapłB
		ISoundStreamFactory::GetPlugInMap()->Write("ogg", "CVorbisStream");
		̂悤ɂăvOCǉĂ܂B
	*/

protected:
	/// gqPlugIñNXւmap
	smart_ptr<IStringMap>	m_vPlugInMap;
};

class CSoundStreamFactory : public ISoundStreamFactory {
/**
	class ISoundStream hNX𐶐factory
*/
public:
	CSoundStreamFactory();
	virtual ~CSoundStreamFactory();

	/// override from class ISoundStreamFactory
	smart_ptr<ISoundStream> Open(const string& filename);
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd


#endif // __yaneSoundStream_h__
