#include "stdafx.h"

#include "yaneWaveOutput.h"
#include "yaneSoundParameter.h"
#include "yaneWaveStaticSound.h"
#include "yaneWaveStreamSound.h"

#include "yaneWaveSound.h"
//#include "../Window/yaneDebugWindow.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

CWaveSound::CWaveSound(IWaveOutput* p) : m_pOutput(p)
{
	// ftHgfalse
	m_bStreamPlay = false;
	if (m_bStreamPlay) {
		m_vSound.Add(new CWaveStreamSound(GetOutput()));
	} else {
		m_vSound.Add(new CWaveStaticSound(GetOutput()));
	}
	m_bFadeStop	= false;
}

CWaveSound::~CWaveSound()
{
}

void CWaveSound::SetStreamPlay(bool b)
{
	if (m_bStreamPlay==b) return;
	m_bStreamPlay = b;

	// 擾
	string filename = GetSound()->GetFileName();
	bool IsLoopPlay = GetSound()->IsLoopPlay();
	LONG lVol = GetSound()->GetVolume();
//	LONG lPos = GetSound()->GetCurrentPos();
	bool IsPlay = GetSound()->IsPlay();

	// pς
	GetSound()->Close();

	// ǂ炩𐶐
	if (m_bStreamPlay) {
		m_vSound.Add(new CWaveStreamSound(GetOutput()));
	} else {
		m_vSound.Add(new CWaveStaticSound(GetOutput()));
	}

	// ݒ
	GetSound()->SetLoopPlay(IsLoopPlay);
	GetSound()->Open(filename);
//	GetSound()->SetCurrentPos(lPos);
	if (IsPlay) GetSound()->Play();
	GetSound()->SetVolume(lVol);
}

////////////////////////////////////////////////////////////////////////

LRESULT CWaveSound::Open(const string& strFileName) {
	StopFade();
	return GetSound()->Open(strFileName);
}

LRESULT CWaveSound::Close()	{ StopFade(); return GetSound()->Close(); }
LRESULT CWaveSound::Play() { StopFade(); return GetSound()->Play(); }
LRESULT CWaveSound::Replay() { StopFade(); return GetSound()->Replay(); }

bool	CWaveSound::IsPlay() const { return GetSound()->IsPlay(); }
LRESULT	CWaveSound::SetLoopPlay(bool bLoop) { return GetSound()->SetLoopPlay(bLoop); }
bool	CWaveSound::IsLoopPlay() const { return GetSound()->IsLoopPlay(); }

LONG	CWaveSound::GetLength() const { return GetSound()->GetLength(); }
LRESULT CWaveSound::SetCurrentPos(LONG lPos) { StopFade(); return GetSound()->SetCurrentPos(lPos); }

LONG	CWaveSound::GetCurrentPos() const { return GetSound()->GetCurrentPos(); }

string	CWaveSound::GetFileName() const { return GetSound()->GetFileName(); }

LRESULT CWaveSound::Restore() { return GetSound()->Restore(); }

LRESULT CWaveSound::Pause() {
	//	pauseƂ́A͑Đ킯ŖڂԂH
	StopFade();
	return GetSound()->Pause();
}

}}

///----------	ȉ̊֐́AFadê߂ɁA׍HKv
#include "../Timer/yaneIntervalTimer.h"
#include "../AppFrame/yaneAppManager.h"
#include "../AppFrame/yaneAppBase.h"
//	C^[o^C}pāAtF[hȂ̒~

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

void	CWaveSound::StopFade(){
	//	FadeĂ̂Ȃ΁Aj
	if (IsFadeStop()){
		CAppManager::GetMyApp()->GetIntervalTimer()->DeleteCallBack(this);
		SetFade(false);
		InnerSetVolume(m_lOriginalVolume);
	}
}

LRESULT CWaveSound::Stop() {
	if (IsFadeStop()) { return 0; } // ɒ~߂ƂH

#ifndef __SoundFadeStop__

	m_lOriginalVolume = GetVolume();
	InnerStop();

#else
	//	fadeȂ~

	m_lOriginalVolume = GetVolume();
	/*
		DSBVOLUME_MAXiȂj : 0
		DSBVOLUME_MIXij : -10000
	*/

	//	10msゲƂVolumefade
	LONG lVol = m_lOriginalVolume;
	int t=0;
	for(;lVol>-10000;t++){
		lVol -= 1000;
		if (lVol < -10000) lVol = -10000;
		if (t==0){
			InnerSetVolume(lVol);
		} else {
			smart_ptr<function_callback> fn(
				function_callback_r<LRESULT>::Create(
					&CWaveSound::InnerSetVolume,this,lVol
				)
			);
			CAppManager::GetMyApp()->GetIntervalTimer()->RegistCallBack(
				this,t*10,0,1,fn);
			///	10ms~n Ƃvolume
		}
	}
	{
		smart_ptr<function_callback> fn(
			function_callback_r<LRESULT>::Create(
				&CWaveSound::InnerStop,this
			)
		);
		CAppManager::GetMyApp()->GetIntervalTimer()->RegistCallBack(
			this,t*10,0,1,fn);
	}
	SetFade(true);

#endif
	return 0;
}

LRESULT CWaveSound::InnerStop() {
	LRESULT lr = GetSound()->Stop();
	lr |= InnerSetVolume(m_lOriginalVolume);	//	H[߂
	return lr;
}

LRESULT CWaveSound::SetVolume(LONG volume) {
	if (IsFadeStop()){
		//	FadeIĂɂĂ񂩁I
		m_lOriginalVolume = volume;
		return 0;
	}
	return GetSound()->SetVolume(volume);
}

LRESULT CWaveSound::InnerSetVolume(LONG volume) {
	return GetSound()->SetVolume(volume);
}

LONG	CWaveSound::GetVolume() const {
	if (IsFadeStop()){
		return m_lOriginalVolume;
	}
	return GetSound()->GetVolume();
}

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd
