// yaneWaveStreamSound.h
//		programmed by ENRA		 '02/03/25

#ifndef __yaneWaveStreamSound_h__
#define __yaneWaveStreamSound_h__


#include "yaneSound.h"
#include "../Thread/yaneThread.h"
#include "../Thread/yaneCriticalSection.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class IWaveOutput;
class ISoundBuffer;
class ISoundStream;
class CWaveStreamSound : public IWaveSound, public CThread {
/**
	WaveĐ̂߂ class ISound hNX
	ۂclass CWaveSoundʂėp
	class CWaveStaticSound ƈႢAt@CWJȂĐ
*/
public:
	CWaveStreamSound(IWaveOutput* p);
	virtual ~CWaveStreamSound();

	///	overriden from class ISound
	LRESULT Open(const string& strFileName) { return Load(strFileName); }
	LRESULT Close()	{ return Release(); }
	LRESULT Play();
	LRESULT Replay();
	LRESULT Stop();
	LRESULT Pause();
	bool	IsPlay() const;
	LRESULT	SetLoopPlay(bool bLoop);
	bool	IsLoopPlay() const;
	LONG	GetLength() const;
	LRESULT SetCurrentPos(LONG lPos);
	LONG	GetCurrentPos() const;
	LRESULT SetVolume(LONG volume);
	LONG	GetVolume() const;
	string	GetFileName() const { return m_strFileName; }
	int	GetType() const { return 4; }

	///	overriden from class IWaveSound
	LRESULT Restore();

	///	t@Cǂݍ
	LRESULT Load(const string& strFileName);
	///	t@C
	LRESULT Release();
	///	Đg̐ݒE擾
	LRESULT SetFrequency(DWORD freq);
	DWORD	GetFrequency() const;

	//////////////////////////////////////////////////////////////////////////

protected:
	//	obt@ByteTCY𓾂
	inline DWORD	GetBufferSize() const { return eBufferLength * m_nAvgBytesPerSec; }

	//	Stop()̉
	LRESULT InnerStop();

	//	Secondary Buffer
	LRESULT InitBuffer();
	//	Secondary BufferɃf[^𗬂
	LRESULT GetNextSoundData();

	//	Accessor
	inline IWaveOutput*				GetOutput() const { return m_pOutput; }
	inline ICriticalSection*		GetCS() const { return const_cast<CCriticalSection*>(&m_vCS); }
	inline smart_ptr<ISoundStream>	GetStream() const { return m_vStream; }
	inline smart_ptr<ISoundBuffer>	GetBuffer() const { return m_vBuffer; }
	inline void	SetStream(const smart_ptr<ISoundStream>& p) { m_vStream = p; }
	inline void	SetBuffer(smart_ptr<ISoundBuffer> p) { m_vBuffer = p; }

	//	overriden from class CThread
	void	ThreadProc();

private:
	//	Secondary Buffer
	smart_ptr<ISoundBuffer>	m_vBuffer;	
	//	Sound Stream
	smart_ptr<ISoundStream>	m_vStream;
	//	Critical Section Object
	CCriticalSection		m_vCS;
	//	Wave Output Device
	IWaveOutput*			m_pOutput;

	volatile DWORD	m_dwPlayPosition;	//	t@C̍ĐʒuByteŎ

	enum	{ eBufferLength = 3 };	//	ZJ_obt@̕b

	DWORD	m_dwPrevWriteCursor;//	ȌJ[\
	DWORD	m_dwNextWriteCursor;//	̏J[\
	DWORD	m_dwWriteDiffer;	//	Ȍ߂ȂTCY
	DWORD	m_dwPrevPlayCursor;	//	O̍ĐJ[\

	string	m_strFileName;		//	t@C
	int		m_bPaused;			//	TEhpauseH
	volatile bool	m_bLoop;	//	[v[hōĐ̂H
	DWORD	m_nAvgBytesPerSec;	//	PbԂ̃f[^oCgiĐʒuZopj
	DWORD	m_dwLength;			//	Ȃ̒[P: Byte]
	LONG	m_lVolume;			//	Volume
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif // __yaneWaveStreamSound_h__
