#include "stdafx.h"
#include "yaneMicroThread.h"
#include <malloc.h>

namespace yaneuraoGameSDK3rd {
namespace Thread {

IMemoryAllocator* CMicroThread::pDefaultAllocator_=NULL;

#ifdef USE_EXCEPTION

	void	CMicroThread::QuitFunction(){
			throw CMicroThreadQuitException();
	}

//	Ô߂ɃR[h𕪗Ă...
#if !defined(yaneSDK_CantUseInlineAssembler)
	void	CMicroThread::ReleaseStack(){
	//	܁A}CNXbhs?
		if (bSuspended_){
			//	X^bN؂ւƁAOthrow邩?
			void *fQuitFunction = (void*)&CMicroThread::QuitFunction;
			//	VC++6̃CCAZustaticȃo֐call
			//	ĂȂ(VC++7ł͉\)
		_asm {
			push	offset Next
			//	resumêƂɖ߂ĂKv̂

			push	ebx
			push	ebp
			push	esi
			push	edi

			push	dword ptr fs:[0]	//	Ô߂ɕKv

			mov		eax,[this]
			xchg	esp,[eax].register_esp_
			mov		eax,fQuitFunction

			// ŗÔŁAۂ́Äȉ͎̕s邱Ƃ͂Ȃ

			pop		dword ptr fs:[0]	//	Ô߂ɕKv

			pop		edi
			pop		esi
			pop		ebp
			pop		ebx
//	VC++6ł̓I[o[[hĂȂO[o֐CCAZuĂяoȂ(;LD`)
			jmp		eax

			// ƁAƂł܂ł́ARsy̎c[(^^;
Next:;
			}
		}

		if (abyStack_!=NULL){
			if (pAllocator_!=NULL) {	//	AP[^Ŋ蓖Ă?
				pAllocator_->Free(abyStack_);
			} else if (pDefaultAllocator_!=NULL) {	//	fBtHgAP[^Ŋ蓖Ă?
				pDefaultAllocator_->Free(abyStack_);
			} else {
				delete [] abyStack_;
			}
			abyStack_ = NULL;
		}
	}

#else	// !defined(yaneSDK_CantUseInlineAssembler)

	//	BCC5.5pɃnhAZuo[Wp
	void	CMicroThread::ReleaseStack(){
	//	܁A}CNXbhs?
		if (bSuspended_){
			//	X^bN؂ւƁAOthrow邩?

			struct CMyTmp {
				BYTE **my_esp;
				void *fQuitFunction;
			};
			CMyTmp mytmp;
			mytmp.my_esp = &register_esp_;
			mytmp.fQuitFunction = (void*)&CMicroThread::QuitFunction;

		//	handassembled by yaneurao('03/07/06)		
/*
		_asm {
		//	push	offset Next
			//	resumêƂɖ߂ĂKv̂

			push	ebx
			push	ebp
			push	esi
			push	edi

			push	dword ptr fs:[0]	//	Ô߂ɕKv

//			mov		eax,[this]
			mov		ecx,[eax]
			xchg	esp,[ecx]
//			mov		eax,fQuitFunction
			mov		eax,[eax+4]

			// ŗÔŁAۂ́Äȉ͎̕s邱Ƃ͂Ȃ

			pop		dword ptr fs:[0]	//	Ô߂ɕKv

			pop		edi
			pop		esi
			pop		ebp
			pop		ebx
//	VC++6ł̓I[o[[hĂȂO[o֐CCAZuĂяoȂ(;LD`)
			jmp		eax

			// ƁAƂł܂ł́ARsy̎c[(^^;
Next:;
			}
*/
			static const BYTE code_area [] ={
				0x8B,0x44,0x24,0x04,//      mov         eax,dword ptr [esp+4] 
				0x53,//               push        ebx  
				0x55,//               push        ebp  
				0x56,//               push        esi  
				0x57,//               push        edi  
				0x64,0xFF,0x35,0,0,0,0,// push        dword ptr fs:[0] 
				0x8B,0x08,//            mov         ecx,dword ptr [eax] 
				0x87,0x21,//            xchg        esp,dword ptr [ecx] 
				0x8B,0x40,0x04,//       mov         eax,dword ptr [eax+4] 
				0x64,0x8F,0x05,0,0,0,0,// pop         dword ptr fs:[0] 
				0x5F,//               pop         edi  
				0x5E,//               pop         esi  
				0x5D,//               pop         ebp  
				0x5B,//               pop         ebx  
				0xFF,0xE0//            jmp         eax  
			};
			//reinterpret_cast<void(*)(CMyTmp*)>(&code_area)(&mytmp);
			void(*f)(CMyTmp*) = (void(*)(CMyTmp*))&code_area;
			f(&mytmp);
		}

		if (abyStack_!=NULL){
			if (pAllocator_!=NULL) {	//	AP[^Ŋ蓖Ă?
				pAllocator_->Free(abyStack_);
			} else if (pDefaultAllocator_!=NULL) {	//	fBtHgAP[^Ŋ蓖Ă?
				pDefaultAllocator_->Free(abyStack_);
			} else {
				delete [] abyStack_;
			}
			abyStack_ = NULL;
		}
	}

#endif	// !defined(yaneSDK_CantUseInlineAssembler)

	CMicroThread::~CMicroThread(){
		//	O𔭐āAIɔoׂ?
		ReleaseStack();
	}

//	Ô߂ɃR[h𕪗Ă...
#if !defined(yaneSDK_CantUseInlineAssembler)
	void	CMicroThread::start(const smart_ptr<function_callback>& fn,int nStackSize)
	{
#ifdef USE_EXCEPTION
		if (nStackSize<=32){
			throw CRuntimeException("CMicroThread::startŃX^bNpӂȂ");
		}
#endif
		bEnd_ = false;
		ReleaseStack();
		if (pAllocator_!=NULL) {	//	AP[^??
			abyStack_ = pAllocator_->Alloc(nStackSize);
		} else if (pDefaultAllocator_!=NULL){
			abyStack_ = pDefaultAllocator_->Alloc(nStackSize);
		} else {
			abyStack_ = new BYTE[nStackSize];
		}
		anStackSize_ = nStackSize;
		fn_ = fn;
		register_esp_ = abyStack_+nStackSize;

		void *fInnerCallBack = (void*)&CMicroThread::InnerCallBack;
		//	VC++6̃CCAZustaticȃo֐call
		//	ĂȂ(VC++7ł͉\)

		_asm {
			mov		eax,[this]

			push	offset Next	//	߂lpush

			push	ebx
			push	ebp
			push	esi
			push	edi

			push	dword ptr fs:[0]	//	Ô߂ɕKv

			xchg	[eax].register_esp_ , esp

			//	bp؂ւĂ̂ŁAthiŝsɂȂ̂
			//	ȍ~AoɃANZXoȂ
			push	eax	//	InnerCallBack̑Pp[^Ƃēn
//			call	InnerCallBack
//	VC++6ł̓I[o[[hĂȂO[o֐CCAZuĂяoȂ(;LD`)
			call	[fInnerCallBack]

		//	ɓBƂƂ́Å֐̎sIƂƂӖ̂
		//	X^bN̏Ԃɖ߂ĂKv

			pop		eax

			xchg	[eax].register_esp_ , esp
			mov		[eax].bEnd_,1	//	bEnd_ = true;

			pop		dword ptr fs:[0]	//	Ô߂ɕKv

			pop		edi
			pop		esi
			pop		ebp
			pop		ebx

//			pop		eax	//	ŏɐς񂾃x
//			jmp		eax
			ret
Next:
		}

	}

#else	// !defined(yaneSDK_CantUseInlineAssembler)

	//	BCC5.5pɃnhAZu by yaneurao('03/07/06)
	void	CMicroThread::start(const smart_ptr<function_callback>& fn,int nStackSize)
	{
#ifdef USE_EXCEPTION
		if (nStackSize<=32){
			throw CRuntimeException("CMicroThread::startŃX^bNpӂȂ");
		}
#endif
		bEnd_ = false;
		ReleaseStack();
		if (pAllocator_!=NULL) {	//	AP[^??
			abyStack_ = pAllocator_->Alloc(nStackSize);
		} else if (pDefaultAllocator_!=NULL) {
			abyStack_ = pDefaultAllocator_->Alloc(nStackSize);
		} else {
			abyStack_ = new BYTE[nStackSize];
		}
		anStackSize_ = nStackSize;
		fn_ = fn;
		register_esp_ = abyStack_+nStackSize;

			struct CMyTmp {
				BYTE **my_esp;
				CMicroThread*pThis;
				void *fInnerCallBack;
				bool *bEnd;
			};
			CMyTmp mytmp;
			mytmp.my_esp = &register_esp_;
			mytmp.pThis = this;
			mytmp.fInnerCallBack = (void*)&CMicroThread::InnerCallBack;
			mytmp.bEnd = &bEnd_;

/*
		_asm {
//			mov		eax,[this]
//			push	offset Next	//	߂lpush

			push	ebx
			push	ebp
			push	esi
			push	edi

			push	dword ptr fs:[0]	//	Ô߂ɕKv

//			xchg	[eax].register_esp_ , esp
			mov		ecx,[eax]
			xchg	esp,[ecx]


			//	bp؂ւĂ̂ŁAthiŝsɂȂ̂
			//	ȍ~AoɃANZXoȂ
//			push	eax	//	InnerCallBack̑Pp[^Ƃēn
			push	[eax+12]
			push	[eax]

			mov		ecx,[eax+8]
			mov		eax,[eax+4]

			//			call	InnerCallBack
//	VC++6ł̓I[o[[hĂȂO[o֐CCAZuĂяoȂ(;LD`)
//			call	[fInnerCallBack]
//			call	[eax+8]
			push	eax
			call	ecx

		//	ɓBƂƂ́Å֐̎sIƂƂӖ̂
		//	X^bN̏Ԃɖ߂ĂKv
			pop		eax
			mov		[eax],1	//	bEnd_ = true;
			pop		eax

//			xchg	[eax].register_esp_ , esp
			xchg	esp,[eax]

			pop		dword ptr fs:[0]	//	Ô߂ɕKv

			pop		edi
			pop		esi
			pop		ebp
			pop		ebx

//			pop		eax	//	ŏɐς񂾃x
//			jmp		eax
			ret
Next:
		}
/**/

		static const BYTE code_area[]={
			0x8B,0x44,0x24,0x04,//      mov         eax,dword ptr [esp+4] 
			0x53,//               push        ebx  
			0x55,//               push        ebp  
			0x56,//               push        esi  
			0x57,//               push        edi  
			0x64,0xFF,0x35,0,0,0,0,// push        dword ptr fs:[0] 
			0x8B,0x08,//            mov         ecx,dword ptr [eax] 
			0x87,0x21,//            xchg        esp,dword ptr [ecx] 

			0xFF,0x30,//            push        dword ptr [eax] 
			0xFF,0x70,0x0C,//         push        dword ptr [eax+0Ch] 

			0x8B,0x48,0x08,//       mov         ecx,dword ptr [eax+8] 
			0x8B,0x40,0x04,//       mov         eax,dword ptr [eax+4] 
			0x50,//                 push        eax  
			0xFF,0xD1,     //       call        ecx  

			0x58,//		              pop         eax  //	Opush̕
			0x58,//		              pop         eax  
			0xC6,0x00,0x01,//    mov         byte ptr [eax],1 

			0x58,//		              pop         eax  
			0x87,0x20,//            xchg        esp,dword ptr [eax] 
 
			0x64,0x8F,0x05,0,0,0,0,// pop         dword ptr fs:[0] 
			0x5F,//               pop         edi  
			0x5E,//               pop         esi  
			0x5D,//               pop         ebp  
			0x5B,//               pop         ebx  
			0xC3 //               ret           	
		};
		//reinterpret_cast<void(*)(CMyTmp*)>(&code_area)(&mytmp);
		void(*f)(CMyTmp*) = (void(*)(CMyTmp*))&code_area;
		f(&mytmp);
	}
#endif	// !defined(yaneSDK_CantUseInlineAssembler)

	void	CMicroThread::suspend()	///	s̏𒆒f
	{
		bSuspended_ = true;

		SwitchThread();
	}


	void	CMicroThread::resume()		///	fĊJ
	{
		if (!isSuspended()) return ;	//	fi`jŲ!!

		bSuspended_ = false;

		SwitchThread();
	}

	void	CMicroThread::sleep(int n){
		while (n-->0){
			suspend();
		}
	}

	///	݃}CNXbhgpĂX^bNTCYԂ
	///	(}CNXbhłAOłĂяoƂo)
	int		CMicroThread::GetUseStackSize() const{
		BYTE* pStack;
		pStack = reinterpret_cast<BYTE*>(&pStack);

		//	}CNXbhĂяôH
		if (abyStack_ <= pStack && 
			pStack <= abyStack_+ anStackSize_){
			//	yes˂݂̌̃X^bNʒuX^bN{g̑Έʒu߂
		} else {
			//	no ˃}CNXbhɕۑĂX^bNʒu𒲂ׂ
			pStack = register_esp_;
		}
		return (abyStack_+ anStackSize_) - pStack;
	}


	void	CMicroThread::InnerCallBack(CMicroThread*p)
	{
		//	fn_ɃR[obN
		if (p->pAllocator_!=NULL || p->pDefaultAllocator_!=NULL){
		//	X^bN̗̈ȂOLȂ̂ŁA
		//	OĂ
			try {
				p->fn_->run();	//	fn_ɃR[obN
			} catch(CMicroThreadQuitException&) {
			}
			//	Kv͂Ȃ
		} else {
			p->fn_->run();	//	fn_ɃR[obN
		}
	}	


//		BCBł́Ainline֐_asmgȂ̂(;LD`)
#if defined(yaneSDK_BCC_Mode)||defined(yaneSDK_CodeWarrior_Mode)
///	ɁABCC5.5TASMĂȂ̂(;LD`)
	void	CMicroThread::SwitchThread(){
	/*
		_asm {
			//	݂̉zX^bNɐς
//			push	offset Next
			//	resumêƂɖ߂ĂKv̂

//			mov		ecx,30		//	offset Next - Now
//			add		ecx,
//			push	ecx
//Now:
			//	̊֐ĂяoƂƂ̓X^bN
			//	߂悪ς܂Ăƍlėǂ

			push	ebx
			push	ebp
			push	esi
			push	edi

			push	dword ptr fs:[0]	//	Ô߂ɕKv

//			mov		eax,[this]
//			xchg	esp,[eax].register_esp_	//	CodeWarriorƂʂȂ̂(;LD`)
			xchg	esp,[eax]

			pop		dword ptr fs:[0]	//	Ô߂ɕKv

			pop		edi
			pop		esi
			pop		ebp
			pop		ebx

//			pop		eax
//			jmp		eax
			ret
Next:;
		}
	*/
		//	hand assembled by yaneurao('03/07/06)
		static const BYTE code_area[] ={
			0x8B,0x44,0x24,0x04,//      mov         eax,dword ptr [esp+4] 
			0x53,	//               push        ebx  
			0x55,	//               push        ebp  
			0x56,	//	             push        esi  
			0x57,	//               push        edi  
			0x64,0xFF,0x35,0,0,0,0, // push        dword ptr fs:[0] 
			0x87,0x20,//            xchg        esp,dword ptr [eax] 
			0x64,0x8F,0x05,0,0,0,0, // pop         dword ptr fs:[0] 
			0x5F,	//               pop         edi  
			0x5E,	//               pop         esi  
			0x5D,	//               pop         ebp  
			0x5B,	//               pop         ebx  
			0xC3,   //	             ret           
		};
		//reinterpret_cast<void(*)(BYTE**)>(&code_area)(&register_esp_);
		void(*f)(BYTE**) = (void(*)(BYTE**))&code_area;
		f(&register_esp_);
	}
#endif

#endif


} // end of namespace Thread
} // end of namespace yaneuraoGameSDK3rd
