// yaneWindow.cpp
#include "stdafx.h"
#include "yaneWindow.h"
#include "yaneWinHook.h"
#include "../Auxiliary/yaneIMEWrapper.h"
#include "../AppFrame/yaneAppInitializer.h"
#include "../Auxiliary/yaneStream.h"
#include "../AppFrame/yaneAppManager.h"

namespace yaneuraoGameSDK3rd {
namespace Window {

bool CWindow::g_bFullScreen		= false; // N̓EBhD[hłI
CCriticalSection CWindow::m_cs;

//////////////////////////////////////////////////////////////////////////////

CWindow::CWindow(){
	m_dwFillColor	=	0;			//	NfBtHg
	m_hWnd			=	NULL;
	m_bShowCursor	=	true;		//	fBtHgŃ}EXJ[\\
	m_bUseMouseLayer=	false;		//	\tgEFA}EXJ[\
	m_bUseMenu		=	false;		//	j[̂Ȃ͂킩OOG
	m_bMinimized	=	false;		//	ŏĂ邩H
	m_bResized		=	false;		//	ChangeWindowStyleSetSizẽtOB
	m_pWndProc		=	NULL;		//	hookWndProc
}

CWindow::~CWindow(){
	GetHookList()->Del(this);		//	ڃtbN
/*
	if (m_hWnd!=NULL) {
		::DestroyWindow(m_hWnd);
	//	ȋȕ@Destroŷ́A߂˂OOG
	//	{ACAppBaseĝȂ΁ÃfXgN^ł́Ał
	//	Windoŵ͉ꂽƂ̂͂...
		m_hWnd	= NULL;
	}
*/
}

//////////////////////////////////////////////////////////////////////////////
/*
LRESULT CALLBACK CWindow::gDlgProc(HWND hDlgWnd, UINT msg, WPARAM wp, LPARAM lp)
{
    switch (msg) {
        case WM_INITDIALOG:
            return FALSE;
        case WM_COMMAND:
            switch (LOWORD(wp)) {
                case IDOK:
					::EndDialog(hDlgWnd, IDOK);
                    break;
                case IDCANCEL:
					::EndDialog(hDlgWnd, IDCANCEL);
                    break;
                default:
                    return FALSE;
            }
        default:
            return FALSE;
    }
    return TRUE;
}
*/

LRESULT CWindow::Create(CWindowOption& opt,HWND hParent){
	CCriticalLock cl(GetCriticalSection());

	HINSTANCE hInst = CAppInitializer::GetInstance();
	m_bFullScreen = g_bFullScreen;	//	݂̉ʃ[hIɕێ
	m_opt	= opt;	//	Rs[Ă

	m_hWnd = NULL;

	LONG lChild = 0;

	//	܂CT|[g
	if (m_opt.dialog!=NULL){
	//	dialog炵ŁH
		m_hWnd = ::CreateDialogParam(hInst,m_opt.dialog, hParent, (DLGPROC)gDlgProc,
			reinterpret_cast<LPARAM>(this));
			//	thisLPARAMɓĂĂI
		goto window_setting;
	}

    // ܂o^ĂȂEBhENXŁAWindowsWNX
    // ȊO̖ȌꍇRegisterClassEx()Ă
    WNDCLASSEX wndclass;
    if( !::GetClassInfoEx(hInst, opt.classname.c_str(), &wndclass) &&
        !IsWindowsClassName(opt.classname)) {

        // ܂̃EChENX
		wndclass.cbSize		= sizeof(WNDCLASSEX);
		wndclass.style		= 0;	//	_uNbNmȂ灨CS_DBLCLKS;
		wndclass.lpfnWndProc= gWndProc;
		wndclass.cbClsExtra	= 0;
		wndclass.cbWndExtra	= 0;
		wndclass.hInstance	= hInst;

		// Ƃ肠A"MAIN"̃ACR\
		wndclass.hIcon		= LoadIcon(hInst,"MAIN");
		wndclass.hIconSm	= LoadIcon(hInst,"MAIN");

		wndclass.hCursor	= LoadCursor(NULL,IDC_ARROW);
		// Ƃ肠A}EXJ[\pӁisvȂ΁AƂŏׂIj

		//	Ƃ肠AŃAɂƂƁc
		if (m_dwFillColor==0) {
			wndclass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
		} else {
			wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
		}

		//	MENUœǂݍł݂
		wndclass.lpszMenuName  = "IDR_MENU";
		//	̃\[X{ɑ݂̂́As܂ł킩Ȃ̂
		//	mȃEBhD̃AhWXgEBhDłoȂ

		{
			HRSRC hrsrc;
			hrsrc = ::FindResource(NULL,"IDR_MENU",RT_MENU);
			if (hrsrc!=NULL) { m_bUseMenu = true; }	//	j[₪ŁOOG
		}

		wndclass.lpszClassName = opt.classname.c_str();

		// ȂŎsĂ񂾂ˁH
		if (!::RegisterClassEx(&wndclass)) {
			Err.Out("CWindow::CreateRegisterClassExs");
			return 1;
		}
	}

	if (hParent!=NULL) {
		lChild	= WS_CHILDWINDOW;
	}

	if (m_bFullScreen){
		//	EChE̐itXN[j
		//	̂Ƃ́Aʂ̃X^CIvV͖

		int sx,sy;
		GetScreenSize(sx,sy);
		m_hWnd = ::CreateWindow(opt.classname.c_str(),opt.caption.c_str(),
						WS_POPUP|WS_VISIBLE	 /* |WS_SYSMENU|
						WS_MAXIMIZEBOX|WS_MINIMIZEBOX */ ,
						0, 0, sx, sy,
						hParent, NULL, hInst, NULL );
	} else {
		// EBhDElɓȂĂ͂ȂȂ
		// \͈͂640*480Ȃ΁AׂWindowTCÝAȏł
		RECT r;
		InnerAdjustWindow(r,opt);
		m_hWnd = ::CreateWindow(opt.classname.c_str(),opt.caption.c_str(),
				// WS_EX_TOPMOSTw肵񂾂ǂȁ[
						lChild | opt.style,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						r.right-r.left,r.bottom-r.top,
						hParent,NULL,hInst,NULL);
	}

window_setting:;
	if (m_hWnd==NULL){
		Err.Out("CWindow::CreateCreateWindowɎsB");
		return 1;
	}

	//	R[obNꂽƂɁAꂼWindowClassdispatcho悤
	//	GWL_USERDATAthisBĂB
	::SetWindowLong(m_hWnd,GWL_USERDATA,(LONG)this);

	//	ʂ̃Z^[ɐ悤ɏCOO
	if ((!m_bFullScreen) && (m_opt.size_x!=0) && (m_opt.size_y!=0)
			&& m_opt.bCentering) {
		int	sx,sy;
		GetScreenSize(sx,sy);
		sx	 = (sx-m_opt.size_x) >> 1;
		sy	 = (sy-m_opt.size_y) >> 1;
		SetWindowPos(sx,sy);
	}

	if ((m_opt.size_x!=0) && (m_opt.size_y!=0)){
		::ShowWindow(m_hWnd, SW_SHOW);
	}

	::SetFocus(m_hWnd);

	//	WWindowClassȂ΁AR[obN֐ƂāA
	//	łB
	if (IsWindowsClassName(opt.classname)){
		m_pWndProc = (WNDPROC)::SetWindowLong(m_hWnd,GWL_WNDPROC,(LONG)gWndProc);
		//	hooḱAillegal...
	} else {
		m_pWndProc = NULL;
	}

	//	̃EBhDȂ̂ŒڃtbNł
	//	iƂCAppManagerɖo^̒iKȂ̂ŒڃtbNȂj
	GetHookList()->Add(this);			//	tbNJn

	return 0;
}

void CWindow::GetScreenSize(int &x,int &y){
	x = ::GetSystemMetrics(SM_CXSCREEN);
	y = ::GetSystemMetrics(SM_CYSCREEN);
}

LRESULT CWindow::SetWindowPos(int x,int y){
	if (m_hWnd==NULL) return 0;
	//	EBhEĂړȂĂ͂ȂȂiEBhD[hj
	if (!m_bFullScreen){
		//	ŃgbvI[_[ɂĂĂȂ̂낤...
		return !::SetWindowPos(m_hWnd,HWND_TOP,x,y,NULL,NULL,SWP_NOSIZE|SWP_NOZORDER);
	}
	return 0;
}

void CWindow::SetSize(int sx,int sy){
	if (m_opt.size_x != sx || m_opt.size_y != sy){
		m_opt.size_x = sx;
		m_opt.size_y = sy;
		m_bResized	= true;	//	ύXꂽŃtOOOG
	}
}

LRESULT CWindow::Resize(int sx,int sy){
	m_opt.size_x = sx;
	m_opt.size_y = sy;

	if (m_hWnd==NULL) return 0;

	if (!m_bFullScreen){
		//	[hȂ̂...
		if ((m_opt.size_x!=0) && (m_opt.size_y!=0)){
			::ShowWindow(m_hWnd, SW_SHOW);	//	Ô߂ɑOOG
		}
		RECT r;
		InnerAdjustWindow(r,m_opt);
		return !::SetWindowPos(m_hWnd,NULL,0,0,r.right-r.left,r.bottom-r.top,SWP_NOMOVE|SWP_NOZORDER);
	} else {
		//	tXN[Ȃ΁ATCY͔T|[g
	}

	return 0;
}

void	CWindow::UseMouseLayer(bool bUse){
	if (bUse==m_bUseMouseLayer) return ;
	m_bUseMouseLayer = bUse;
	if (bUse) {
		//	gȂΖɏ
		ShowCursor(false);
	} else {
		//	gȂ̂ł΁AEBhD[h(or DIBDraw)Ȃ΃}EXJ[\
		if (!IsFullScreen()
/*
#ifdef USE_DIB32
			|| CAppManager::GetMyDIBDraw()!=NULL
			|| CAppManager::GetMyFastDraw()!=NULL
#endif
*/
		){
			ShowCursor(true);
		}
	}
}

void	CWindow::ChangeWindowStyle() {
	//	݂̉ʃ[hƁAEBhEX^CvΕύX̕KvȂ
	if (m_bFullScreen==g_bFullScreen && !m_bResized) return ;

	m_bFullScreen	= g_bFullScreen;
	m_bResized		= false;

	// قȂꍇ̓EBhDX^C݂̃[hɍ킹ĕύX
	if (!m_bFullScreen) {
		RECT r;
		int	sx,sy;
		GetScreenSize(sx,sy);
		r.left	 = (sx-m_opt.size_x) >> 1;
		r.top	 = (sy-m_opt.size_y) >> 1;
		r.right	 = r.left + m_opt.size_x;
		r.bottom = r.top  + m_opt.size_y;
		sx = r.left;	sy = r.top;
//		SetWindowPos(r.left,r.top);
		InnerAdjustWindow(r,m_opt);
		::SetWindowPos(m_hWnd,HWND_TOP,sx,sy,r.right-r.left,r.bottom-r.top,SWP_NOZORDER);

		//	́ASetWindowLong() Ō݂̏(ő剻AŏAʏ)
		//	ݒ肷( '02/03/16)
		UINT nState = 0;// EChȄ
		if(::IsIconic(m_hWnd))nState = WS_MINIMIZE;
		else if(::IsZoomed(m_hWnd))nState = WS_MAXIMIZE;
		::SetWindowLong(m_hWnd,GWL_STYLE,m_opt.style | nState );
		//	WS_CAPTION('01/04/24)@ρA̓[U[w肵Ȃ_

		::SetMenu(m_hWnd,GetMenu(m_hWnd)); // j[̈̍ĕ`
		::ShowWindow(m_hWnd,SW_SHOW);
		CIMEWrapper::GetObj()->Show();
	} else {
		::SetWindowLong(m_hWnd, GWL_STYLE, WS_POPUP);
		::SetMenu(m_hWnd,GetMenu(m_hWnd)); // j[̈̍ĕ`
		::ShowWindow(m_hWnd,SW_SHOW);
		CIMEWrapper::GetObj()->Hide();
	}
}

//	EBhDTCYadjust
//	Win32::AdjustWindowbug-fixp
//		(C) Tia-Deen & yaneurao '00/08/01,'00/11/05
void	CWindow::InnerAdjustWindow(RECT&rc,CWindowOption&opt){
	::SetRect(&rc,0,0,opt.size_x,opt.size_y);
	LONG	lStyle = opt.style;
/*	//	ρÃR[huserw肷ׂ '01/11/14
	if (lStyle & WS_POPUP) {
		lStyle |= WS_CAPTION;
	}
*/
	bool	bMenu = false;
	if (lStyle & WS_SYSMENU){
		//	m_hWndNULL̏ԂGetMenuĂяô͕sH
		if (m_bUseMenu || (m_hWnd!=NULL && ::GetMenu(m_hWnd)!=NULL)){
			bMenu = true;
		} else {
			bMenu = false;
			lStyle &= ~WS_SYSMENU;	//	SYSMENUtOO
		}
	//	lStyle |= WS_CAPTION;	//	ALvV̎w͍sȂi߁j
	}
	::AdjustWindowRect(&rc,lStyle,bMenu);
}

///////////////////////////////////////////////////////////////////////////////

bool	CWindow::IsShowCursor(){
	//	n[hEFA}EXJ[\̕\^\擾
	return m_bShowCursor;
}

void	CWindow::ShowCursor(bool bShow){
	//	CreateWindowXbhȂĂ͂ȂȂ

	//	\tgEFA}EXJ[\Ȃ΋It
	if (m_bUseMouseLayer) bShow = false;

	//	n[hEFA}EXJ[\̕\^\
	if (m_bShowCursor==bShow) return ;

	m_bShowCursor = bShow;
	::ShowCursor(bShow);
}

bool CWindow::IsWindowsClassName(const string& strClassName){
	return (strClassName=="BUTTON") || (strClassName=="COMBOBOX") ||
		(strClassName=="EDIT") || (strClassName=="LISTBOX") ||
		(strClassName=="MDICLIENT") || (strClassName=="SCROLLBAR") ||
		(strClassName=="STATIC");
}

///////////////////////////////////////////////////////////////////////////////
//
//	bZ[W̃gbv
//

//	ʏWindow̏ꍇ
LRESULT CALLBACK CWindow::gWndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){

	CWindow* win = (CWindow*)::GetWindowLong(hWnd,GWL_USERDATA);	//	CWindow*BĂ
	/**
		łEBhDɑ΂đĂbZ[W^dispatch邱Ƃ肤..
	*/
	if (win!=NULL) {
		return win->m_HookPtrList.Dispatch(hWnd,uMsg,wParam,lParam,win->m_pWndProc);
	} else {
		return ::DefWindowProc(hWnd,uMsg,wParam,lParam);
	}
}

//	_CAȌꍇ
LRESULT CALLBACK CWindow::gDlgProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	CWindow* win = (CWindow*)::GetWindowLong(hWnd,GWL_USERDATA);	//	CWindow*BĂ
	if (win==NULL) {
		win = reinterpret_cast<CWindow*>(lParam);	//	ႠH(CreateuԁH)
	}
	if (win!=NULL) {
		return win->m_HookPtrList.DispatchDlg(hWnd,uMsg,wParam,lParam,win->m_pWndProc);
	} else {
		//	_CAȌꍇ́ADefWindowProcĂяoĂ͂Ȃ
		//	(Iɏ悤_CAOprocedure)
		return 0;
	}
	return 0;
}


//////////////////////////////////////////////////////////////////////////////
//	ŏꂽ𔻒肵Aێ邽߂̃tbN
LRESULT	CWindow::WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){

	switch(uMsg){
	case WM_ACTIVATEAPP: {
		//	Windows2000ȂΕKł邪A
		//	Win95/98WM_SIZESIZE_RESTOREDŗȂƂH
		UINT bActive = wParam;
		if (bActive) {
			m_bMinimized = false;	//	ʏԂł
		}
		break;
						 }
	case WM_SIZE : {
		switch (wParam) {
		case SIZE_MINIMIZED : m_bMinimized = true; break;		//	ŏĂ
		case SIZE_RESTORED	: m_bMinimized = false; break;		//	ʏԂł
		//		ʏԂɖ߂ǂ́AWM_ACTIVATEAPPƂŌׂ
		}
		break;
						}


/*
	http://www.microsoft.com/JAPAN/support/kb/articles/JP214/6/55.HTM
	F

	[SDK32] AvP[VIA^XN o[ɋ󔒂̃{bNXc 
	ŏIXV: 2001/01/30
	ԍ: JP214655	


AvP[V̏IA^XN o[XVꂸA󔒂̃{bNX (EBhẼ^CgACR\ĂȂ) cꂽ܂܂ɂȂ邱Ƃ܂B̋󔒂̃{bNXNbNƁAĂ܂܂B 


̖́AAvP[V^XN o[ɑ΂\Ɋ֌WEBhẼX^CύX߂ɋN܂B 

Ⴆ΁AEBhE WS_EX_TOOLWINDOWS X^Cw肵āÅgX^CύXÃEBhEN[YOɊgX^C̃ZbgɎsꍇA^XN o[ɋ󔒂̃{^\܂B 

@
̓ɑꍇA̖ɂ́AEBhẼX^CZbg邩AAvP[ṼC EBhȄŁAWM_CLOSE ܂ WM_DESTROY ̒ŁASW_HIDE p^ɂ ShowWindow Ăяo܂B 
*/

/*
	ǋLB
		́AEBhD̏ԂWɖ߂ɏIƁA
		ۂN悤B
		܂A
		EBhȄԂő剻Wɖ߂Ƃ̃Aj[V
		ꂵSW_HIDEŁAhideāÂƁAEBhDX^C
		m[}ɖ߂ΗǂB
*/
	case WM_DESTROY : {
		::ShowWindow(m_hWnd, SW_HIDE);

///		ƁAfbhbNɊׂ邱Ƃ悤DD
//		::SetWindowLong(m_hWnd, GWL_STYLE, WS_POPUP);
		//	ň̃hCõoOɂȂāA
		//	𔽉f邽߂(ShowWindowSetWindowPosKv)
//		::SetWindowPos(hWnd, (HWND)HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
/*
		SetWindowPos(hWnd, (HWND)HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
		ĂƂAZbgȂƁA͂薼EBhD^XNo[Ɏc邱ƂioÔQj
*/

//		::ShowWindow(m_hWnd, SW_HIDE);
		}
		break;
	//	L̖ɑ΂΍R[h
	case WM_NCDESTROY : {
		//	EBhD̂ꂽ̂ŁÃtFCYŁAEBhDnh
		//	ZbgĂKvBiȂƁÃNX
		//	fXgN^ŁAddestroyĂ܂j
		m_hWnd = NULL;
		break;
		}
	} // end switch

	return 0;
}

//////////////////////////////////////////////////////////////////////////////

void	CDialogHelper::hook(IWindow*pWin){
	if (pWin!=NULL){
		pWin->GetHookList()->Add(GetPooler());
	}
}

void	CDialogHelper::unhook(IWindow*pWin){
	if (pWin!=NULL){
		pWin->GetHookList()->Del(GetPooler());
	}
}

string	CDialogHelper::GetText(int nEditControlID){
	HWND hWnd = GetHWnd();
	if (hWnd==NULL) return "";
	smart_ptr<BYTE> pBuf;
	int nLength = 16;	//	16Jn
	while (true) {
		pBuf.AddArray(nLength);
		int nResultLength = ::GetDlgItemText(hWnd,nEditControlID,(LPTSTR)pBuf.get(),pBuf.size());
		if (nResultLength+1 == nLength){
			//	obt@ȂƎv
			nLength <<=1;
		} else {
			break;
		}
	}
	return string((LPCSTR)pBuf.get());
}

///	X^eBbNeLXgRg[etc..ɑ΂āAɃeLXgݒ肷
LRESULT	CDialogHelper::SetText(int nEditControlID,const string& str){
	HWND hWnd = GetHWnd();
	if (hWnd==NULL) return 1;
	return ::SetDlgItemText(hWnd,nEditControlID,str.c_str())?0:1;
}

LRESULT CDialogHelper::SetCheck(int nEditControlID,int nCheck){
	HWND hWnd = GetHWnd();
	if (hWnd==NULL) return 1;
	HWND hDlgItem = ::GetDlgItem(hWnd,nEditControlID);
	if (hDlgItem==NULL) return 2;
	switch (nCheck){
	case 0 : nCheck = BST_UNCHECKED; break;
	case 1 : nCheck = BST_CHECKED; break;
	case 2 : nCheck = BST_INDETERMINATE; break;
	}
	return ::SendMessage(hDlgItem , BM_SETCHECK, nCheck , 0L)?0:3;
}

///	{^Ԃ̎擾
LRESULT	CDialogHelper::GetCheck(int nEditControlID){
/*
	-1:̃{^݂͑Ȃ
	0:{^̃`FbN̓ItɂȂĂ܂B 
	1:{^̃`FbN̓IɂȂĂ܂B 
	2:{^̓OC\ismj̏ԂłB{^ABS_3STATE X^C܂ BS_AUTO3STATE X^CƂɂKp܂B 
*/
	HWND hWnd = GetHWnd();
	if (hWnd==NULL) return -1;
//	HWND hDlgItem = ::GetDlgItem(hWnd,nEditControlID);
//	if (hDlgItem==NULL) return -1;
	UINT n = ::IsDlgButtonChecked(hWnd,nEditControlID);
	switch(n){
	case BST_UNCHECKED : return 0; // {^̃`FbN̓ItɂȂĂ܂B
	case BST_CHECKED : return 1; //{^̃`FbN̓IɂȂĂ܂B 
	case BST_INDETERMINATE : return 2; // {^̓OC\ismj̏ԂłB{^ABS_3STATE X^C܂ BS_AUTO3STATE X^CƂɂKp܂B 
	}
	return -1;	//???
}

///////////////////////////////////////////////////////////////////////////

void	CMsgDlg::Out(const string& caption,const string& message){
/*
	// tXN[ŃtbvgĂ邩mȂ̂
#ifdef USE_DirectDraw
	CDirectDraw* lpDraw = CAppManager::GetMyDirectDraw();
	if (lpDraw!=NULL){
		lpDraw->FlipToGDISurface();
	}
#endif
	CWindow* lpWindow = CAppManager::GetMyApp()->GetMyWindow();
	bool bShowCursor;
	if (lpWindow!=NULL) {
		bShowCursor = lpWindow->IsShowCursor();
		lpWindow->ShowCursor(true);
	}
*/
	::MessageBox(CAppManager::GetHWnd(),message.c_str(),caption.c_str()
		,MB_OK|MB_SYSTEMMODAL|MB_SETFOREGROUND);
/*
	if (lpWindow!=NULL) {
		lpWindow->ShowCursor(bShowCursor);
	}
*/
}

} // end of namespace Window
} // end of namespace yaneuraoGameSDK3rd
