/*
	smart_ptr	: an intelligent pointer
		reprogrammed & desinged by yaneurao(M.Isozaki) '02/02/28
*/

#ifndef __YTLSmartPtr_h__
#define __YTLSmartPtr_h__

#include "../Thread/yaneCriticalSection.h"
#include "ref_deleter.h"
#include "exceptions.h"

namespace yaneuraoGameSDK3rd {
namespace YTL {

//	smart_ptr_base͍폜
//	smart_ptr<void> => smart_obj
//	shared_ptr_ytl<void> => shared_obj
//	typedefĂ̂ŁAȍ~͂gă`

namespace smart_ptr_detail
{
	template<class T> struct smart_ptr_traits {
		typedef T& reference_type;
	};
	template<> struct smart_ptr_traits<void> {
		typedef void reference_type;
	};
}

template<
	class T,
	class ThreadingModel = ThreadingModels::SingleThread
>
class smart_ptr : /*public smart_ptr_base,*/ public ThreadingModel
{
/**
	a real smart pointer
	X}[g|C^NXiz^z񓝍Łj

	iQƃJEgĂāAǂQƂȂȂƂ
	IɃIuWFNĝ悤Ȍ|C^j

	gF
			smart_ptr<CHoge> s1(new CHoge);

		Ƃ悤ɂ΁AƂ́A

			smart_ptr<CHoge> s2;
			s2 = s1;

		Ƃ悤ȃRs[ĂAŌɎcX}[g|C^
		ӔCăIuWFNĝĂI

		@zIuWFNg\F

			smart_ptr<CHoge> s1;
			s1.AddArray(10);
			//	CHoge* s1 = new CHoge[10]; ̈Ӗɋ߂

			//	CHogeDerivedCHogehNX
			s1.AddArray(new CHogeDerived[10],10);
			B

		@z|C^̐AbvLXg\B

		܂ARXgN^explicitŒ`Ă̂ŁA
			void function(smart_array<CHoge> av);
		Ƃ悤Ȋ֐̌ĂяoŁAʂ̃|C^nƂ́A
		L̃X}[g|C^𐶐ēnƁI

		܂A
			function(smart_array<CHoge>(pHoge,false));
		ƂāARXgN^̑Qp[^falseɂČĂяoB

		@ThreadingModel::LockPolicy|V[NXς邱ƂɂĔr̗LI\

		r䂪KvȂƂF
			smart_ptr<CHoge> s1;
		r䂪KvłƂF
			smart_ptr<CHoge, ThreadingModels::MultiThread> s1;


		lB̃NX́A
			gcc version 2.95.3-6 (mingw)
			[command line] g++ -pedantic -Wall -ansi
		ŃRpCʂ͂Hi͂킩Ȃj
*/
public:
	typedef smart_ptr<T, ThreadingModel> self_type;
	typedef typename smart_ptr_detail::smart_ptr_traits<T>::reference_type reference_type;

	///	̃|C^izIuWFNgjRXgN^
	template <class S>
	explicit smart_ptr(S* _P, bool bOwner=true) :
	m_lpObj(NULL) , m_nIndex(0) , m_lpRefObj(NULL)
	/**
		_ṔAIuWFNgn܂B
		bOwneŕA̔zX}[g|C^ɔ߃IuWFNg
			폜ė~Ƃtrueɂ܂BdefaultłtrueB
	*/
	{
		if (_P!=NULL) { Init(_P,bOwner,1); }
			//	SzNXł邱Ƃ͖DD͂
	}

	///	fBtHgRXgN^
	smart_ptr() :	m_lpObj(NULL) , m_nIndex(0) , m_lpRefObj(NULL) {}

	//	Rs[RXgN^
	smart_ptr(const self_type& s){
		inc_ref(s);
	}

	smart_ptr& operator = (const self_type& s){
		if (this != &s) { dec_ref(); inc_ref(s); }
		return *this;
	}

	~smart_ptr() {
		dec_ref();
	}

	///	|C^̂ӂ邽߂̎d|
	reference_type operator*() const  {return *get(); }
	T* operator->() const {return get(); }

	/// vfւ̃ANZX
	reference_type operator [] (const int n) { return *get(n); }

	/**
		|[tBbNȔzIuWFNg擾
		͈͊Oւ̗vfւ̃ANZXɂ́A
		CIndexOutOfBoundsExceptionOo
		NULL|C^ɑ΂ANZXCNullPointerExceptionO
		X}[g|C^NULLǂisNullŃ`FbN̂
		dlŗǂ
	*/
	T* get(const int n=0) const
#ifdef USE_EXCEPTION
		throw(CIndexOutOfBoundsException,CNullPointerException)
#endif
	{
		ThreadingModel::Lock guard(*this);
#ifdef USE_EXCEPTION
		//	̃|C^Null̂ƂNull|C^̎擾iRs[֎~邱ƂɂȂ邪Aŗǂj
		if ( isNull() ) { throw CNullPointerException(); }
		else if ( isEnd() ) { throw CIndexOutOfBoundsException(); }
#endif

		return getPointer(n);
	}

	///	get()̃ANZXᔽȃ|C^łOȂo[W
	T* getPointer(const int n=0) const
	{
		ThreadingModel::Lock guard(*this);
		if ( isNull() ) return NULL;
		return (T*)((BYTE*)m_lpObj + (n+m_nIndex)*get_obj_size());
	}

	/**
		ȉ̃\bhŎ擾łsmart_ptŕA
		QƃJEgLĂ̂ŁAȂ
		zIuWFNgȂ
	*/
	///	zIuWFNĝvfւ̃X}[g|C^擾
	self_type get_smart_ptr(const int n=0) const {
		ThreadingModel::Lock guard(*this);
		return self_type(*this)+=n;	//	indexZ
	}
	///	zIuWFNg̐擪vfւ̃X}[g|C^擾
	self_type begin() const {
		return get_smart_ptr(0-m_nIndex);
	}
	///	z̍Ō̗vf̗̎vfւ̃X}[g|C^擾
	self_type end() const {
		return get_smart_ptr(size()-m_nIndex);
	}
	///	̃|C^z͈̔͊OwĂ邩`FbN
	bool	isEnd() const {
		return (((ULONG)m_nIndex) >= (ULONG)size());
	}

	void	Add(){
	///	LCX^X̒ǉ\
		dec_ref();				//	Ô
		Init(new T,true,1);		//	x
	}
	template <class S>
	void	Add(S*_P){				//	|[tBbNȌ^ł
		dec_ref();				//	Ô
		if (_P!=NULL) {
			Init(_P,true,1);
		}
	}
	//	̂Q̊֐Pɂ܂Ƃ߂
	//	new T̕ŁAT ۃNXƃRpCG[ɂȂB

	template <class S>
	void	Add(S*_P,ref_object*ref){
	/**
		̎iK肵|C^n
		ǐÃX}[g|C^͏Lj

		)	smart_ptr<CHoge> pHoge;
			pHoge.Add(new CHoge,new my_ref_object);
	*/
		dec_ref();
		if (_P!=NULL){
			Init(_P,true,1,false,ref);
		}
	}

	///	L̖|C^̐ݒ
	template <class S>
	void	Set(S*_P){			//	|[tBbNȌ^ł
		dec_ref();				//	Ô
		if (_P!=NULL) {
			Init(_P,false,1);
		}
	}

	///	LȂzCX^X̒ǉ\
	template <class S>
	void	SetArray(S* p, const int n) {
		dec_ref();
		Init(p,false,n,true);
	}

	///	LzCX^X̒ǉ\
	void	AddArray(const int n){
		dec_ref();
		if (n<=0) return ; // Ȃł˂DD
		Init(new T[n],true,n,true);
	}

	template <class S>
	void	AddArray(S*_P, const int n, ref_object*ref=NULL){
	/**
		̎iK肵z|C^n
		ǐÃX}[g|C^͏Lj

		)	smart_ptr<CHoge> pHoge;
			pHoge.Add(new CHoge[10],new my_ref_object);
	*/
		dec_ref();
		if (n<=0) return ; // Ȃł˂DD
		Init(_P,true,n,true,ref);
	}

	template <class RelateType>
	self_type&	UpCast(const smart_ptr<RelateType,ThreadingModel>& s){
	///	IAbvLXg\@@cf.smart_ptr_static_cast
	/**	Âłsmart_ptrԂŃAbvLXgĂ͂Ȃ
		Ȃ킿A
			smart_ptr<CHoge> p;
			p.UpCast(p); // ͂Ă͂Ȃ
	*/
		ThreadingModel::Lock guard(*this);
		if ((void*)this != (void*)&s) {
		//	^ႤmȂ̂ł̒x̃`FbNoȂ
			dec_ref();

			//	ȉinc_ref(s)Ɠ
			m_lpObj		= static_cast<T*>(s.getObj());
			//	̓LXg܂ނ̂ŃAbvLXgłȂ
			//	RpCG[ɂȂ
			m_nIndex	= *(const_cast<smart_ptr<RelateType,ThreadingModel>*>(&s))->getIndex();
			m_lpRefObj	= s.getRefObj();
			if (m_lpRefObj!=NULL) m_lpRefObj->inc_ref();
		}
		return *this;
	}

	template <class RelateType>
	self_type&	DownCast(const smart_ptr<RelateType,ThreadingModel>& s){
	///	IAbvLXg\@@cf.smart_ptr_dynamic_cast
	/**	Âłsmart_ptrԂŃ_ELXgĂ͂Ȃ
		Ȃ킿A
			smart_ptr<CHoge> p;
			p.DownCast(p); // ͂Ă͂Ȃ
	*/
		ThreadingModel::Lock guard(*this);
		if ((void*)this != (void*)&s) {
		//	^ႤmȂ̂ł̒x̃`FbNoȂ
			dec_ref();

			//	ȉinc_ref(s)Ɠ
			m_lpObj		= dynamic_cast<T*>(s.getObj());
			//	̓LXg܂ނ̂Ń_ELXgłȂ
			//	RpCG[ɂȂ
			m_nIndex	=
				*(const_cast<smart_ptr<RelateType,ThreadingModel>*>(&s))->getIndex();
			m_lpRefObj	= s.getRefObj();
			if (m_lpRefObj!=NULL) m_lpRefObj->inc_ref();
		}
		return *this;
	}

	bool	unique() const {
	///	IuWFNgQƂĂ̂BꂩH
		return count()==1;
	}
	int		count()	const {
	///	IuWFNg̎QƐԂ
		ThreadingModel::Lock guard(*this);
		return m_lpRefObj!=NULL?m_lpRefObj->get_ref():0;
	}

	bool	isNull() const {
	///	wĂIuWFNgNULLH
		return m_lpObj==NULL;
	}

	int		size() const {
	///	zIuWFNgȂ΁Aő吔Ԃ
	///	zIuWFNgȂ΁A1Ԃ
		if (m_lpRefObj==NULL) return 0;
		ThreadingModel::Lock guard(*this);
		return m_lpRefObj->get_size();
	}

	void	Delete() {	dec_ref(); }
	///	̃IuWFNĝiÃX}[g|C^Q
	///	Ă΁Aۂdelete܂ł͏oȂj

	///	X}[g|C^̉Z
	void dec() { 
		ThreadingModel::Lock guard(*this);
		m_nIndex--; }
	void inc() { 
		ThreadingModel::Lock guard(*this);
		m_nIndex++; }

	///	Ẑ߂̃Iy[^
	self_type& operator++() {
		inc(); return (*this); }
	self_type operator++(int){
		ThreadingModel::Lock guard(*this);
		self_type _Tmp = *this; inc(); return (_Tmp); }
	self_type& operator--() {
		dec(); return (*this); }
	self_type operator--(int)
		{	ThreadingModel::Lock guard(*this);
		self_type _Tmp = *this; dec(); return (_Tmp); }
	self_type& operator+=(int _N)
		{	ThreadingModel::Lock guard(*this);
		m_nIndex += _N; return (*this); }
	self_type& operator-=(int _N)
		{	ThreadingModel::Lock guard(*this);
		m_nIndex -= _N; return (*this); }
	self_type operator+(int _N) const
		{ self_type _Tmp = *this; return (_Tmp += _N); }
	self_type operator-(int _N) const
		{ self_type _Tmp = *this; return (_Tmp -= _N); }

	///	r̂߂̃Iy[^
	bool operator==(const self_type& _X) const
		{ThreadingModel::Lock guard(*this);
		return (getPointer() == _X.getPointer()); }
	bool operator!=(const self_type& _X) const
		{return (!(*this == _X)); }
	bool operator<(const self_type& _X) const
		{ThreadingModel::Lock guard(*this);
		return (getPointer() < _X.getPointer()); }
	bool operator>(const self_type& _X) const
		{return (_X < *this); }
	bool operator<=(const self_type& _X) const
		{return (!(_X < *this)); }
	bool operator>=(const self_type& _X) const
		{return (!(*this < _X)); }

	///	̎qIuWFNgւ̃|C^Ԃipj
	ref_object* getRefObj() const { return m_lpRefObj; }
	///	IuWFNg̎ipj
	T* getObj() const { return m_lpObj; }
	///	index̎擾(iteratorIɎgpĂƂ)^p
	int* getIndex() { return &m_nIndex; }

protected:
	int		get_obj_size() const {
	//	IuWFNgЂƂ̗vf̃TCYԂipj
		ThreadingModel::Lock guard(*this);
		return m_lpRefObj!=NULL?m_lpRefObj->get_obj_size():0;
	}

	void	set_size(int nSize) {
	///	size֐Ŏ擾łTCYύX
		ThreadingModel::Lock guard(*this);
		if (m_lpRefObj==NULL) return ;
		m_lpRefObj->set_size(nSize);
	}

	//	⏕֐
	template <class S>
	void	Init(S *s,bool bOwner,int nSize,bool bArray=false,ref_object*ref=NULL){
		ThreadingModel::Lock guard(*this);
		//	́A
		//	PDIuWFNg̃NX@QD̃IuWFNg̏L
		//	RD̃IuWFNg̐@SDzIuWFNgǂ
		if (m_lpRefObj!=NULL) delete m_lpRefObj;
		m_nIndex = 0;
		m_lpObj = s;
		//	ŁARpCG[ốA
		//	smart_ptr̃RXgN^̈Ɏw肵Ă^
		//	̃X}[g|C^Ŏw肵Ă^̔hNXŖ̂

		if (nSize==0) return ; // ȂŁHH
#ifdef USE_EXCEPTION
		if (!bOwner && ref!=NULL){
			//	OwnerŖ̂ɉ̃IuWFNgnĂƂ͂ǂH
			throw CSyntaxException("L̂ɉ̃IuWFNgw肳Ă");
		}
#endif
		/*	//	Owner΁AǂIuWFNg͍폜Ȃ
			//	(ref_deleter::dec_ref)
		if (!bOwner) {
			m_lpRefObj = new null_ref_object;
			//	L̂ŉ̂ȂIuWFNg
		} else
		*/	
		if (ref!=NULL) {
			m_lpRefObj = ref;
		} else if (!bArray) {
			m_lpRefObj = new nonarray_ref_object<S>(s);
		} else {
			m_lpRefObj = new array_ref_object<S>(s);
		}
		m_lpRefObj->set_ref(1);
		m_lpRefObj->set_owner(bOwner);
		//	I[i[Ŗ̂łΌĉ̂Ȃ悤ɂĂ
		m_lpRefObj->set_obj_size(sizeof(S));
		m_lpRefObj->set_size(nSize);
	}

	//	QƃJEg̑ip̂݁j
	void	inc_ref(const self_type& s) {
		ThreadingModel::Lock guard(*this);
		m_lpObj		= s.m_lpObj;
		m_nIndex	= s.m_nIndex;
		m_lpRefObj	= s.m_lpRefObj;
		if (m_lpRefObj!=NULL) m_lpRefObj->inc_ref();
	}
	void	dec_ref() {
		ThreadingModel::Lock guard(*this);
		if (m_lpRefObj!=NULL){
			if (m_lpRefObj->dec_ref()){
				//	IuWFNg͉̎qoRō폜
				delete m_lpRefObj;
			}
			m_lpRefObj = NULL;
			m_lpObj = NULL;
		}
	}

private:
	T*		m_lpObj;			//	IuWFNg
	int		m_nIndex;			//	smart_ptrÃIuWFNg
								//	Ԗڂ̗vfwĂ邩
	ref_object* m_lpRefObj;		//	̗pIuWFNg
};

template<typename T>
class shared_ptr_ytl : public smart_ptr<T, ThreadingModels::MultiThread>
{
public:
	typedef	shared_ptr_ytl<T> self_type;
	typedef	smart_ptr<T, ThreadingModels::MultiThread> base_type;

	template <class S>
	explicit shared_ptr_ytl(S* _P, bool bOwner=true) : base_type(_P,bOwner) {};
	shared_ptr_ytl() : base_type() {}
	shared_ptr_ytl(const base_type& s) : base_type(s) {}
};

typedef	smart_ptr<void> smart_obj;
typedef	shared_ptr_ytl<void> shared_obj;

//////////////////////////////////////////////////////////////////////////
//	castpZq(smart_ptr,shared_ptr_ytlɑ΂Ďg)

template <typename T, typename U, class ThreadingModel>
smart_ptr<T, ThreadingModel> smart_ptr_static_cast(const smart_ptr<U, ThreadingModel>& r)
/**
	smart_ptr<U>̎QƃJE^ƁAŕԂsmart_ptr<T>
	QƃJE^Ƃ͋LB(Ȃ킿smart_ptr<U>̎L
	DȂ)

	gp)
		smart_ptr<RealResult> result;
		return smart_ptr_static_cast<IResult>(result);
*/
{	return smart_ptr<T, ThreadingModel>().UpCast(r);	}

template <typename T, typename U, class ThreadingModel>
smart_ptr<T, ThreadingModel> smart_ptr_dynamic_cast(const smart_ptr<U, ThreadingModel>& r)
/**
	smart_ptr<U>̎QƃJE^ƁAŕԂsmart_ptr<T>
	QƃJE^Ƃ͋LB(Ȃ킿smart_ptr<U>̎L
	DȂ)

	gp)
		smart_ptr<RealResult> result;
		return smart_ptr_static_cast<IResult>(result);
*/
{	return smart_ptr<T, ThreadingModel>().DownCast(r);	}

} // end of namespace YTL
} // end of namespace yaneuraoGameSDK3rd

#endif
