/**
	simple string class
		STLstring clasśAVC++67(.NET)ŎقȂ̂
		OŗpӂB
		iSTLPortsςƂ͌Ȃ̂Łj

	implemented by yaneurao(M.Isozaki) '03/04/02
	implemented by coLun(Y.Imamura) '03/04/07 - '03/05/19

	'03/04/25@@substr̕s
	'03/04/27@@rfind̕s(Ɏrfind)
	'03/05/01@@replace̕s
	'03/05/12@@erase̕s
	'03/05/12@@reverse_iterator̕s
	'03/05/13@@rfind̕s(Ɏrfind)
	'03/05/19@@iteratorconst_iterator̒`̌iboostΉj
	'03/06/20@@reverse_iteratorconst_reverse_iteratořiVC6Ήj

	UNICODEł܂ƂȂDDR(LDM)m

	Ȃ񂩏tx݂̏hĊDD

	낢둫Ȃo邩mȂǁAǉA
	˂炨܂Ń[Ă[iOOG
*/

#ifndef __YTLString_h__
#define __YTLString_h__

#include "../YTL/allocator.h"
//#include "../YTL/exceptions.h"
#include <stdexcept>
#include <string>
#include <iterator>
#include <xutility>
//#include <iostream>

namespace yaneuraoGameSDK3rd {
namespace YTL {
namespace YTLstring {
namespace detail {

//	ʂ( ĹM)
struct null_pointer_exception : public std::exception
{
	null_pointer_exception(const char* str) : std::exception(str) {}
};
//	typedefɂƂ܂c
typedef std::out_of_range	index_out_of_bounds_exception;

//	VC6/VC7/STLPortŋʂ̖OȂ̂ŌǎŒ`ȂƂȂ
template<class T> inline
const T& _max(const T& _X, const T& _Y) { return (_X < _Y ? _Y : _X); }
template<class T> inline
const T& _min(const T& _X, const T& _Y) { return (_Y < _X ? _Y : _X); }

}	//	end of namespace detail

template <class E, class T = std::char_traits<E>, class A = YTLallocator::allocator<E> >
class basic_string
{/**
	STL݊stringNX(Ȃ肵ڂ)
	ɒPȎǊقĂDD(_G)
*/
public:
//#!`iC^[^Ȃǂj
	typedef basic_string		self_type;
	typedef T					traits_type;
	typedef A					allocator_type;
	typedef typename T::char_type		char_type;
	typedef typename A::size_type		size_type;
	typedef typename A::difference_type	difference_type;
	typedef typename A::pointer			pointer;
	typedef typename A::const_pointer	const_pointer;
	typedef typename A::reference		reference;
	typedef typename A::const_reference	const_reference;
	typedef typename A::value_type		value_type;
	static const size_type		npos;
	static const char_type		char_null;

	class iterator : public std::iterator<std::random_access_iterator_tag, value_type, difference_type> {
	public:
		typedef iterator					self_type;
		typedef basic_string				parent_type;
		typedef reference					reference_type;
		typedef pointer						pointer_type;
		typedef size_type					size_type;

		self_type() : m_nPos(0),m_pStr(NULL) {}
		self_type(const self_type& i) : m_nPos(i.get()), m_pStr(i.GetStringPtr()) {}
		self_type(size_type n, parent_type* pStr) : m_pStr(pStr) { set(n); }

		//	ANZbT
		parent_type * GetStringPtr() const { return m_pStr; }
		size_type get() const { return m_nPos; }
		void set(size_type n) {
			size_type len=length();
			if(n==npos || len<n)m_nPos=len;
			else m_nPos = n;
		}

		//	*
		reference_type operator* () const {
			parent_type* p = GetStringPtr();
			if ( p==NULL ) {
				throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::iterator::operator* () const");
			}
			return (*p)[m_nPos];
		}
		pointer_type operator->() const { return &(operator*()); }

		//	Zq
		self_type& operator+= (size_type n){
			if(n==npos)set(npos);
			else set(m_nPos+n);
			return *this;
		}
		self_type& operator-= (size_type n){
			if (m_nPos < n) m_nPos = 0;
			else set(m_nPos-n);
			return *this;
		}
		///	Ẑ߂̃Iy[^
		self_type& operator++() { inc(); return (*this); }
		self_type operator++(int) { self_type i = *this; inc(); return i; }
		self_type& operator--() { dec(); return (*this); }
		self_type operator--(int) { self_type i = *this; dec(); return i; }
		self_type operator+(size_type _N) const { self_type i = *this; return i+=_N; }
		self_type operator-(size_type _N) const { self_type i = *this; return i-=_N; }
		difference_type operator-(const self_type & it) const { return m_nPos-it.m_nPos; }

		//	rIy[^
		bool operator== (const self_type& it) const { return (m_nPos == it.m_nPos) && (m_pStr == it.m_pStr); }
		bool operator!= (const self_type& it) const { return !(*this == it); }
		//	size_typeƂ̔rpӂȂstring::nposƔrłȂ
		bool operator== (size_type size) const { if(size==npos)size=length(); return m_nPos == size; }
		bool operator!= (size_type size) const { return !(*this == size); }
		reference_type operator[] (difference_type n) const { return *((*this)+n); }

		void inc(){ set(m_nPos+1); }
		void dec(){ if(0<m_nPos)set(m_nPos-1); }
		size_type length() const { return m_pStr!=0?m_pStr->size():0; }
	protected:
		size_type		m_nPos;	//	0IWȃ|WVŕۑƂ悤
		parent_type*	m_pStr; // eւ̃|C^ƉẐƂend̔肪ł
	};

	class const_iterator : public std::iterator<std::random_access_iterator_tag, value_type, difference_type> {
	public:
		typedef const_iterator				self_type;
		typedef basic_string				parent_type;
		typedef reference					reference_type;
		typedef pointer						pointer_type;
		typedef size_type					size_type;

		self_type() : m_nPos(0), m_pStr(NULL) {}
		self_type(const iterator& i) : m_nPos(i.get()), m_pStr(i.GetStringPtr()) {}
		self_type(const self_type& i) : m_nPos(i.get()), m_pStr(i.GetStringPtr()) {}
		self_type(size_type n, const parent_type* pStr) : m_pStr(pStr) { set(n); }

		//	ANZbT
		parent_type * GetStringPtr() const { return m_pStr; }
		size_type get() const { return m_nPos; }
		void set(size_type n) {
			size_type len=length();
			if(n==npos || len<n)m_nPos=len;
			else m_nPos = n;
		}

		//	*
		reference_type operator* () const {
			parent_type* p = GetStringPtr();
			if ( p==NULL ) {
				throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::const_iterator::operator* () const");
			}
			return (*p)[m_nPos];
		}
		pointer_type operator-> () const { return &(operator*()); }

		//	Zq
		self_type& operator+= (size_type n){
			if(n==npos)set(npos);
			else set(m_nPos+n);
			return *this;
		}
		self_type& operator-= (size_type n){
			if (m_nPos < n) m_nPos = 0;
			else set(m_nPos-n);
			return *this;
		}
		///	Ẑ߂̃Iy[^
		self_type& operator++() { inc(); return (*this); }
		self_type operator++(int) { self_type i = *this; inc(); return i; }
		self_type& operator--() { dec(); return (*this); }
		self_type operator--(int) { self_type i = *this; dec(); return i; }
		self_type operator+(size_type _N) const { self_type i = *this; return i+=_N; }
		self_type operator-(size_type _N) const { self_type i = *this; return i-=_N; }
		difference_type operator-(const self_type& it) const { return m_nPos-it.m_nPos; }

		//	rIy[^
		bool operator== (const self_type& it) const { return (m_nPos == it.m_nPos) && (m_pStr == it.m_pStr); }
		bool operator!= (const self_type& it) const { return !(*this == it); }
		//	size_typeƂ̔rpӂȂstring::nposƔrłȂ
		bool operator== (size_type size) const { if(size==npos)size=length(); return m_nPos == size; }
		bool operator!= (size_type size) const { return !(*this == size); }
		reference_type operator[] (difference_type n) const { return *((*this)+n); }

		void inc(){ set(m_nPos+1); }
		void dec(){ if(0<m_nPos)set(m_nPos-1); }
		size_type length() const { return m_pStr!=0?m_pStr->size():0; }
	protected:
		size_type		m_nPos;	//	0IWȃ|WVŕۑƂ悤
		const parent_type*	m_pStr; // eւ̃|C^ƉẐƂend̔肪ł
	};

	class reverse_iterator : public std::iterator<std::random_access_iterator_tag, value_type, difference_type> {
	public:
		typedef iterator					base_type;
		typedef reverse_iterator			self_type;
		typedef typename base_type::parent_type		parent_type;
		typedef typename base_type::reference_type	reference_type;
		typedef typename base_type::pointer_type		pointer_type;
		typedef typename base_type::size_type		size_type;

		self_type() : m_nPos(0),m_pStr(NULL) {}
		self_type(const self_type& i) : m_nPos(i.get()), m_pStr(i.GetStringPtr()) {}
		self_type(const base_type& i) : m_nPos(i.get()), m_pStr(i.GetStringPtr()) {}
		self_type(size_type n, parent_type* pStr) : m_pStr(pStr) { set(n); }

		//  base
		base_type base() const {
			return base_type(get(), GetStringPtr());
		}

		//	ANZbT
		parent_type * GetStringPtr() const { return m_pStr; }
		size_type get() const { return m_nPos; }
		void set(size_type n) {
			size_type len=length();
			if(n==npos || len<n)m_nPos=len;
			else m_nPos = n;
		}

		//	*
		reference_type operator* () const {
			parent_type* p = GetStringPtr();
			if ( p==NULL ) {
				throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::reverse_iterator::operator* () const");
			}
			return (*p)[m_nPos-1];
		}
		pointer_type operator-> () const { return &(operator*()); }

		//	Zq
		self_type& operator+= (size_type n){
			if (m_nPos < n) m_nPos = 0;
			else set(m_nPos-n);
			return *this;
		}
		self_type& operator-= (size_type n){
			if(n==npos)set(npos);
			else set(m_nPos+n);
			return *this;
		}
		///	Ẑ߂̃Iy[^
		self_type& operator++() { inc(); return (*this); }
		self_type operator++(int) { self_type i = *this; inc(); return i; }
		self_type& operator--() { dec(); return (*this); }
		self_type operator--(int) { self_type i = *this; dec(); return i; }
		self_type operator+(size_type _N) const { self_type i = *this; return i+=_N; }
		self_type operator-(size_type _N) const { self_type i = *this; return i-=_N; }
		difference_type operator-(const self_type & it) const { return it.m_nPos-m_nPos; }

		//	rIy[^
		bool operator== (const self_type& it) const { return (m_nPos == it.m_nPos) && (m_pStr == it.m_pStr); }
		bool operator!= (const self_type& it) const { return !(*this == it); }
		//	size_typeƂ̔rpӂȂstring::nposƔrłȂ
		bool operator== (size_type size) const { if(size==npos)size=length(); return m_nPos == size; }
		bool operator!= (size_type size) const { return !(*this == size); }
		reference_type operator[] (difference_type n) const { return *((*this)+n); }

		void dec(){ set(m_nPos+1); }
		void inc(){ if(0<m_nPos)set(m_nPos-1); }
		size_type length() const { return m_pStr!=0?m_pStr->size():0; }
	protected:
		size_type		m_nPos;	//	0IWȃ|WVŕۑƂ悤
		parent_type*	m_pStr; // eւ̃|C^ƉẐƂend̔肪ł
	};

	class const_reverse_iterator : public std::iterator<std::random_access_iterator_tag, value_type, difference_type> {
	public:
		typedef const_iterator				base_type;
		typedef const_reverse_iterator		self_type;
		typedef typename base_type::parent_type		parent_type;
		typedef typename base_type::reference_type	reference_type;
		typedef typename base_type::pointer_type		pointer_type;
		typedef typename base_type::size_type		size_type;

		self_type() : m_nPos(0),m_pStr(NULL) {}
		self_type(const self_type& i) : m_nPos(i.get()), m_pStr(i.GetStringPtr()) {}
		self_type(const base_type& i) : m_nPos(i.get()), m_pStr(i.GetStringPtr()) {}
		self_type(const reverse_iterator& i)  : m_nPos(i.get()), m_pStr(i.GetStringPtr()) {}
		self_type(const iterator& i)  : m_nPos(i.get()), m_pStr(i.GetStringPtr()) {}
		self_type(size_type n, const parent_type* pStr) : m_pStr(pStr) { set(n); }

		//  base
		base_type base() const {
			return base_type(get(), GetStringPtr());
		}

		//	ANZbT
		parent_type * GetStringPtr() const { return m_pStr; }
		size_type get() const { return m_nPos; }
		void set(size_type n) {
			size_type len=length();
			if(n==npos || len<n)m_nPos=len;
			else m_nPos = n;
		}

		//	*
		reference_type operator* () const {
			parent_type* p = GetStringPtr();
			if ( p==NULL ) {
				throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::const_reverse_iterator::operator* () const");
			}
			return (*p)[m_nPos-1];
		}
		pointer_type operator-> () const { return &(operator*()); }

		//	Zq
		self_type& operator+= (size_type n){
			if(n==npos)set(npos);
			else set(m_nPos+n);
			return *this;
		}
		self_type& operator-= (size_type n){
			if (m_nPos < n) m_nPos = 0;
			else set(m_nPos-n);
			return *this;
		}
		///	Ẑ߂̃Iy[^
		self_type& operator++() { inc(); return (*this); }
		self_type operator++(int) { self_type i = *this; inc(); return i; }
		self_type& operator--() { dec(); return (*this); }
		self_type operator--(int) { self_type i = *this; dec(); return i; }
		self_type operator+(size_type _N) const { self_type i = *this; return i+=_N; }
		self_type operator-(size_type _N) const { self_type i = *this; return i-=_N; }
		difference_type operator-(const self_type & it) const { return it.m_nPos-m_nPos; }

		//	rIy[^
		bool operator== (const self_type& it) const { return (m_nPos == it.m_nPos) && (m_pStr == it.m_pStr); }
		bool operator!= (const self_type& it) const { return !(*this == it); }
		//	size_typeƂ̔rpӂȂstring::nposƔrłȂ
		bool operator== (size_type size) const { if(size==npos)size=length(); return m_nPos == size; }
		bool operator!= (size_type size) const { return !(*this == size); }
		reference_type operator[] (difference_type n) const { return *((*this)+n); }

		void dec(){ set(m_nPos+1); }
		void inc(){ if(0<m_nPos)set(m_nPos-1); }
		size_type length() const { return m_pStr!=0?m_pStr->size():0; }
	protected:
		size_type		m_nPos;	//	0IWȃ|WVŕۑƂ悤
		const parent_type*	m_pStr; // eւ̃|C^ƉẐƂend̔肪ł
	};


//#!RXgN^EfXgN^
	///	̕eƂď܂
	explicit basic_string(const allocator_type& a = allocator_type())
		: m_Allocator(a), m_pszBuffer(NULL), m_nLength(0), m_nCapacity(0)
	{
	}

	///	sŵAlen̕eƂď܂
	basic_string(const char_type* s, size_type len, const allocator_type& a = allocator_type())
		: m_Allocator(a), m_pszBuffer(NULL), m_nLength(0), m_nCapacity(0)
	{
		assign(psz, len);
	}

	///	seƂď܂
	basic_string(const self_type& s)
		: m_Allocator(s.get_allocator()), m_pszBuffer(NULL), m_nLength(0), m_nCapacity(0)
	{
		assign(s);
	}
	///	\0I[seƂď܂
	basic_string(const char_type* s, const allocator_type& a = allocator_type())
		: m_Allocator(a), m_pszBuffer(NULL), m_nLength(0), m_nCapacity(0)
	{
		assign(s);
	}
	///	ch1ׂeƂď܂
	basic_string(const char_type ch, const allocator_type& a = allocator_type())
		: m_Allocator(a), m_pszBuffer(NULL), m_nLength(0), m_nCapacity(0)
	{
		assign(1, ch);
	}
	///	chlenׂeƂď܂
	basic_string(size_type len, char_type ch, const allocator_type& a = allocator_type())
		: m_Allocator(a), m_pszBuffer(NULL), m_nLength(0), m_nCapacity(0)
	{
		assign(len, ch);
	}
	///	[first,last)͈̔͂̕eƂď܂
	template <class InputIterator>
	basic_string(InputIterator first, InputIterator last, const allocator_type& a = allocator_type())
		: m_Allocator(a), m_pszBuffer(NULL), m_nLength(0), m_nCapacity(0)
	{
		assign(first, last);
	}
	///	std::basic_string<E,T,A>^̃IuWFNgsێ镶eƂď܂
	basic_string(const std::basic_string<E,T,A>& s)
		: m_Allocator(s.get_allocator()), m_pszBuffer(NULL), m_nLength(0), m_nCapacity(0)
	{
		assign(s.begin(), s.end());
	}
	///	fXgNg܂(virtual֐)
	~basic_string() {
		_Clear();
	}

//#!WSTLstd::stringƂ̕ϊ
	///	std::basic_string<E,T,A>^̃IuWFNgsێ镶eƂď܂ 
	self_type& operator= (const std::basic_string<E,T,A>& s) {
		assign(s.begin(), s.end());
		return *this;
	}
	///	ێĂ镶̓estd::basic_string<E,T,A>^̃IuWFNg𐶐ĕԂ܂
	operator const std::basic_string<E,T,A> () const {
		return std::basic_string<E,T,A>(c_str(), size());
	}

//#!operator=
	self_type& operator= (const self_type& s){
		assign(s);
		return *this;
	}
	self_type& operator= (const char_type* s){
		assign(s);
		return *this;
	}
	self_type& operator= (char_type ch){
		assign(1, ch);
		return *this;
	}

//#!operator+=
	self_type& operator+= (const self_type & s){
		append(s);
		return *this;
	}
	self_type& operator+= (const char_type * str){
		append(str);
		return *this;
	}
	self_type& operator+= (char_type ch){
		append(1, ch);
		return *this;
	}

//#!operator+
	self_type operator+ (const self_type& s) const {
		self_type tmp;
		tmp.reserve(size() + s.size() + 1);
		tmp.append(*this);
		tmp.append(s);
		return tmp;
	}

//#!rZq
	bool	operator== (const self_type& s) const {
		return (compare(s)==0);
	}
	bool	operator!= (const self_type& s) const {
		return !(*this==s);
	}
	bool	operator< (const self_type& s) const {
		return (compare(s)<0);
	}
	bool	operator> (const self_type& s) const {
		return s < *this;
	}
	bool	operator<= (const self_type& s) const {
		return !(*this > s);
	}
	bool	operator>= (const self_type& s) const {
		return !(*this < s);
	}

//#!operator[]
	///	nڂւ̎QƂԂ܂
	reference operator[] (size_type n) {
		pointer p = getBuffer();
		if ( p==NULL ) return *((pointer)&char_null);
		return *(p+n);
	}
	///	nڂւconstQƂԂ܂
	const_reference operator[] (size_type n) const {
		pointer p = getBuffer();
		if ( p==NULL ) return char_null;
		return *(p+n);
	}

//#!at
	///	nڂւ̎QƂԂ܂
	///	n͈͊Ȍꍇindex_out_of_bounds_exceptionOthrow܂
	reference at (size_type n) {
		if (n<0 || size()<n) {
			throw detail::index_out_of_bounds_exception("in YTL::YTLstring::basic_string::at(size_type n)");
		}
		return (*this)[n];
	}
	///	nڂւconstQƂԂ܂
	///	n͈͊Ȍꍇindex_out_of_bounds_exceptionOthrow܂
	const_reference at (size_type n) const {
		if (n<0 || size()<n) {
			throw detail::index_out_of_bounds_exception("in YTL::YTLstring::basic_string::at(size_type n) const");
		}
		return (*this)[n];
	}

//#!append
	///	sŵAlen̕𖖔ɒǉ܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	self_type& append(const char_type* s, size_type len) {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::append(const char_type* s, size_type len)");
		}
		_Insert(s, len, size());
		return *this;
	}
	///	s𖖔ɒǉ܂
	self_type& append(const self_type& s) {
		if ( s.size()!=0 ) {
			_Insert(s.c_str(), s.size(), size());
		}
		return *this;
	}
	///	sposڂlen𖖔ɒǉ܂
	///	pos͈͊Ȍꍇindex_out_of_bounds_exceptionOthrow܂
	self_type& append(const self_type& s, size_type pos, size_type len) {
		if ( s.size()<pos ) {
			throw detail::index_out_of_bounds_exception("in YTL::YTLstring::basic_string::append(const self_type& s, size_type pos, size_type len)");
		}
		_Insert(s.c_str()+pos, detail::_min(len, s.size()-pos), size());
		return *this;
	}
	///	\0I[s𖖔ɒǉ܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	self_type& append(const char_type* s) {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::append(const char_type* s)");
		}
		const size_type len = traits_type::length(s);
		_Insert(s, len, size());
		return *this;
	}
	///	chlenׂ𖖔ɒǉ܂
	self_type& append(size_type len, char_type ch) {
		_InsertChar(ch, len, size());
		return *this;
	}
	///	[first,last)͈̔͂̕𖖔ɒǉ܂
	template<class InputIterator>
	self_type& append(InputIterator first, InputIterator last) {
		const size_type len = std::distance(first, last);
		_Insert(first, len, size());
		return *this;
	}

//#!assign
	///	sŵAlen̕蓖Ă܂
	self_type& assign(const char_type* s, size_type len) {
		if ( len==0 ) {
			_Clear();
		} else {
			_MakeBuffer(len);
			erase();
			_Insert(s,len,0);
		}
		return *this;
	}
	///	s蓖Ă܂
	self_type& assign(const self_type& s) {
		//	s = s;̂悤Ȏȑɑ΂ăZ[tłȂ΂ȂȂ
		if ( this==&s ) return *this; // Rs[KvȂI
		assign(s.c_str(), s.size());
		return *this;
	}
	///	sposڂlen蓖Ă܂
	///	pos͈͊Ȍꍇindex_out_of_bounds_exceptionOthrow܂
	self_type& assign(const self_type& s, size_type pos, size_type n) {
		if ( s.size()<pos ) {	//	if ( pos==npos || s.size()<=pos ) {
			//assign(NULL, 0);
			//return *this;
			throw detail::index_out_of_bounds_exception("in YTL::YTLstring::basic_string::assign(const self_type& s, size_type pos, size_type n)");
		}
		//if ( n == npos || s.size()<pos+n ) {
		//	n = s.size() - pos;
		//}
		assign(s.c_str()+pos, detail::_min(n, s.size() - pos));
		return *this;
	}
	///	s蓖Ă܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	self_type& assign(const char_type* s) {
		if ( s==NULL ) {
			//assign(s, 0);
			//return *this;
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::assign(const char_type* s)");
		}
		const size_type len = traits_type::length(s);
		assign(s, len);
		return *this;
	}
	///	chlenׂ蓖Ă܂
	self_type& assign(size_type len, char_type ch) {
		if ( len==0 ) {
			_Clear();
		} else {
			_MakeBuffer(len);
			erase();
			_InsertChar(ch, len, 0);
		}
		return *this;
	}
	///	[first,last)͈̔͂̕蓖Ă܂
	template<class InputIterator>
	self_type& assign(InputIterator first, InputIterator last) {
		const size_type len = std::distance(first, last);
		if ( len==0 ) {
			_Clear();
			return *this;
		} else {
			_MakeBuffer(len);
			erase();
			_Insert(first, len, 0);
		}
		return *this;
	}

//#!compare
	///	g̕ƁAsr܂
	///	0AłȂ0ȊOԂ܂
	int compare(const self_type& s) const {
		return _Compare(c_str(), size(), s.c_str(), s.size());
	}
	///	gposڂlen̕ƁAsr܂
	///	0AłȂ0ȊOԂ܂
	///	pos͈͊Ȍꍇindex_out_of_bounds_exceptionOthrow܂
	int compare(size_type pos, size_type len, const self_type& s) const {
		if ( size()<=pos ) {
			//if ( s.size() ) return -1;
			//return 0;
			throw detail::index_out_of_bounds_exception("in YTL::YTLstring::basic_string::compare(size_type pos, size_type len, const self_type& s) const");
		}
		return _Compare(c_str()+pos, detail::_min(len, size() - pos), s.c_str(), s.size());
	}
	///	gposڂlen̕ƁAspos2ڂlen2̕r܂
	///	0AłȂ0ȊOԂ܂
	///	pos/pos2͈͊Ȍꍇindex_out_of_bounds_exceptionOthrow܂
	int compare(size_type pos, size_type len, const self_type& s, size_type pos2, size_type len2) const {
		//if ( size()<=pos ) {
		//	if ( s.size()!=0 ) return -1;
		//	return 0;
		//}
		//if ( s.size()<=pos2 ) {
		//	return 1;
		//}
		if ( size()<=pos || s.size()<=pos2 ) {
			throw detail::index_out_of_bounds_exception("in YTL::YTLstring::basic_string::compare(size_type pos, size_type len, const self_type& s, size_type pos2, size_type len2) const");
		}
		return _Compare(c_str()+pos, detail::_min(len, size() - pos), s.c_str()+pos2, detail::_min(len2, s.size() - pos2));
	}
	///	g̕ƁAsr܂
	///	0AłȂ0ȊOԂ܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	int compare(const char_type* s) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::compare(const char_type* s) const");
		}
		const size_type len = traits_type::length(s);
		return _Compare(c_str(), size(), s, len);
	}
	///	gposڂlen̕ƁAspos2ڈȍ~̕r܂
	///	0AłȂ0ȊOԂ܂
	///	pos͈͊Ȍꍇindex_out_of_bounds_exceptionOthrow܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	int compare(size_type pos, size_type len, const char_type* s, size_type pos2) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::compare(size_type pos, size_type len, const char_type* s, size_type pos2) const");
		}
		if ( size()<=pos ) {
			//if(s.size())return -1;
			//return 0;
			throw detail::index_out_of_bounds_exception("in YTL::YTLstring::basic_string::compare(size_type pos, size_type len, const char_type* s, size_type pos2) const");
		}
		return _Compare(c_str()+pos, detail::_min(len, size() - pos), s, len2);
	}

//#!substr
	///	posڂlen̕𐶐ĕԂ܂
	///	pos͈͊Ȍꍇindex_out_of_bounds_exceptionOthrow܂
	self_type substr(size_type pos = 0, size_type len = npos) const {
		if ( size()<=pos ) {
			throw detail::index_out_of_bounds_exception("in YTL::YTLstring::basic_string::substr(size_type pos = 0,size_type n = npos) const");
		}
		return self_type().assign(*this, pos, len);
	}

//#!erase
	///	[first,last)͈̔͂̕폜܂
	iterator erase(iterator first, iterator last) {
		// firstbegin()@@lastend() ̂ƂA܂邲Ə
		_Erase(first.get(), last.get() - first.get());
		return first;
	}
	///	posڂlen폜܂
	self_type& erase(size_type pos = 0, size_type len = npos) {
		// pos0@@lennpos ̂ƂA܂邲Ə
		_Erase(pos, len);
		return *this;
	}
	///	itw폜܂
	iterator erase(iterator it) {
		_Erase(it.get(), 1);
		return it;
	}

//#!copy
	///	obt@sɁAgposڂlen̕Rs[ARs[Ԃ܂
	///	pos͈͊Ȍꍇindex_out_of_bounds_exceptionOthrow܂
	size_type copy(char_type* s, size_type len, size_type pos=0) const {
		if ( size()<=pos ) {
			throw detail::index_out_of_bounds_exception("in YTL::YTLstring::basic_string::copy(char_type* s, size_type len, size_type pos=0) const");
		}
		//if (len == npos || size()<len || size()<pos+len)len=size()-pos;	//	detail::_min(len, size()-pos)ł
		_NCopy(s, c_str()+pos, detail::_max(detail::_min(len, size()-pos), 0));
		return len;
	}

//#!c_str()data()
	///	\0I[Ԃ܂Bistring'\0'܂ޏꍇ́A'\0'̎O܂łCꕶƂĐɔF܂j
	const char_type* c_str() const {
		const char_type* p = getBuffer();
		return (p!=NULL) ? p : &char_null;	//	0̏ꍇłKmۂĂ܂ŁEEE
	}
	///	f[^̐擪|C^Ԃ܂B
	const char_type* data() const {
		return c_str();
	}

//#!find
	///	posڂ珇Ɍ܂iΏہFs̐擪lenj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	size_type find(const char_type* s, size_type pos, size_type len) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::find(const char_type* s, size_type pos, size_type len) const");
		}
		const size_type _size = size();
		if ( len==0 && pos<=_size ) return pos;		//	͈͓Ȃ󕶎͏Ƀ}b`Ȃ炵
		if ( pos<_size && len<=_size-pos ) {
			const_pointer _first = getBuffer();
			const_pointer _last = _first + _size - len + 1;
			const_pointer _it = _first + pos;
			while ( _it != _last ) {	//	char_traits<E>::searchđRׂƎvc
				if ( traits_type::eq(*_it, *s) ) {
					if ( 0==traits_type::compare(_it, s, len) ) { return (_it - _first); }
				}
				++_it;
			}
		}

		return npos;
	}
	///	posڈȍ~Ɍ܂iΏہFsŚj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	size_type find(const char_type* s, size_type pos = 0) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::find(const char_type* s, size_type pos = 0) const");
		}
		const size_type len = traits_type::length(s);	//	null`FbNĂȂc
		return find(s, pos, len);
	}
	///	posڈȍ~Ɍ܂iΏہFsŚj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	size_type find(const basic_string& s, size_type pos = 0) const{
		return find(s.c_str(), pos, s.size());
	}
	///	posڈȍ~Ɍ܂iΏہFchj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	size_type find(char_type ch, size_type pos = 0) const{
		return find_first_of(ch, pos);
	}

//#!rfind
	///	posڈȑOtɌ܂iΏہFs̐擪lenj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	size_type rfind(const char_type* s, size_type pos, size_type len) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::rfind(const char_type* s, size_type pos, size_type len) const");
		}
		const size_type _size = size();
		if ( len==0 ) return detail::_min(pos, _size);
		if ( len <= _size ) {
			const_pointer _rev_first = _first + detail::_min(pos, _size - len);
			const_pointer _rev_last = getBuffer();
			for ( const_pointer _it = _rev_first; ; --_it; ) {
				if ( traits_type::eq(*_it, *s) ) {
					if ( 0==traits_type::compare(_it+1, s+1, len-1) ) { return (_it - _first); }
				}
				else if ( _it!=_rev_last ) return npos;
			}
		}
		return npos;
	}
	///	posڈȑOtɌ܂iΏہFsŚj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	size_type rfind(const char_type* s, size_type pos = npos) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::rfind(const char_type* s, size_type pos = npos) const");
		}
		const size_type len = traits_type::length(s);
		return rfind(s, pos, len);
	}
	///	posڈȑOtɌ܂iΏہFsŚj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	size_type rfind(const basic_string& s, size_type pos = npos) const {
		return rfind(str.c_str(),pos,str.size());
	}
	///	posڈȑOtɌ܂iΏہFchj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	size_type rfind(char_type ch, size_type pos = npos) const {
		return find_last_of(ch, pos);
	}

//#!find_first_of
	///	posڈȍ~Ɍ܂iΏہFs̐擪len̕Ɋ܂܂镶̂ꂩj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	size_type find_first_of(const char_type* s, size_type pos, size_type len) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::find_first_of(const char_type* s, size_type pos, size_type len) const");
		}
		const size_type _size = size();
		if ( pos<_size ) {
			const_pointer _first = getBuffer();
			const_pointer _last = _first + _size - 1 + 1;
			const_pointer _it = _first + pos;
			while ( _it != _last ) {
				for ( size_type i=0; i<len; ++i ) {
					if ( traits_type::eq(*_it, s[i]) ) { return (_it - _first); }
				}		
				++_it;
			}
		}
		return npos;
	}
	///	posڈȍ~Ɍ܂iΏہFsɊ܂܂镶̂ꂩj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	size_type find_first_of(const self_type& s, size_type pos=0) const {
		return find_first_of(s.c_str(), pos, s.size());
	}
	///	posڈȍ~Ɍ܂iΏہFsɊ܂܂镶̂ꂩj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	size_type find_first_of(const char_type* s, size_type pos=0) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::find_first_of(const char_type* s, size_type pos=0) const");
		}
		const size_type len = traits_type::length(s);
		return find_first_of(s, pos, len);
	}
	///	posڈȍ~Ɍ܂iΏہFchj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	size_type find_first_of(char_type ch, size_type pos=0) const {
		const size_type _size = size();
		if ( pos<_size ) {
			const_pointer _first = getBuffer();
			const_pointer _last = _first + _size;
			const_pointer _it = _first + pos;
			while ( _it != _last ) {
				if ( traits_type::eq(*_it, ch) ) { return (_it - _first); }
				++_it;
			}
		}
		return npos;
	}

//#!find_first_not_of
	///	posڈȍ~Ɍ܂iΏہFs̐擪len̕Ɋ܂܂Ȃj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	size_type find_first_not_of(const char_type* s, size_type pos, size_type len) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::find_first_not_of(const char_type* s, size_type pos, size_type len) const");
		}
		const size_type _size = size();
		if ( pos<size ) {
			const_pointer _first = getBuffer();
			const_pointer _last = _first + size - 1 + 1;
			const_pointer _it = _first + pos;
			while ( _it != _last ) {
				for ( size_type i=0; i<len; ++i ) {
					if ( !traits_type::eq(*_it, s[i]) ) { return (_it - _first); }
				}
				++_it;
			}
		}
		return npos;
	}
	///	posڈȍ~Ɍ܂iΏہFsɊ܂܂Ȃj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	size_type find_first_not_of(const self_type& s, size_type pos=0) const {
		return find_first_not_of(s.c_str(), pos, s.size());
	}
	///	posڈȍ~Ɍ܂iΏہFsɊ܂܂Ȃj
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	size_type find_first_not_of(const char_type* s, size_type pos=0) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::find_first_not_of(const char_type* s, size_type pos=0) const");
		}
		const size_type len = traits_type::length(s);
		return find_first_not_of(s, pos, len);
	}
	///	posڈȍ~Ɍ܂iΏہFchȊO̕j
	///	ΏۂƂÄʒu[IWŕԂ܂
	///	ȂnposԂ܂
	size_type find_first_not_of(char_type ch, size_type pos=0) const {
		const size_type _size = size();
		if ( pos<size ) {
			const_pointer _first = getBuffer();
			const_pointer _last = _first + size - 1 + 1;
			const_pointer _it = _first + pos;
			while ( _it != _last ) {
				if ( !traits_type::eq(*_it, ch) ) { return (_it - _first); }
				++_it;
			}
		}
		return npos;
	}

//#!find_last_of
	// sn܂len̕Ɋ܂܂邢ꂩ̕AstringposڈȑOt
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	size_type find_last_of(const char_type* s, size_type pos, size_type len) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::find_last_of(const char_type* s, size_type pos, size_type len) const");
		}
		const size_type _size = size();
		if ( 0<len && 0<_size ) {
			const_pointer _first = getBuffer();
			const_pointer _rev_first = _first + detail::_min(pos, _size - 1);
			for ( const_pointer _it = _rev_first; ; --_it; ) {
				if ( traits_type::find(s, len, *_it) ) { return (_it - _first); }
				else if ( _it==_first ) return npos;
			}
		}
		return npos;
	}
	// sɊ܂܂邢ꂩ̕AstringposڈȑOt
	size_type find_last_of(const self_type& s, size_type pos=npos) const {
		return find_last_of(s.c_str(), pos, s.size());
	}
	// CꕶsɊ܂܂邢ꂩ̕AstringposڈȑOt
	size_type find_last_of(const char_type* s, size_type pos=npos) const {
		if(s==NULL)return npos;
		const size_type len = traits_type::length(s);
		return find_last_of(s, pos, len);
	}
	// cAstringposڈȑOt
	size_type find_last_of(char_type ch, size_type pos=npos) const {
		const size_type _size = size();
		if ( 0<_size ) {
			const_pointer _first = getBuffer();
			const_pointer _rev_first = _first + detail::_min(pos, _size - 1);
			for ( const_pointer _it = _rev_first; ; --_it ) {
				if ( traits_type::eq(ch, *_it) ) { return (_it - _first); }
				else if ( _it==_first ) return npos;
			}
		}
		return npos;
	}

//#!find_last_not_of
	// sn܂n̕Ɋ܂܂Ȃꂩ̕AstringposڈȑOt
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	size_type find_last_not_of(const char_type* s, size_type pos, size_type len) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::find_last_not_of(const char_type* s, size_type pos, size_type len) const");
		}
		const size_type _size = size();
		if ( 0<_size ) {
			const_pointer _first = getBuffer();
			const_pointer _rev_first = _first + detail::_min(pos, _size - 1);
			for ( const_pointer _it = _rev_first; ; --_it ) {
				if ( !traits_type::find(s, len, *_it) ) { return (_it - _first); }
				else if ( _it==_first ) return npos;
			}
		}
		return npos;
	}
	// sɊ܂܂Ȃꂩ̕AstringposڈȑOt
	size_type find_last_not_of(const self_type & s, size_type pos=npos) const {
		return find_last_not_of(s.c_str(), pos, s.size());
	}
	// CꕶsɊ܂܂Ȃꂩ̕AstringposڈȑOt
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	size_type find_last_not_of(const char_type* s, size_type pos=npos) const {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::find_last_not_of(const char_type* s, size_type pos) const");
		}
		const size_type len = traits_type::length(s);
		return find_last_not_of(s, pos, len);
	}
	// cȊO̕AstringposڈȑOt
	size_type find_last_not_of(char_type ch, size_type pos=npos) const {
		const size_type _size = size();
		if ( 0<_size ) {
			const_pointer _first = getBuffer();
			const_pointer _rev_first = _first + detail::_min(pos, _size - 1);
			for ( const_pointer _it = _rev_first; ; --_it ) {
				if ( !traits_type::eq(ch, *_it) ) { return (_it - _first); }
				else if ( _it==_first ) return npos;
			}
		}
		return npos;
	}

//#!get_allocator
	// AP[^Ԃ܂
	allocator_type get_allocator() const {
		return m_Allocator;
	}

//#!insert
	// posڂstrŎn܂len̕}܂
	self_type& insert(size_type pos, const char_type* s, size_type len) {
		_Insert(s, len, pos);
		return *this;
	}
	// posڂCꕶs}܂
	///	sNULL̏ꍇnull_pointer_exceptionOthrow܂
	self_type& insert(size_type pos, const char_type* s) {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::insert(size_type pos, const char_type *str)");
		}
		const size_type len = traits_type::length(s);
		_Insert(s, len, pos);
		return *this;
	}
	// posڂɕstr}܂
	self_type& insert(size_type pos, const self_type& s) {
		_Insert(s.c_str(), s.size(), pos);
		return *this;
	}
	// posڂstrindex2ڂlen̕}܂
	self_type& insert(size_type pos, const self_type& s, size_type pos2, size_type len) {
		const size_type _size = s.size();
		if ( pos2<_size() ) {
			_Insert(s.c_str()+pos2, detail::_min(len, _size-pos2), pos);
		}
		return *this;
	}
	// posڂɕchlenׂ}܂
	self_type& insert(size_type pos, size_type len, char_type ch) {
		_InsertChar(ch, len, pos);
		return *this;
	}
	// pos̏ꏊɕchlenׂ}܂
	void insert(iterator pos, size_type len, char_type ch) {
		_InsertChar(ch, len, pos.get());
		return *this;
	}
	// pos̏ꏊɕch}܂
	iterator insert(iterator pos, char_type ch) {
		_InsertChar(ch, 1, pos.get());
		return pos;
	}
	// pos̏ꏊstart`end̎}܂
	template<class InputIterator>
	void insert(iterator pos, InputIterator first, InputIterator last) {
		const size_type len = std::distance(first, last);
		_Insert(first, len, pos.get());
	}

//#!max_size
	///	ő̒̕𓾂܂
	size_type max_size() const{
		return get_allocator().max_size();
	}

//#!begin()end()
	// ŏ̃̕C^[^Ԃ܂iconstj
	const_iterator begin() const { return const_iterator(0, this); }
	// ŏ̃̕C^[^Ԃ܂
	iterator begin() { return iterator(0, this); }
	// I[̃C^[^Ԃ܂iconstj
	const_iterator end() const { return const_iterator(npos, this); }
	// I[̃C^[^Ԃ܂
	iterator end() { iterator it(npos, this); return it; }

//#!rbegin()rend()
	// t猩čŏ̃̕o[XC^[^Ԃ܂iconstj
	const_reverse_iterator rbegin() const { return const_reverse_iterator(end()); }
	// t猩čŏ̃̕o[XC^[^Ԃ܂
	reverse_iterator rbegin() { return reverse_iterator(end()); }
	// t猩ďI[̃o[XC^[^Ԃ܂iconstj
	const_reverse_iterator rend() const { return const_reverse_iterator(begin()); }
	// t猩ďI[̃o[XC^[^Ԃ܂
	reverse_iterator rend() { return reverse_iterator(begin()); }

//#!replace
	// posڂlenAstrƒu܂
	self_type& replace(size_type pos, size_type len, const self_type& s) {
		_Replace(s.c_str(), s.size(), pos, len);
		return *this;
	}
	// posڂlenAstrpos2ڂlen2ƒu܂
	self_type& replace(size_type pos, size_type len, const self_type& s, size_type pos2, size_type len2) {
		const size_type _size = s.size();
		if ( pos2==npos || _size<=pos2 ) {
			_Erase(pos, len);
		} else {
			_Replace(str.c_str()+pos2, detail::_min(len2, (_size-pos2)), pos, len);
		}
		return *this;
	}
	// posڂlenACꕶstrƒu܂
	self_type& replace(size_type pos, size_type len, const char_type* s) {
		if ( s==NULL ) {
			throw detail::null_pointer_exception("in YTL::YTLstring::basic_string::replace(size_type pos, size_type len, const char_type* s)");
		}
		const size_type len2 = traits_type::length(s);
		_Replace(s, len2, pos, len);
		return *this;
	}
	// posڂlenAlen2̕chŒu܂
	self_type& replace(size_type pos, size_type len, size_type len2, char_type ch) {
		_ReplaceChar(ch, len2, pos, len);
		return *this;
	}

	// start`end̋ԂAstrŒu܂
	self_type& replace(iterator start, iterator end, const self_type& s) {
		const size_type len = std::distance(first, last);
		_Replace(s.c_str(), s.size(), start.get(), len);
		return *this;
	}
	// start`end̋ԂACꕶstrŒu܂
	self_type& replace(iterator first, iterator last, const char_type* s) {
		const size_type len = std::distance(first, last);
		const size_type len2 = traits_type::length(s);
		_Replace(str.c_str(), len2, first.get(), len);

		return *this;
	}
	// start`end̋ԂAlen̕chŒu܂
	self_type& replace(iterator first, iterator last, size_type len, char_type ch){
		const size_type len2 = traits_type::length(s);
		_ReplaceChar(ch, len, start.get(), len2);
		return *this;
	}
	// start`end̋ԂAʃReistart2`end2Œu܂
	template<class InputIterator> self_type & replace(iterator first, iterator last, InputIterator first2, InputIterator last2){
		const size_type len = std::distance(first, last);
		const size_type len2 = std::distance(first2, last2);
		_Replace(first2, len2, first.get(), len);
		return *this;
	}

//#!reserve
	// lenȏ[ł郁mۂ܂
	void reserve(size_type len=0) {
		//size()+1<=capacity()Ȃ̂Ŕr͂POK
		_MakeBuffer(len);
		if ( len < capacity() ) {
		} else {	//	mۂȂ?
			pointer pBuf;
			size_type cap;
			myAlloc(len+1, pBuf, cap);

			pointer p = pBuf;
			_Copy(p, getBuffer(), size()+1);

			_Destroy(getBuffer(), size()+1);
			myFree(getBuffer());
			m_pszBuffer = pBuf;
			m_nCapacity = cap;
		}
	}

//#!resize
	// ̃TCYύX܂BȂ͕chŖ܂܂
	void resize(size_type len, char_type ch){
		if ( len<0 ) {
			_Clear();
			return;
		}
		else if ( len==size() ) return;

		_MakeBuffer(len);
		if ( len<size() ) {
			pointer p=m_pszBuffer+size()-len;
			_Copy(p,m_pszBuffer+size(), 1, m_pszBuffer+size()+1);
			_Destroy(m_pszBuffer+len+1, size()-len);
			m_nLength=len;
		} else {
			reserve(len);
			pointer p=m_pszBuffer+len;
			_CopyRev(p, m_pszBuffer+size(), 1, m_pszBuffer+size()+1);
			p=m_pszBuffer+size();
			_Fill(p, ch, len-size(), p+1);
			m_nLength=len;
		}
	}
	// ̃TCYύX܂
	void resize(size_type len){
		if ( len<0 ) {
			_Clear();
			return;
		}
		else if ( len==size() ) return;

		_MakeBuffer(len);
		if ( len<size() ) {
			pointer p=m_pszBuffer+size()-len;
			_Copy(p,m_pszBuffer+size(), 1, m_pszBuffer+size()+1);
			_Destroy(m_pszBuffer+len+1, size()-len);
			m_nLength=len;
		} else {
			resize(len, char_type());
		}
	}

//#!swap
	// Q̒̕gւ܂BiAhXւĂ̂ŁAAP[^ɓւĂ܂j
	void swap(self_type& s) {
		std::swap(m_pszBuffer, s.m_pszBuffer);
		std::swap(m_nCapacity, s.m_nCapacity);
		std::swap(m_nLength, s.m_nLength);
		std::swap(m_Allocator, s.m_Allocator);
	}

//#!oϐ̏K
	size_type capacity() const { return m_nCapacity; }
	bool empty() const { return size()==0; }

	size_type	size() const {
		return m_nLength;
	}
	size_type	length() const {
		return size();
	}

protected:

//#!oϐ
	pointer			m_pszBuffer;
	size_type		m_nLength;
	//	nLength!=0 ̂ƂAm_pszBuffeŕA
	//	sizeof(E) * (m_nLength+1)mۂĂ
	//				(+1Ȃ̂͏I[񂪂̂)
	size_type		m_nCapacity;	//	mۂTCY(2^nPʂŊm)
	allocator_type	m_Allocator;

	///	obt@𓾂
	pointer getBuffer() const { return m_pszBuffer; }

//#!mۃ\bh
	///	nSize : mۂTCY
	///	pBuf  : mۂ|C^
	///	capa  : ۂɊmۂTCY(2^nŃAC)
	void myAlloc(size_type nSize,pointer&pBuf,size_type& capa) {
		//	2^nɃAC
		size_type n = nSize;
		size_type c = 1;
		while ( n!=0 ) {
			n>>=1; c<<=1;
		}
		pBuf = m_Allocator.allocate(c,(pointer)0);//new E[c];
		capa = c;
	}

//#!\bh
	///	myAllocŊmۂ
	void myFree(pointer pBuf) {
		if ( pBuf!=NULL ) {
			m_Allocator.deallocate(pBuf, m_nCapacity);//delete [] pBuf;
		}
	}

protected:///////////////////////////////////////////////////////////
//CX^XEĂ邵ĂȂ̈ւ̃Rs[
	//Ō̃|C^insȍ~̓CX^XĂȂB
	//template<class InputIterator> void _Copy(pointer& p,InputIterator start, InputIterator end, pointer ins=NULL){
	//	while(start!=end){
	//		if(p<ins)	*(p++)=*(start++);
	//		else		m_Allocator.construct(p++,*(start++));
	//	}
	//}
	template<class InputIterator> static void _NCopy(pointer& p,InputIterator start, size_type n){
		for(size_type i=0;i<n;i++){
			*(p++)=*(start++);
		}
	}
	template<class InputIterator> void _Copy(pointer& p,InputIterator start, size_type n, pointer ins=NULL){
		for(size_type i=0;i<n;i++){
			if(p<ins)	*(p++)=*(start++);
			else		m_Allocator.construct(p++,*(start++));
		}
	}
	template<class InputIterator> void _CopyRev(pointer& p,InputIterator start, size_type n, pointer ins=NULL){
		{for(size_type i=0;i<n;i++){
			p++;start++;
		}}
		pointer p2=p;
		{for(size_type i=0;i<n;i++){
			if(--p2<ins)	*(p2)=*(--start);
			else		m_Allocator.construct(p2,*(--start));
		}}
	}
	void _Fill(pointer& p,const_reference x, size_type n, pointer ins=NULL){
		for(size_type i=0;i<n;i++){
			if(p<ins)	*(p++)=x;
			else		m_Allocator.construct(p++,x);
		}
	}
//CX^Ẍ
	void _Destroy(pointer s, size_type n){
		for(size_type i=0;i<n;++i){
			m_Allocator.destroy(s++);
		}
	}
//#! vCx[gɉBꂽ{\bh
	template<class InputIterator> void _Insert(InputIterator it, size_type len, size_type pos){
		if(len<=0)return;
		if(pos==npos || size()<pos)pos=size();

		_MakeBuffer(len);
		if(size()+len+1<=capacity()){
			pointer p=m_pszBuffer+pos+len;
			_CopyRev(p, m_pszBuffer+pos, size()-pos+1, m_pszBuffer+size()+1);
			p=m_pszBuffer+pos;
			_Copy(p, it, len, m_pszBuffer+size()+1);
		}
		else{
			pointer pBuf;
			size_type cap;
			myAlloc(size()+len+1,pBuf,cap);

			pointer p=pBuf;
			_Copy(p, m_pszBuffer, pos);
			_Copy(p, it, len);
			_Copy(p, m_pszBuffer+pos, size()-pos+1);

			_Destroy(m_pszBuffer, size()+1);
			myFree(m_pszBuffer);
			m_pszBuffer = pBuf;
			m_nCapacity = cap;
		}
		m_nLength+=len;
	}
	void _InsertChar(const_reference ch, size_type len, size_type pos){
		if(len<=0)return;
		if(pos==npos || size()<pos)pos=size();

		_MakeBuffer(len);
		if(size()+len+1<=capacity()){
			pointer p=m_pszBuffer+pos+len;
			_CopyRev(p, m_pszBuffer+pos, size()-pos+1, m_pszBuffer+size()+1);
			p=m_pszBuffer+pos;
			_Fill(p, ch, len, m_pszBuffer+size()+1);
		}
		else{
			pointer pBuf;
			size_type cap;
			myAlloc(size()+len+1,pBuf,cap);

			pointer p=pBuf;
			_Copy(p, m_pszBuffer, pos);
			_Fill(p, ch, len);
			_Copy(p, m_pszBuffer+pos, size()-pos+1);

			_Destroy(m_pszBuffer, size()+1);
			myFree(m_pszBuffer);
			m_pszBuffer = pBuf;
			m_nCapacity = cap;
		}
		m_nLength+=len;
	}
	template<class InputIterator> void _Replace(InputIterator it, size_type len, size_type pos, size_type len2){
		if(len<=0)return;
		if(pos==npos || size()<=pos){
			_Insert(it, len, pos);
			return;
		}
		if(len2==npos || size()<len2 || size()<len2+pos)len2=size()-pos;

		_MakeBuffer(len);
		if(len2<=len){
			if(size()+len-len2+1<=capacity()){
				if(len2!=len){
					pointer p=m_pszBuffer+pos+len;
					_CopyRev(p, m_pszBuffer+pos+len2, size()-pos-len2+1, m_pszBuffer+size()+1);
				}
				pointer p=m_pszBuffer+pos;
				_Copy(p, it, len, m_pszBuffer+size()+1);
			}
			else{
				pointer pBuf;
				size_type cap;
				myAlloc(size()+len-len2+1,pBuf,cap);

				pointer p=pBuf;
				_Copy(p, m_pszBuffer, pos);
				_Copy(p, it, len);
				_Copy(p, m_pszBuffer+pos+len2, size()-pos-len2+1);

				_Destroy(m_pszBuffer, size()+1);
				myFree(m_pszBuffer);
				m_pszBuffer = pBuf;
				m_nCapacity = cap;
			}
		}
		else{
			pointer p=m_pszBuffer+pos;
			_Copy(p, it, len, m_pszBuffer+size()+1);
			_Copy(p, m_pszBuffer+pos+len2, size()-pos-len2+1, m_pszBuffer+size()+1);
			_Destroy(m_pszBuffer+size()+len-len2+1, len2-len);
		}
		m_nLength+=len-len2;
	}

	void _ReplaceChar(const_reference ch, size_type len, size_type pos, size_type len2){
		if(len<=0)return;
		if(pos==npos || size()<=pos){
			_InsertChar(ch, len, pos);
			return;
		}
		if(len2==npos || size()<len2 || size()<len2+pos)len2=size()-pos;

		_MakeBuffer(len);
		if(len2<=len){
			if(size()+len-len2+1<=capacity()){
				pointer p;
				if(len2!=len){
					p=m_pszBuffer+pos+len;
					_CopyRev(p, m_pszBuffer+pos+len2, size()-pos-len2+1, m_pszBuffer+size()+1);
				}
				p=m_pszBuffer+pos;
				_Fill(p, ch, len, m_pszBuffer+size()+1);
			}
			else{
				pointer pBuf;
				size_type cap;
				myAlloc(size()+len-len2+1,pBuf,cap);

				pointer p=pBuf;
				_Copy(p, m_pszBuffer, pos);
				_Fill(p, ch, len);
				_Copy(p, m_pszBuffer+pos+len2, size()-pos-len2+1);

				_Destroy(m_pszBuffer, size()+1);
				myFree(m_pszBuffer);
				m_pszBuffer = pBuf;
				m_nCapacity = cap;
			}
		}
		else{
			pointer p=m_pszBuffer+pos;
			_Fill(p, ch, len, m_pszBuffer+size()+1);
			_Copy(p, m_pszBuffer+pos+len2, size()-pos-len2+1, m_pszBuffer+size()+1);
			_Destroy(m_pszBuffer+size()+len-len2+1, len2-len);
		}
		m_nLength+=len-len2;
	}

	void _Erase(size_type pos, size_type len){
		if(size()<=pos){
			return;
		}
		if(len==npos || size()<len || size()<len+pos){
			len=size()-pos;
			if(pos==0){
				_Clear();
				return;
			}
		}
		pointer p=m_pszBuffer+pos;
		_Copy(p, m_pszBuffer+pos+len, size()-pos-len+1, m_pszBuffer+size()+1);
		_Destroy(m_pszBuffer+size()-len+1, len);
		m_nLength-=len;
	}

	int _Compare(const_pointer str, size_type len, const_pointer str2, size_type len2) const {
		const int cmp = traits_type::compare(str, str2, detail::_min(len, len2));
		return cmp != 0 ? cmp : (len < len2 ? -1 : (len > len2 ? 1 : 0));
	}

	void _Clear() {
		if ( m_pszBuffer!=NULL ) {
			_Destroy(m_pszBuffer, size()+1);
			myFree(m_pszBuffer);
		}
		m_pszBuffer=NULL;
		m_nLength=0;
		m_nCapacity=0;
	}
	void _MakeBuffer(size_type len=0) {
		if ( m_pszBuffer==NULL ) {
			m_nLength = 0;
			myAlloc(len+1, m_pszBuffer, m_nCapacity);
			pointer p = m_pszBuffer;
			_Fill(p, char_type(), 1);
		}
	}

};	//	end of class basic_string<E,T,A>

//	Iy[^
template <class E,class T,class A>
basic_string<E,T,A>	operator+ (E* pBuf, const basic_string<E,T,A>&s2) {
	return basic_string<E,T,A>(pBuf) += s2;
}

template <class E,class T,class A>
basic_string<E,T,A>	operator+ (E ch, const basic_string<E,T,A>&s2) {
	return basic_string<E,T,A>(ch) += s2;
}

//*			// streamւ̑Ή@Ԑڔ
template <class E,class T,class A>
std::basic_ostream<E,T> & operator<<(std::basic_ostream<E,T>& o, const basic_string<E,T,A>& s){
	std::basic_string<E,T,A> str(s.c_str(), s.size());
	o << str;
	return o;
}
template <class E,class T,class A>
std::basic_istream<E,T> & operator>>(std::basic_istream<E,T>& i, basic_string<E,T,A>& s){
	std::basic_string<E,T,A> str;
	i >> str;
	s.assign(str.begin(), str.end());
	return i;
}
template <class E,class T,class A>
std::basic_istream<E,T> & getline(std::basic_istream<E,T>& i, basic_string<E,T,A>& s, E delim){
	std::basic_string<E,T,A> str;
	getline(i, str, delim);
	s.assign(str.begin(), str.end());
	return i;
}
/*/			// streamւ̑Ή@ڔ
template <class E,class T,class A>
std::basic_ostream<E,T> & operator<<(std::basic_ostream<E,T>& o, const basic_string<E,T,A>& s){
	o.write(s.c_str(), (std::streamsize)s.size());
	return o;
}
template <class E,class T,class A>
std::basic_istream<E,T> & operator>>(std::basic_istream<E,T>& i, basic_string<E,T,A>& s){
	std::size_t w=i.width();
	std::ios_base::iostate st = std::ios_base::goodbit;
	s.erase();
	//s.reserve(w);
	for(T::int_type ch=i.rdbuf()->sgetc();--w || s.size()==0;ch=i.rdbuf()->snextc()){
		if(T::eq_int_type(T::eof(), ch)){
			st|=std::ios_base::eofbit;
			break;
		}
		if(std::use_facet<std::ctype<E> >(i.getloc()).is(std::ctype<E>::space, T::to_char_type(ch))){
			i.rdbuf()->sbumpc();
			break;
		}
		s.append(1, T::to_char_type(ch));
		if(s.max_size()<=s.size()){
			i.rdbuf()->sbumpc();
			break;
		}
	}
	if(s.size()==0)st|=std::ios_base::failbit;
	i.setstate(st);
	return i;
}
template <class E,class T,class A>
std::basic_istream<E,T> & getline(std::basic_istream<E,T>& i, basic_string<E,T,A>& s, E delim){
	std::size_t w=i.width();
	std::ios_base::iostate st = std::ios_base::goodbit;
	s.erase();
	//s.reserve(w);
	for(T::int_type ch=i.rdbuf()->sgetc();--w || s.size()==0;ch=i.rdbuf()->snextc()){
		if(T::eq_int_type(T::eof(), ch)){
			st|=std::ios_base::eofbit;
			break;
		}
		if(T::to_char_type(ch)==delim){
			i.rdbuf()->sbumpc();
			break;
		}
		s.append(1, T::to_char_type(ch));
		if(s.max_size()<=s.size()){
			i.rdbuf()->sbumpc();
			break;
		}
	}
	if(s.size()==0)st|=std::ios_base::failbit;
	i.setstate(st);
	return i;
}
//*/		// streamւ̑ΉIB


template <class E,class T,class A>
std::basic_istream<E,T> & getline(std::basic_istream<E,T>& i, basic_string<E,T,A>& s){
	return getline(i, s, i.widen('\n'));
}

template<class E,class T, class A>
void swap(const basic_string<E,T,A> & lhs, const basic_string<E,T,A> & rhs){
	lhs.swap(rhs);
}

template<class E,class T,class A>
typename const basic_string<E,T,A>::size_type basic_string<E,T,A>::npos = (typename basic_string<E,T,A>::size_type)-1;
template<class E,class T,class A>
typename const basic_string<E,T,A>::char_type basic_string<E,T,A>::char_null = basic_string<E,T,A>::char_type();

typedef basic_string<char> string;

}	//	end of namespace YTLstring
}	//	end of namespace YTL
}	//	end of namespace yaneuraoGameSDK3rd

//	Ȃ[ȂNX̂ɊۈR(`DL)mܧ

#endif
